/***************************************************************************************************
 *
 *  CTT3. Original versions by VUC++. Version 3.0 by Zeropoint.
 *
 *  $CLASS    CTTMutator
 *  $VERSION  1.01
 *  $AUTHOR   Daan 'Defrost' Scheerens  initial version
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/
class CTTMutator extends Mutator;

simulated function postBeginPlay() {
	local CTTFlagReplacer sn;
	
	if (role == ROLE_SimulatedProxy) {
		// Client side.
	
		setTimer(1.0, false);
	
	} else {
		// Server side.
	
		super.postBeginPlay();
		
		// Check if the current game is a Capture the flag game.
		if (level.game.isA('CTFGame')) {
			
			// It is, so change it to capture the tree!
			sn = spawn(class'CTTFlagReplacer');
		}
		
	}
}

simulated function timer() {
	local CTTXmasTree cttFlag;
		
	foreach allActors(class'CTTXmasTree', cttFlag) {
		spawn(class'CTTXmasTreeLightSpawner', cttFlag);
	}
}

defaultproperties {
	bAlwaysRelevant=true
	bNetTemporary=true
	RemoteRole=ROLE_SimulatedProxy
}
