/***************************************************************************************************
 *
 *  CTT3. Original versions by VUC++. Version 3 by Zeropoint.
 *
 *  $CLASS        CTTMutator
 *  $VERSION      1.01 (1-12-2007 23:53)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  The capture the tree mutator.
 *
 **************************************************************************************************/ 
class CTTMutator extends Mutator;



/***************************************************************************************************
 *
 *  $DESCRIPTION  Called when the Actor is spawned. Spawns the CTTFlagReplacer at the server and
 *                starts the timer at the client.
 *  $OVERRIDE
 *
 **************************************************************************************************/
simulated function postBeginPlay() {
	local CTTFlagReplacer sn;
	
	if (role == ROLE_SimulatedProxy) {
		// Client side.
	
		setTimer(1.0, false);
	
	} else {
		// Server side.
	
		super.postBeginPlay();
		
		// Check if the current game is a Capture the flag game.
		if (level.game.isA('CTFGame')) {
			
			// It is, so change it to capture the tree!
			sn = spawn(class'CTTFlagReplacer');
		}
		
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Called when the timer ticks. Spawns the an CTTXmasTreeLightSpawner for each tree.
 *  $OVERRIDE
 *
 **************************************************************************************************/
simulated function timer() {
	local CTTXmasTree cttFlag;
		
	foreach allActors(class'CTTXmasTree', cttFlag) {
		spawn(class'CTTXmasTreeLightSpawner', cttFlag);
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
	bAlwaysRelevant=true
	bNetTemporary=true
	RemoteRole=ROLE_SimulatedProxy
}
