/***************************************************************************************************
 *
 *  CTT3. Original versions by VUC++. Version 3 by Zeropoint.
 *
 *  $CLASS        CTTXmasTreeLight
 *  $VERSION      1.01 (14-12-2007 12:51)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  Xmas tree light.
 *
 **************************************************************************************************/
class CTTXmasTreeLight extends AnimSpriteEffect;

#exec texture import name=XMLight1_a00 file="Resources\XMLight1_a00.pcx" mips=off flags=2
#exec texture import name=XMLight1_a01 file="Resources\XMLight1_a01.pcx" mips=off flags=2
#exec texture import name=XMLight1_a02 file="Resources\XMLight1_a02.pcx" mips=off flags=2
#exec texture import name=XMLight1_a03 file="Resources\XMLight1_a03.pcx" mips=off flags=2
#exec texture import name=XMLight1_a04 file="Resources\XMLight1_a04.pcx" mips=off flags=2
#exec texture import name=XMLight1_a05 file="Resources\XMLight1_a05.pcx" mips=off flags=2
#exec texture import name=XMLight1_a04 file="Resources\XMLight1_a06.pcx" mips=off flags=2
#exec texture import name=XMLight1_a05 file="Resources\XMLight1_a07.pcx" mips=off flags=2

const minDrawScale = 0.1;     // Minimum draw scale.
const maxDrawScale = 0.6;     // Maximum draw scale.



/***************************************************************************************************
 *
 *  $DESCRIPTION  Called when the Actor is spawned. Gives the light a random draw scale.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function postBeginPlay() {
	super.postBeginPlay();
	drawScale = fRand() * (maxDrawScale - minDrawScale) + minDrawScale;
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
    RemoteRole=ROLE_None
    LifeSpan=0.50
    DrawType=DT_SpriteAnimOnce
    Style=STY_Translucent
    Texture=Texture'XMLight1_a00'
    DrawScale=0.50
    LightType=LT_Steady
    LightRadius=3
    LightHue=0
    LightSaturation=255
    LightBrightness=255
    bCorona=True
}

