/***************************************************************************************************
 *
 *  CTT3. Original versions by VUC++. Version 3 by Zeropoint.
 *
 *  $CLASS        CTTXmasTreeLightSpawner
 *  $VERSION      1.01 (2-12-2007 0:39)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  Class that makes the lights of a xmas tree blink.
 *
 **************************************************************************************************/ 
class CTTXmasTreeLightSpawner extends Info;

const lowDetailLightsPerTick = 1;
const normalDetailLightsPerTick = 2;
const highDetailLightsPerTick = 3;



/***************************************************************************************************
 *
 *  $DESCRIPTION  Called when the Actor is spawned. Sets the timer and gets the PlayerPawn of the
 *                local client.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function postBeginPlay() {
	local PlayerPawn p;
	
	if (owner == none || !owner.isA('CTTXmasTree')) {
		destroy();
	} else {
		setTimer(0.05, true);
		
		foreach allActors(class'PlayerPawn', p) {
			if (Viewport(p.player) != none) {
				CTTXmasTree(owner).localPlayer = p;
				break;
			}
		}
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Timer tick. Makes the tree blink.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function timer() {
	local byte index;
	local byte numLights;
	
	if (level.bDropDetail) {
		numLights = lowDetailLightsPerTick;
	} else if (level.bHighDetailMode) {
		numLights = normalDetailLightsPerTick;
	} else {
		numLights = highDetailLightsPerTick;
	}
	
	for (index = 0; index < numLights; index++) {
		CTTXmasTree(owner).blink();
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
    bNetTemporary=True
    RemoteRole=ROLE_None
}