/***************************************************************************************************
 *
 *  IGSRVEXT. IG Generation 3 server extension by Zeropoint.
 *
 *  $CLASS        IGSXClient
 *  $VERSION      1.00 (8-12-2007 14:13)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  IG Server extension pack client controller class. This class is the base of the
 *                clientside support for the extension plugin.
 *
 **************************************************************************************************/
class IGSXClient extends NexgenClientController;



/***************************************************************************************************
 *
 *  $DESCRIPTION  Modifies the setup of the Nexgen remote control panel.
 *  $OVERRIDE
 *
 **************************************************************************************************/
simulated function setupControlPanel() {
	local SmartCTFPlayerReplicationInfo pri;
	
	// Enable SmartCTF scoreboard by default.
	foreach allActors(class'SmartCTFPlayerReplicationInfo', pri) {
		if (pri.owner == client.player.playerReplicationInfo) {
			pri.bViewingStats = true;
			break;
		}
	}

}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
	ctrlID="IGClientExtension"
}