/***************************************************************************************************
 *
 *  NSC. Nexgen Server Controller by Zeropoint.
 *
 *  $CLASS        NexgenLang
 *  $VERSION      1.33 (16-6-2008 19:45)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  Localization support class. Provides the language dependant functionality of the
 *                Nexgen server controller.
 *
 **************************************************************************************************/
class NexgenLang extends Info;

var localized string dateFormatStr;               // Format of date strings.

var localized string defaultLogFileNameFormat;    // Default format for log file names.
var localized string defaultLogFileTimeStampFormat;    // Default format for timestamps in log files.
var localized string longDateTimeFormat;          // Format of long date and time strings.

var localized string startingControllerMsg;       // Message logged if the server controller is starting.
var localized string noDedicatedServerMsg;        // Indicates the server isn't dedicated.
var localized string compatibilityModeMsg;        // Compatibility mode for a specific mutator is enabled.
var localized string autoInstallMsg;              // Automatically installing Nexgen at first run.
var localized string autoUpdateMsg;               // Automatically updating config to current version.
var localized string invalidConfigMsg;            // Configuration was invalid and has been repaired.
var localized string attrServerIDMsg;             // Server ID code attribute & value message.
var localized string nexgenBootMsg;               // Message logged when the Nexgen boot is activated.
var localized string nexgenMapLoadFailMsg;        // Warning shown in case Nexgen was not able to
                                                  // the specified map.
var localized string nexgenBootFailMsg;           // The message to log when the Nexgen boot failed.
var localized string execCommandMsg;              // Text to write to the log when a command is executed.
var localized string bootLevelSwitchMsg;          // Message logged when switching to another map.
var localized string nexgenActiveMsg;             // Logged when the Nexgen controller is operational.
var localized string logFileCreateFailed;         // Message in case the the log file could not be created.
var localized string logFileCreated;              // Log file started message.

var localized string loadingPluginMsg;            // Text written to the log if a plugin is loaded.
var localized string initFailedMsg;               // Plugin failed to initialize.
var localized string regFailedMsg;                // Failed to register plugin at the controller.

var localized string noHUDReplacementClassMsg;    // Unable to find a HUD replacement class.

var localized string loginRequestMsg;             // Login request message written to the log.
var localized string attrClientIPMsg;             // IP address used by the client.
var localized string attrClientIDMsg;             // Client ID of the client that wants to login.
var localized string attrPasswordMsg;             // The password entered by the client.
var localized string duplicateIDMsg;              // Another player already is using the same ID.
var localized string bannedMsg;                   // Player is banned or kicked from the server.
var localized string invalidPassMsg;              // Invalid password entered.
var localized string serverCapacityMsg;           // Servers max capacity has been reached.
var localized string noPlayRightMsg;              // Client has no playing rights.
var localized string loginAcceptedMsg;            // Login request has been accepted.
var localized string loginRejectedMsg;            // Login request has been rejected.

var localized string gameStartedMsg;              // Event message when the game has started.
var localized string gameEndedMsg;                // Event message when the game has ended.
var localized string serverTravelDetectedMsg;     // Message indicating that a server travel has been detected.
var localized string serverTravelFailedMsg;       // In case the pending server travel failed.

var localized string playerJoinMsg;               // When a new player joins the game (and is accepted).
var localized string playerLeaveMsg;              // When a player leaves the game.
var localized string playerNameChangeMsg;         // When a player has changed his/her name.
var localized string playerLeaveLogMsg;           // Written to log when a player leaves.
var localized string teamSwitchFailMsg;           // When a team switch has been rejected.
var localized string teamsLockedMsg;              // Message indicating that the teams are locked.
var localized string nameChangeFailMsg;           // Shown when a player failed to change his/her name.
var localized string nameChangeDisabled;          // Name change failed because name change is disabled.

var localized string invalidCommandMsg;           // Player tried to execute an invalid command.
var localized string commandFailedMsg;            // Message displayed when a command failed.
var localized string internalErrorMsg;            // An internal error has occurred.
var localized string teamSwitchFailedMsg;         // Failed to execute a team switch command.
var localized string specTeamSwitchMsg;           // A spectator tried to teamswitch.
var localized string teamSwitchDisabledMsg;       // Team switching is disabled.
var localized string playerTeamSwitchDisabledMsg; // Player is not allowed to switch team.
var localized string invalidTeamMsg;              // Tried to switch to a nonexistent team.
var localized string sameTeamMsg;                 // Can't switch to the same team.
var localized string noSpecsAllowedMsg;           // The server has no spectator slots.
var localized string noMoreSpecSlotsMsg;          // All spectator slots are taken.
var localized string noPlayingRightsMsg;          // Client has no playing rights.
var localized string noMorePlayerSlotsMsg;        // No more player slots available.
var localized string teamBalanceFailedMsg;        // Team balance command failed to execute.
var localized string notATeamGameMsg;             // The current game is not a team game.
var localized string teamBalanceDisabledMsg;      // The team balance command is disabled.
var localized string teamsAlreadyBalancedMsg;     // Teams are already balanced.
var localized string balanceMsg;                  // Successfully executed team balance message.
var localized string launchMsg;                   // Message displayed when the game has been launched.
var localized string playerReadyMsg;              // Message shown when a player has send a ready signal.

var localized string teamName[4];                 // Team names.

var localized string forcedEndMsg;                //

var localized string rootAdminTitle;              //
var localized string specTitle;                   //

var localized string deathPreventedMsg;           //

var localized string mutedReminderMsg;            //

var localized string accountTypeNameStr;          //

var localized string teamKillAttemptMsg;          //

var localized string controllerSystemLogTag;      //
var localized string eventLogTag;                 //
var localized string messageLogTag;               //
var localized string chatMessageLogTag;           //
var localized string teamSayMessageLogTag;        //
var localized string privateMessageLogTag;        //
var localized string adminActionLogTag;           //

var localized string allowedToPlayRightDesc;      //
var localized string vipSlotAccessRightDesc;      //
var localized string adminSlotAccessRightDesc;    //
var localized string needsNoPWRightDesc;          //
var localized string canBeIdleRightDesc;          //
var localized string matchAdminRightDesc;         //
var localized string matchSetRightDesc;           //
var localized string moderatorRightDesc;          //
var localized string banOpRightDesc;              //
var localized string accountMngrRightDesc;        //
var localized string serverAdminRightDesc;        //
var localized string canBanAccountsRightDesc;     //
var localized string hiddenAdminRightDesc;        //

var localized string launchGameMsg;               //
var localized string adminLaunchGameMsg;          //
var localized string tournamentLaunchGameMsg;     //

var localized string serverCrashedClientMsg;      //
var localized string bootFailedClientMsg;         //

var localized string welcomeMsg;                  //

// Control panel actions.
var localized string settingsSavedMsg;            //

var localized string receivedPMMsg;               //

var localized string receivedPWMsg;               //

var localized string passwordSendMsg;             //

var localized string noBanAccountRightMsg;        //

var localized string adminTeamSwitchMsg;          //
var localized string adminPauseGameMsg;           //
var localized string adminResumeGameMsg;          //
var localized string adminRestartGameMsg;         //
var localized string adminStopGameMsg;            //
var localized string adminPlayerTeamSwitchDisableMsg;  //
var localized string adminPlayerTeamSwitchEnableMsg;   //
var localized string adminReconnectAsPlayerMsg;   //
var localized string adminReconnectAsSpecMsg;     //
var localized string adminSendToURLMsg;           //
var localized string adminDisableTeamSwitchMsg;   //
var localized string adminEnableTeamSwitchMsg;    //
var localized string adminDisableTeamBalanceMsg;  //
var localized string adminEnableTeamBalanceMsg;   //
var localized string adminLockTeamsMsg;           //
var localized string adminUnlockTeamsMsg;         //
var localized string adminAddBanMsg;              //
var localized string adminDeleteBanMsg;           //
var localized string adminEnableMatchModeMsg;     //
var localized string adminDisableMatchModeMsg;    //
var localized string adminMutePlayerMsg;          //
var localized string adminUnmutePlayerMsg;        //
var localized string adminSetNameMsg;             //
var localized string adminKickPlayerMsg;          //
var localized string adminBanPlayerMsg;           //
var localized string adminMuteAllMsg;             //
var localized string adminUnmuteAllMsg;           //
var localized string adminEnableNameChangeMsg;    //
var localized string adminDisableNameChangeMsg;   //
var localized string adminRebootServerMsg;        //
var localized string adminEnableTournamentModeMsg;     //
var localized string adminDisableTournamentModeMsg;    //

var localized string adminAddAccountType;         //
var localized string adminUpdateAccountType;      //
var localized string adminRemoveAccountType;      //
var localized string adminMoveAccountType;        //
var localized string adminRemoveAccount;          //
var localized string adminUpdateAccount;          //
var localized string adminAddAccount;             //
var localized string adminUpdateBanMsg;           //
var localized string adminUpdateBootControl;      //
var localized string adminSeparateByTag;          //
var localized string adminUpdateMatchSettings;    //
var localized string adminUpdateIgnoredWeaponList;     //
var localized string adminUpdateHUDReplacementList;    //
var localized string adminUpdateGlobalServerSettings;  //

var localized string invalidPasswordMsg;          //
var localized string adminLoginMsg;               //

// HUD.
var localized string autoReconnectAlert;          //
var localized string reconnectingAlert;           //
var localized string rebootAlert;                 //
var localized string idleAlert;                   //
	
var localized string waitingState;                //
var localized string waitingStateUnknownTime;     //
var localized string readyState;                  //
var localized string readySignalWaitState;        //
var localized string startingState;               //
var localized string onlineState;                 //
var localized string offlineState;                //
var localized string offlineStateRCN;             //
var localized string endedState;                  //
var localized string pausedState;                 //
var localized string loginState;                  //
var localized string idleState;                   //
var localized string mutedState;                  //
var localized string protectedState;              //
var localized string deadState;                   //
var localized string matchState;                  //

// GUI.
var localized string clientTabTxt;                //
var localized string homeTabTxt;                  //
var localized string settingsTabTxt;              //
var localized string privateMessageTabTxt;        //
var localized string gameTabTxt;                  //
var localized string playersTabTxt;               //
var localized string moderatorTabTxt;             //
var localized string matchControlTabTxt;          //
var localized string matchSetupTabTxt;            //
var localized string serverTabTxt;                //
var localized string infoTabTxt;                  //
var localized string banControlTabTxt;            //
var localized string accountsTabTxt;              //
var localized string accountTypesTabTxt;          //
var localized string bootTabTxt;                  //
var localized string pluginsTabTxt;               //
var localized string aboutTabTxt;                 //

var localized string welcomeTxt;                  //
var localized string rightsOverviewTxt;           //
var localized string rightNotDefinedTxt;          //
var localized string teamBalanceTxt;              //
var localized string redTeamTxt;                  //
var localized string blueTeamTxt;                 //
var localized string greenTeamTxt;                //
var localized string goldTeamTxt;                 //
var localized string playTxt;                     //
var localized string spectateTxt;                 //
var localized string reconnectTxt;                //
var localized string disconnectTxt;               //
var localized string exitTxt;                     //
var localized string mapVoteTxt;                  //
var localized string startTxt;                    //
var localized string loginTxt;                    //

var localized string serverNameTxt;               //
var localized string shortServerNameTxt;          //
var localized string MOTDLineTxt;                 //
var localized string adminNameTxt;                //
var localized string adminEmailTxt;               //
var localized string serverPasswordTxt;           //
var localized string adminPasswordTxt;            //
var localized string playerSlotsTxt;              //
var localized string vipSlotsTxt;                 //
var localized string adminSlotsTxt;               //
var localized string specSlotsTxt;                //
var localized string advertiseTxt;                //
var localized string resetTxt;                    //
var localized string saveTxt;                     //

var localized string keyBindsTxt;                 //
var localized string balanceBindTxt;              //
var localized string switchRedBindTxt;            //
var localized string switchBlueBindTxt;           //
var localized string switchGreenBindTxt;          //
var localized string switchGoldBindTxt;           //
var localized string suicideBindTxt;              //
var localized string openMapVoteBindTxt;          //
var localized string openCPBindTxt;               //
var localized string pauseGameBindTxt;            //
var localized string UISettingsTxt;               //
var localized string enableMsgHUDTxt;             //
var localized string msgFlashEffectTxt;           //
var localized string showPlayerLocationTxt;       //
var localized string pmSoundTxt;                  //
var localized string miscSettingsTxt;             //
var localized string autoSSNormalGameTxt;         //
var localized string autoSSMatchTxt;              //

var localized string playerListTxt;               //
var localized string blockedListTxt;              //
var localized string blockToggleTxt;              //
var localized string blockAllPMsTxt;              //
var localized string messageTxt;                  //
var localized string sendNormalPMTxt;             //
var localized string sendWindowedPMTxt;           //
var localized string historyTxt;                  //
var localized string blockMsg;                    //
var localized string unblockMsg;                  //
var localized string sendMsgTxt;                  //
var localized string receivedMsgTxt;              //

var localized string accountNameTxt;              //
var localized string accountTitleTxt;             //
var localized string passwordTxt;                 //
var localized string addAccountTypeTxt;           //
var localized string delAccountTypeTxt;           //
var localized string moveUpTxt;                   //
var localized string moveDownTxt;                 //

var localized string userNameTxt;                 //
var localized string accountTypeTxt;              //
var localized string userTitleTxt;                //
var localized string onlineTxt;                   //
var localized string offlineTxt;                  //
var localized string updateTxt;                   //
var localized string addTxt;                      //
var localized string deleteTxt;                   //
var localized string customAccountTxt;            //

var localized string switchToTeamTxt;             //
var localized string sendToURLTxt;                //
var localized string reconnectAsPlayerTxt;        //
var localized string reconnectAsSpecTxt;          //
var localized string disableTeamSwitchTxt;        //
var localized string pauseGameTxt;                //
var localized string endGameTxt;                  //
var localized string restartGameTxt;              //
var localized string allowTeamSwitchTxt;          //
var localized string allowTeamBalanceTxt;         //
var localized string lockTeamsTxt;                //
var localized string tournamentModeTxt;           //

var localized string playerNameTxt;               //
var localized string banReasonTxt;                //
var localized string banPeriodTxt;                //
var localized string banForeverTxt;               //
var localized string banMatchesTxt;               //
var localized string banDaysTxt;                  //
var localized string banUntilDateTxt;             //
var localized string ipAddressesTxt;              //
var localized string clientIDsTxt;                //
var localized string addBanTxt;                   //
var localized string updateBanTxt;                //
var localized string delBanTxt;                   //
var localized string removeTxt;                   //

var localized string enableBootCtrlTxt;           //
var localized string restartOnLastGameTxt;        //
var localized string inclMutatorsTxt;             //
var localized string exclMutatorsTxt;             //
var localized string bootCmdLineTxt;              //
var localized string gameTypeTxt;                 //
var localized string mapPrefixTxt;                //
var localized string extraCmdLineOptTxt;          //
var localized string preSwitchCommandsTxt;        //
var localized string rebootTxt;                   //

var localized string administratorTxt;            //
var localized string contactAddrTxt;              //
var localized string msgOfTheDayTxt;              //
var localized string serverIDTxt;                 //
var localized string statisticsTxt;               //
var localized string totalGamesTxt;               //
var localized string totalFragsTxt;               //
var localized string totalDeathsTxt;              //
var localized string totalFlagsTxt;               //
var localized string bestPlayersTxt;              //
var localized string FPHTxt;                      //
var localized string recordSetTxt;                //

var localized string timeLimitTxt;                //
var localized string scoreLimitTxt;               //
var localized string teamScoreLimitTxt;           //
var localized string gameSpeedTxt;                //
var localized string teamSwitchEnabledTxt;        //
var localized string teamBalanceEnabledTxt;       //
var localized string teamsLockedTxt;              //
var localized string nameChangeAllowedTxt;        //
var localized string mutatorsTxt;                 //
var localized string levelTxt;                    //
var localized string fileTxt;                     //
var localized string titleTxt;                    //
var localized string authorTxt;                   //
var localized string idealPlayerCountTxt;         //

var localized string matchSettingsTxt;            //
var localized string matchNumOfGamesTxt;          //
var localized string matchCurrGameNumTxt;         //
var localized string matchSpecNoPassTxt;          //
var localized string matchMuteSpecsTxt;           //
var localized string matchBootControlTxt;         //
var localized string matchAutoLockTeamsTxt;       //
var localized string matchAutoPauseTxt;           //
var localized string matchSeparateByTagTxt;       //
var localized string matchAutoTagSeparateTxt;     //
var localized string matchDoSeparateTxt;          //
var localized string startMatchTxt;               //
var localized string stopMatchTxt;                //
var localized string sendPasswordTxt;             //
var localized string allPlayersTxt;               //

var localized string muteToggleTxt;               //
var localized string setPlayerNameTxt;            //
var localized string kickPlayerTxt;               //
var localized string banPlayerTxt;                //
var localized string muteAllTxt;                  //
var localized string allowNameChangeTxt;          //
var localized string showAdminMessageTxt;         //

var localized string autoUpdateBansTxt;           //
var localized string autoDelExpiredBansTxt;       //
var localized string announceTeamKillsTxt;        //
var localized string enableNexgenMessageHUDTxt;   //
var localized string logEventsTxt;                //
var localized string logMessagesTxt;              //
var localized string logChatMessagesTxt;          //
var localized string LogPrivateMessagesTxt;       //
var localized string defaultAllowTeamSwitchTxt;   //
var localized string defaultAllowTeamBalanceTxt;  //
var localized string defaultAllowNameChangeTxt;   //
var localized string gameWaitTimeTxt;             //
var localized string gameStartDelayTxt;           //
var localized string autoReconnectTimeTxt;        //
var localized string maxIdleTimeTxt;              //
var localized string maxIdleTimeCPTxt;            //
var localized string spawnProtectTimeTxt;         //
var localized string teamKillDmgProtectTxt;       //
var localized string teamKillPushProtectTxt;      //
var localized string autoDisableMatchTimeTxt;     //

var localized string ignoredWeaponsTxt;           //
var localized string weaponClassTxt;              //
var localized string ignorePrimaryFireTxt;        //
var localized string ignoreAltFireTxt;            //
var localized string hudReplaceClassesTxt;        //
var localized string originalHUDClassTxt;         //
var localized string replacementHUDClassTxt;      //
var localized string addNewItemTxt;               //



/***************************************************************************************************
 *
 *  $DESCRIPTION  Returns the name of the team specified by the given number.
 *  $PARAM        team  Number of the team whose name is to be returned.
 *  $RETURN       The name of the team, or ? if an invalid team is specified.
 *
 **************************************************************************************************/
static function string getTeamName(int team) {
	if (0 <= team && team < arrayCount(default.teamName)) {
		return default.teamName[team];
	} else {
		return "?";
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Formats the given string by inserting the specified strings into the proper
 *                positions. The positions are indicated by the "%n" tags, where n is number of the
 *                string to insert.
 *  $PARAM        source  The string that is to be formatted.
 *  $PARAM        str1    String number 1 to insert.
 *  $PARAM        str2    String number 2 to insert.
 *  $PARAM        str3    String number 3 to insert.
 *  $PARAM        str4    String number 4 to insert.
 *  $RETURN       The formatted string.
 *
 **************************************************************************************************/
static function string format(string source, optional coerce string str1, optional coerce string str2,
                              optional coerce string str3, optional coerce string str4) {
	return class'NexgenUtil'.static.format(source, str1, str2, str3, str4);
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Converts a ban period string into a human readable format.
 *  $PARAM        banPeriodStr  The string describing the ban period.
 *  $RETURN       A string describing (in words) how long the ban lasts.
 *
 **************************************************************************************************/
function string getBanPeriodDescription(string banPeriodStr) {
	local string description;
	
	if (banPeriodStr == "") {
		description = "forever";
	} else if (left(banPeriodStr, 1) ~= "M") {
		description = "for" @ mid(banPeriodStr, 1) @ "matches";
	} else if (left(banPeriodStr, 1) ~= "U") {
		description = "until" @ getLocalizedDateStr(mid(banPeriodStr, 1));
	} else {
		description = "forever";
	}
	
	return description;
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Returns a compact date description string for the specified date.
 *  $PARAM        year    Year of the specified date.
 *  $PARAM        month   Month of the specified date.
 *  $PARAM        day     Day of the specified date.
 *  $PARAM        hour    Hour of the specified date.
 *  $PARAM        minute  Minute of the specified date.
 *  $REQUIRE      (1 <= month && moth <= 12) && (1 <= day && day <= 31) &&
 *                (0 <= hour && hour <= 23) && (0 <= minute && minute <= 59)
 *  $RETURN       The date description string for the given date.
 *
 **************************************************************************************************/
static function string getCompactDateStr(int year, int month, int day, int hour, int minute) {
	return class'NexgenUtil'.static.lfill(day, 2, "0") $ "/" $
	       class'NexgenUtil'.static.lfill(month, 2, "0") $ "/" $
	       class'NexgenUtil'.static.lfill(year, 4, "0") $ " " $
	       class'NexgenUtil'.static.lfill(hour, 2, "0") $ ":" $
	       class'NexgenUtil'.static.lfill(minute, 2, "0");
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Parses the given date string.
 *  $PARAM        dateStr  The date string to parse.
 *  $PARAM        year     Year of the specified date.
 *  $PARAM        month    Month of the specified date.
 *  $PARAM        day      Day of the specified date.
 *  $PARAM        hour     Hour of the specified date.
 *  $PARAM        minute   Minute of the specified date.
 *  $REQUIRE      'dateStr follows dateFormatStr'
 *  $RETURN       True if the specified date string was valid, false if not. When false is returned
 *                the outcome (the date) should be ignored.
 *
 **************************************************************************************************/
static function bool parseDate(string dateStr, out int year, out int month, out int day,
                               out int hour, out int minute) {
	local bool bValid;
	local string remaining;
	local int index;
	
	bValid = true;
	remaining = class'NexgenUtil'.static.trim(dateStr);
	
	// Parse day.
	index = instr(remaining, "/");
	if (index >= 0) {
		day = int(left(remaining, index));
		remaining = mid(remaining, index + 1);
	} else {
		bValid = false;
	}
	
	// Parse month.
	if (bValid) {
		index = instr(remaining, "/");
		if (index >= 0) {
			month = int(left(remaining, index));
			remaining = class'NexgenUtil'.static.trim(mid(remaining, index + 1));
		} else {
			bValid = false;
		}
	}
	
	// Parse year.
	if (bValid) {
		index = instr(remaining, " ");
		if (index >= 0) {
			year = int(left(remaining, index));
			remaining = mid(remaining, index + 1);
		} else {
			bValid = false;
		}
	}
	
	// Parse hour.
	if (bValid) {
		index = instr(remaining, ":");
		if (index >= 0) {
			hour = int(left(remaining, index));
			remaining = mid(remaining, index + 1);
		} else {
			bValid = false;
		}
	}
	
	// Parse minute.
	if (bValid) {
		minute = int(remaining);
	}
	
	// Return result.
	return bValid;
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Converts the given date string into a localized format.
 *  $PARAM        dateStr  The date string to convert.
 *  $RETURN       The converted date into a localized format.
 *
 **************************************************************************************************/
function string getLocalizedDateStr(string dateStr) {
	local bool bValid;
	local int year, month, day, hour, minute;
	
	bValid = class'NexgenUtil'.static.readDate(dateStr, year, month, day, hour, minute);
	if (bValid) {
		return getCompactDateStr(year, month, day, hour, minute);
	} else {
		return dateStr;
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Converts the given localized date string into a standard format.
 *  $PARAM        dateStr  The date string to convert.
 *  $RETURN       The converted date into a standard format.
 *
 **************************************************************************************************/
function string getDelocalizedDateStr(string dateStr) {
	local bool bValid;
	local int year, month, day, hour, minute;
	
	bValid = parseDate(dateStr, year, month, day, hour, minute);
	if (bValid) {
		return class'NexgenUtil'.static.serializeDate(year, month, day, hour, minute);
	} else {
		return dateStr;
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Returns the current date in the specified format.
 *  $PARAM        The format of the date.
 *  $RETURN       The current date in the the specified format.
 *
 **************************************************************************************************/
function string getCurrentDate(string format) {
	return getDate(format,
	               level.year,
	               level.month,
	               level.day,
	               level.dayOfWeek,
	               level.hour,
	               level.minute,
	               level.second);
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Returns given date in the specified format.
 *  $PARAM        The format of the date.
 *  $RETURN       The given date in the the specified format.
 *
 **************************************************************************************************/
static function string getDate(string format, int year, int month, int day, int dayOfWeek,
                               int hour, int minute, int second) {
	local string dateStr;
	local int value;
	local string strValue;
	
	dateStr = format;
	
	// Year.
	if (instr(dateStr, "%Y") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%Y", class'NexgenUtil'.static.lfill(year, 4, "0"));
	}
	
	if (instr(dateStr, "%y") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%y", class'NexgenUtil'.static.lfill(year, 2, "0", 2));
	}
	
	if (instr(dateStr, "%L") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%L", byte(class'NexgenUtil'.static.isLeapYear(year)));
	}

	// Month.
	if (instr(dateStr, "%m") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%m", class'NexgenUtil'.static.lfill(month, 2, "0"));
	}
	
	if (instr(dateStr, "%n") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%n", month);
	}
	
	if (instr(dateStr, "%F") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%F", getMonthName(month));
	}
	
	if (instr(dateStr, "%M") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%M", getShortMonthName(month));
	}
	
	if (instr(dateStr, "%t") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%t", class'NexgenUtil'.static.daysInMonth(year, month));
	}
	
	// Day.
	if (instr(dateStr, "%d") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%d", class'NexgenUtil'.static.lfill(day, 2, "0"));
	}
	
	if (instr(dateStr, "%j") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%j", day);
	}
	
	if (instr(dateStr, "%w") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%w", dayOfWeek);
	}
	
	if (instr(dateStr, "%N") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%N", (dayOfWeek + 1));
	}
	
	if (instr(dateStr, "%l") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%l", getDayName(dayOfWeek));
	}
	
	if (instr(dateStr, "%D") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%D", getShortDayName(dayOfWeek));
	}
	
	// Hour.
	if (instr(dateStr, "%H") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%H", class'NexgenUtil'.static.lfill(hour, 2, "0"));
	}
	
	if (instr(dateStr, "%h") >= 0) {
		value = hour % 12;
		if (value == 0) value = 12;
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%h", class'NexgenUtil'.static.lfill(value, 2, "0"));
	}
	
	if (instr(dateStr, "%G") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%G", hour);
	}
	
	if (instr(dateStr, "%g") >= 0) {
		value = hour % 12;
		if (value == 0) value = 12;
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%g", value);
	}
	
	if (instr(dateStr, "%a") >= 0) {
		if (hour == 0 || hour > 12) {
			strValue = "am";
		} else {
			strValue = "pm";
		}
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%a", strValue);
	}
	
	if (instr(dateStr, "%A") >= 0) {
		if (hour == 0 || hour > 12) {
			strValue = "AM";
		} else {
			strValue = "PM";
		}
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%A", strValue);
	}
	
	// Minute.
	if (instr(dateStr, "%i") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%i", class'NexgenUtil'.static.lfill(minute, 2, "0"));
	}
	
	// Second.
	if (instr(dateStr, "%s") >= 0) {
		dateStr = class'NexgenUtil'.static.replace(dateStr, "%s", class'NexgenUtil'.static.lfill(second, 2, "0"));
	}
	
	return dateStr;
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Retrieves the full textual representation of the specified day of the week.
 *  $PARAM        day  The number of day of the week whose name is to be retrieved.
 *  $REQUIRE      0 <= day && day <= 6
 *  $RETURN       A full textual representation of the day of the week.
 *  $ENSURE       result != ""
 *
 **************************************************************************************************/
static function string getDayName(int day) {
	switch (day) {
		case  0: return "Sunday";
		case  1: return "Monday";
		case  2: return "Tuesday";
		case  3: return "Wednesday";
		case  4: return "Thursday";
		case  5: return "Friday";
		case  6: return "Saturday";
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Retrieves the short textual representation of the specified day of the week, three
 *                letters.
 *  $PARAM        day  The number of day of the week whose name is to be retrieved.
 *  $REQUIRE      0 <= day && day <= 6
 *  $RETURN       A short textual representation of the day of the week.
 *  $ENSURE       len(result) == 3
 *
 **************************************************************************************************/
static function string getShortDayName(int day) {
	switch (day) {
		case  0: return "Sun";
		case  1: return "Mon";
		case  2: return "Tue";
		case  3: return "Wed";
		case  4: return "Thu";
		case  5: return "Fri";
		case  6: return "Sat";
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Retrieves the full textual representation of the specified month, such as January
 *                or March.
 *  $PARAM        month  The number of the month whose name is to be retrieved.
 *  $REQUIRE      1 <= month && month <= 12
 *  $RETURN       A full textual representation of the specified month.
 *  $ENSURE       result != ""
 *
 **************************************************************************************************/
static function string getMonthName(int month) {
	switch (month) {
		case  1: return "January";
		case  2: return "February";
		case  3: return "March";
		case  4: return "April";
		case  5: return "May";
		case  6: return "June";
		case  7: return "July";
		case  8: return "August";
		case  9: return "September";
		case 10: return "October";
		case 11: return "November";
		case 12: return "December";
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Retrieves the short textual representation of the specified month, three letters.
 *  $PARAM        month  The number of the month whose short name is to be retrieved.
 *  $REQUIRE      1 <= month && month <= 12
 *  $RETURN       A short textual representation of the specified month.
 *  $ENSURE       len(result) == 3
 *
 **************************************************************************************************/
static function string getShortMonthName(int month) {
	switch (month) {
		case  1: return "Jan";
		case  2: return "Feb";
		case  3: return "Mar";
		case  4: return "Apr";
		case  5: return "May";
		case  6: return "Jun";
		case  7: return "Jul";
		case  8: return "Aug";
		case  9: return "Sep";
		case 10: return "Oct";
		case 11: return "Nov";
		case 12: return "Dec";
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
	dateFormatStr="dd/mm/yyyy hh:mm"
	
	defaultLogFileNameFormat="nsc_%Y_%m_%d_%H_%i_%s"
	defaultLogFileTimeStampFormat="[%d/%m/%Y %H:%i:%s]"
	longDateTimeFormat="%l, %F %j, %Y, %H:%i:%s"
	
	startingControllerMsg="Starting Nexgen Server Controller..."
	noDedicatedServerMsg="Failed, your server should be dedicated."
	compatibilityModeMsg="%1 has been detected, entering compatibility mode..."
	autoInstallMsg="First time run, executing default installation..."
	autoUpdateMsg="Updating Nexgen configuration to version %1..."
	invalidConfigMsg="Configuration file has been automatically repaired."
	attrServerIDMsg="ServerID = %1"
	nexgenBootMsg="Server crash/reboot detected, executing Nexgen boot sequence..."
	nexgenMapLoadFailMsg="Warning, attempt to load %1 has failed!"
	nexgenBootFailMsg="Nexgen boot sequence failed, resuming to normal mode."
	execCommandMsg="EXEC %1"
	bootLevelSwitchMsg="Restarting server on %1"
	nexgenActiveMsg="Nexgen Server Controller is active."
	logFileCreateFailed="Failed to create log file: %1"
	logFileCreated="Log file created, logging to: %1"
	
	loadingPluginMsg="Loading %1 %2..."
	initFailedMsg="Failed to initialize %1, destroying..."
	regFailedMsg="Failed to register %1, destroying..."
	
	noHUDReplacementClassMsg="No replacement class found for %1"
	
	loginRequestMsg="Login request for %1"
	attrClientIPMsg="IP       = %1"
	attrClientIDMsg="ClientID = %1"
	attrPasswordMsg="Password = %1"
	duplicateIDMsg="Client ID already in use."
	bannedMsg="Kicked/banned from the server."
	invalidPassMsg="Invalid password."
	serverCapacityMsg="Server is full."
	noPlayRightMsg="No playing rights."
	loginAcceptedMsg="Login accepted."
	loginRejectedMsg="Login denied. Reason: %1"
	
	gameStartedMsg="The game has started."
	gameEndedMsg="The game has ended after %1 sec."
	serverTravelDetectedMsg="Pending server travel: %1"
	serverTravelFailedMsg="The server travel to %1 has failed."
			
	playerJoinMsg="<C07>(+%2) %1"
	playerLeaveMsg="<C04>(-%2) %1"
	playerNameChangeMsg="%1 has changed his/her name to %2."
	playerLeaveLogMsg="%1 has left the server."
	teamSwitchFailMsg="Failed to switch team, %1."
	teamsLockedMsg="the teams are locked"
	nameChangeFailMsg="Failed to change name, %1."
	nameChangeDisabled="name change has been disabled"
	
	invalidCommandMsg="Invalid Nexgen command or parameters."
	commandFailedMsg="Failed to execute command, %1."
	internalErrorMsg="internal error"
	teamSwitchFailedMsg="Failed to switch team, %1."
	specTeamSwitchMsg="spectators can't switch team"
	teamSwitchDisabledMsg="team switching is disabled on this server"
	teamsLockedMsg="the teams are locked"
	playerTeamSwitchDisabledMsg="you are not allowed to change from team"
	invalidTeamMsg="team doesn't exist"
	sameTeamMsg="you are already on %1"
	noSpecsAllowedMsg="this server doesn't allow spectators"
	noMoreSpecSlotsMsg="all spectator slots are taken"
	noPlayingRightsMsg="you do not have playing rights on this server"
	noMorePlayerSlotsMsg="all player slots are taken"
	teamBalanceFailedMsg="Failed to balance teams, %1."
	notATeamGameMsg="this command is only available for team games"
	teamBalanceDisabledMsg="team balancing is disabled"
	teamsAlreadyBalancedMsg="the teams are already balanced"
	balanceMsg="%1 has balanced the teams."
	launchMsg="<C07>%1 has started the game."
	playerReadyMsg="<C07>%1 is READY!"

	teamName(0)="red"
	teamName(1)="blue"
	teamName(2)="green"
	teamName(3)="yellow"
	
	forcedEndMsg="The game has been forced to an end."
	
	rootAdminTitle="Root Admin"
	specTitle="Spectator"
	
	deathPreventedMsg="The server has prevented you from dying."
	
	mutedReminderMsg="<C07>Unable to send message, you are muted."
	
	accountTypeNameStr="Account type %1"
	
	teamKillAttemptMsg="%1 had a team kill attempt against %2."
	
	controllerSystemLogTag="[NSC-SYS]"
	eventLogTag="[ EVENT ]"
	messageLogTag="[MESSAGE]"
	chatMessageLogTag="[  SAY  ]"
	teamSayMessageLogTag="[TEAMSAY]"
	privateMessageLogTag="[ PMSAY ]"
	adminActionLogTag="[ ADMIN ]"
	
	allowedToPlayRightDesc="Allowed to play on server."
	vipSlotAccessRightDesc="VIP slot access."
	adminSlotAccessRightDesc="Admin slot access."
	needsNoPWRightDesc="Password immune."
	canBeIdleRightDesc="Can be idle."
	matchAdminRightDesc="Game supervisor."
	matchSetRightDesc="Setup matches."
	moderatorRightDesc="Moderate."
	banOpRightDesc="Ban operator."
	accountMngrRightDesc="Manage accounts."
	serverAdminRightDesc="Server administrator."
	canBanAccountsRightDesc="Ban registered players."
	hiddenAdminRightDesc="Hidden admin."
	
	launchGameMsg="<C07>Press [Fire] to start the game."
	adminLaunchGameMsg="<C07>Please wait, an administrator is going to start the game."
	tournamentLaunchGameMsg="<C07>Waiting for ready signals, press [Fire] to send your ready signal!"
	
	serverCrashedClientMsg="<C00>The server has crashed and has been reloaded!"
	bootFailedClientMsg="<C00>The Nexgen boot sequence has failed, please contact the server administrator!"
	
	welcomeMsg="<C07>Welcome to Nexgen, type !open to open the control panel."
	
	settingsSavedMsg="<C07>New settings have been saved."
	
	receivedPMMsg="<C04>[PM] %3 %1: %2"
	
	receivedPWMsg="<C07>Match password received: '%1'"
	
	passwordSendMsg="<C07>The password has been send."
	
	noBanAccountRightMsg="<C07>You are not allowed to kick or ban players that have an account on this server."
	
	adminTeamSwitchMsg="<C07>%1 has moved %2 to %3."
	adminPauseGameMsg="<C07>%1 has paused the game."
	adminResumeGameMsg="<C07>%1 has resumed the game."
	adminRestartGameMsg="<C07>%1 has restarted the game."
	adminStopGameMsg="<C07>%1 has stopped the game."
	adminPlayerTeamSwitchDisableMsg="<C07>%1 has disabled team switching for %2."
	adminPlayerTeamSwitchEnableMsg="<C07>%1 has enabled team switching for %2."
	adminReconnectAsPlayerMsg="<C07>%1 has reconnected %2 as player."
	adminReconnectAsSpecMsg="<C07>%1 has reconnected %2 as spectator."
	adminSendToURLMsg="<C07>%1 has send %2 to %3."
	adminDisableTeamSwitchMsg="<C07>%1 has disabled team switching."
	adminEnableTeamSwitchMsg="<C07>%1 has enabled team switching."
	adminDisableTeamBalanceMsg="<C07>%1 has disabled team balancing."
	adminEnableTeamBalanceMsg="<C07>%1 has enabled team balancing."
	adminLockTeamsMsg="<C07>%1 has locked the teams."
	adminUnlockTeamsMsg="<C07>%1 has unlocked the teams."
	adminAddBanMsg="<C07>%1 has added %2 to the banlist."
	adminDeleteBanMsg="<C07>%1 has removed %2 from the banlist."
	adminEnableMatchModeMsg="<C07>%1 has set the server in match mode."
	adminDisableMatchModeMsg="<C07>%1 has reset the server in normal mode."
	adminMutePlayerMsg="<C07>%1 has muted %2."
	adminUnmutePlayerMsg="<C07>%1 has unmuted %2."
	adminSetNameMsg="<C07>%1 has renamed %2 to %3."
	adminKickPlayerMsg="<C07>%1 has kicked %2 from the server."
	adminBanPlayerMsg="<C07>%1 has banned %2 from the server."
	adminMuteAllMsg="<C07>%1 has muted all players."
	adminUnmuteAllMsg="<C07>%1 has unmuted all players."
	adminEnableNameChangeMsg="<C07>%1 has allowed nickname changing on the server."
	adminDisableNameChangeMsg="<C07>%1 has disabled nickname changing on the server."
	adminRebootServerMsg="<C07>%1 has rebooted the server."
	adminEnableTournamentModeMsg="<C07>%1 has enabled tournament mode."
	adminDisableTournamentModeMsg="<C07>%1 has disabled tournament mode."
	
	adminAddAccountType="<C07>%1 has created a new account type named: %2."
	adminUpdateAccountType="<C07>%1 has modified the %2 account type."
	adminRemoveAccountType="<C07>%1 has removed the %2 account type."
	adminMoveAccountType="<C07>%1 has repositioned the %2 account type."
	adminRemoveAccount="<C07>%1 has deleted the account %3 for %2."
	adminUpdateAccount="<C07>%1 has modified the account for %2."
	adminAddAccount="<C07>%1 has created a new %3 account for %2."
	adminUpdateBanMsg="<C07>%1 has modified the ban entry for %2."
	adminUpdateBootControl="<C07>%1 has modified the boot control settings."
	adminSeparateByTag="<C07>%1 has separated the players by their tag."
	adminUpdateMatchSettings="<C07>%1 has modified the match settings."
	adminUpdateIgnoredWeaponList="<C07>%1 has modified the spawn protect ignored weapon list."
	adminUpdateHUDReplacementList="<C07>%1 has modified the HUD replacement list."
	adminUpdateGlobalServerSettings="<C07>%1 has modified the basic server settings."
	
	invalidPasswordMsg="<C07>Unable to login as administrator, invalid password."
	adminLoginMsg="<C07>%1 has logged in as %2."
	
	autoReconnectAlert="Connection lost!\\nReconnecting in %1..."
	reconnectingAlert="Connection lost!\\nReconnecting now..."
	rebootAlert="Warning, reboot sequence activated!\\nRebooting server in %1..."
	idleAlert="Idle / camper detection activated!\\nMove or be kicked in %1..."
	
	waitingState="Waiting [%1]"
	waitingStateUnknownTime="Waiting..."
	readyState="Ready..."
	readySignalWaitState="Ready [%1/%2]"
	startingState="Starting [%1]"
	onlineState="Online [%1]"
	offlineState="Offline"
	offlineStateRCN="Offline [%1]"
	endedState="Ended"
	pausedState="Paused"
	loginState="Logging in"
	idleState="Idle [%1]"
	mutedState="Muted"
	protectedState="Protected [%1]"
	deadState="Dead"
	matchState="Match [%1]"

	clientTabTxt="Client"
	homeTabTxt="Home"
	settingsTabTxt="Settings"
	privateMessageTabTxt="Private message"
	gameTabTxt="Game"
	playersTabTxt="Players"
	moderatorTabTxt="Moderator"
	matchControlTabTxt="Match control"
	matchSetupTabTxt="Match setup"
	serverTabTxt="Server"
	infoTabTxt="Info"
	banControlTabTxt="Ban control"
	accountsTabTxt="Accounts"
	accountTypesTabTxt="Account types"
	bootTabTxt="Boot control"
	pluginsTabTxt="Plugins"
	aboutTabTxt="About"
	
	welcomeTxt="Welcome %1, you are logged in as %2."
	rightsOverviewTxt="The following privileges / rights are available to you on this server:"
	rightNotDefinedTxt="Privilege %1 (not defined)."
	teamBalanceTxt="Team balance"
	redTeamTxt="Red"
	blueTeamTxt="Blue"
	greenTeamTxt="Green"
	goldTeamTxt="Yellow"
	playTxt="Play"
	spectateTxt="Spectate"
	reconnectTxt="Reconnect"
	disconnectTxt="Disconnect"
	exitTxt="Exit"
	mapVoteTxt="Open mapvote"
	startTxt="Start game"
	loginTxt="Admin login"
	
	serverNameTxt="Server name:"
	shortServerNameTxt="Short server name:"
	MOTDLineTxt="MOTD line %1"
	adminNameTxt="Admin name:"
	adminEmailTxt="Admin email:"
	serverPasswordTxt="Server password:"
	adminPasswordTxt="Admin password:"
	playerSlotsTxt="Player slots:"
	vipSlotsTxt="VIP slots:"
	adminSlotsTxt="Admin slots:"
	specSlotsTxt="Spectator slots:"
	advertiseTxt="Advertise server:"
	resetTxt="Reset"
	saveTxt="Save"
	
	keyBindsTxt="Keybinds"
	balanceBindTxt="Balance teams"
	switchRedBindTxt="Switch to red"
	switchBlueBindTxt="Switch to blue"
	switchGreenBindTxt="Switch to green"
	switchGoldBindTxt="Switch to yellow"
	suicideBindTxt="Suicide"
	openMapVoteBindTxt="Open map vote"
	openCPBindTxt="Open control panel"
	pauseGameBindTxt="Pause game"
	UISettingsTxt="User interface"
	enableMsgHUDTxt="Enable Nexgen message HUD"
	msgFlashEffectTxt="Enable message 'flash' effect"
	showPlayerLocationTxt="Show player location on teamsay messages"
	pmSoundTxt="Play a sound when a private message arrives"
	miscSettingsTxt="Miscellaneous settings"
	autoSSNormalGameTxt="Auto screenshot at the end of normal games"
	autoSSMatchTxt="Auto screenshot at the end of matches"
	
	playerListTxt="Players"
	blockedListTxt="Blocked"
	blockToggleTxt="Block / Unblock"
	blockAllPMsTxt="Block all private messages"
	messageTxt="Message"
	sendNormalPMTxt="Send normal PM"
	sendWindowedPMTxt="Send windowed PM"
	historyTxt="History"
	blockMsg="%1 has been blocked."
	unblockMsg="%1 has been unblocked."
	sendMsgTxt="Send to %1: %2"
	receivedMsgTxt="%1: %2"
	
	accountNameTxt="Account name"
	accountTitleTxt="Account title"
	passwordTxt="Password"
	addAccountTypeTxt="Add account type"
	delAccountTypeTxt="Delete account type"
	moveUpTxt="Move up"
	moveDownTxt="Move down"
	
	userNameTxt="User name"
	accountTypeTxt="Account type"
	userTitleTxt="User title"
	onlineTxt="Online"
	offlineTxt="Offline"
	updateTxt="Update"
	addTxt="Add"
	deleteTxt="Delete"
	customAccountTxt="<Custom>"
	
	switchToTeamTxt="Switch to %1"
	sendToURLTxt="Send to URL"
	reconnectAsPlayerTxt="Reconnect as player"
	reconnectAsSpecTxt="Reconnect as spectator"
	disableTeamSwitchTxt="(Dis)allow team switch"
	pauseGameTxt="Pause game"
	endGameTxt="End game"
	restartGameTxt="Restart game"
	allowTeamSwitchTxt="Allow team switching"
	allowTeamBalanceTxt="Allow team balancing"
	lockTeamsTxt="Lock the game"
	tournamentModeTxt="Tournament mode"
	
	playerNameTxt="Player name"
	banReasonTxt="Ban/kick reason"
	banPeriodTxt="Ban period"
	banForeverTxt="Forever"
	banMatchesTxt="'x' matches"
	banDaysTxt="'x' days"
	banUntilDateTxt="Until 'date'"
	ipAddressesTxt="IP addresses"
	clientIDsTxt="Client IDs"
	addBanTxt="Create new ban"
	updateBanTxt="Update ban"
	delBanTxt="Remove ban"
	removeTxt="Remove"
	
	enableBootCtrlTxt="Enable Nexgen boot control"
	restartOnLastGameTxt="Restart game on last map"
	inclMutatorsTxt="Mutators used"
	exclMutatorsTxt="Mutators not used"
	bootCmdLineTxt="Server boot command line"
	gameTypeTxt="Game type"
	mapPrefixTxt="Map prefix"
	extraCmdLineOptTxt="Additional command line options"
	preSwitchCommandsTxt="Pre switch server console commands"
	rebootTxt="Reboot"
	
	administratorTxt="Administrator"
	contactAddrTxt="Contact address"
	msgOfTheDayTxt="Message of the day"
	serverIDTxt="Server ID"
	statisticsTxt="Stats"
	totalGamesTxt="Games hosted"
	totalFragsTxt="Total frags"
	totalDeathsTxt="Total deaths"
	totalFlagsTxt="Total caps"
	bestPlayersTxt="Top players"
	FPHTxt="FPH"
	recordSetTxt="Date"
	
	timeLimitTxt="Time limit"
	scoreLimitTxt="Score limit"
	teamScoreLimitTxt="Team score limit"
	gameSpeedTxt="Game speed"
	teamSwitchEnabledTxt="Team switch enabled"
	teamBalanceEnabledTxt="Team balancing enabled"
	teamsLockedTxt="Teams are locked"
	nameChangeAllowedTxt="Name change allowed"
	mutatorsTxt="Mutators"
	levelTxt="Level"
	fileTxt="File"
	titleTxt="Title"
	authorTxt="Author"
	idealPlayerCountTxt="Players"
	
	matchSettingsTxt="Match settings"
	matchNumOfGamesTxt="Number of games"
	matchCurrGameNumTxt="Current game"
	matchSpecNoPassTxt="Allow spectators to enter the game without a password"
	matchMuteSpecsTxt="Mute spectators during the game"
	matchBootControlTxt="Switch back to last map when the server has crashed"
	matchAutoLockTeamsTxt="Automatically lock teams at the beginning of each game"
	matchAutoPauseTxt="Automatically pause the game when a player leaves"
	matchSeparateByTagTxt="Separate players by tag"
	matchAutoTagSeparateTxt="Automatically separate by tag"
	matchDoSeparateTxt="Separate now"
	startMatchTxt="Start match"
	stopMatchTxt="Stop match"
	sendPasswordTxt="Send password"
	allPlayersTxt="<All players>"
	
	muteToggleTxt="(Un)mute"
	setPlayerNameTxt="Set name"
	kickPlayerTxt="Kick"
	banPlayerTxt="Ban"
	muteAllTxt="Mute all players"
	allowNameChangeTxt="Allow players to change their name"
	showAdminMessageTxt="Show message"
	
	autoUpdateBansTxt="Automatically update ban entries"
	autoDelExpiredBansTxt="Automatically remove expired ban entries"
	announceTeamKillsTxt="Broadcast team kill attempts"
	enableNexgenMessageHUDTxt="Enable the Nexgen message HUD"
	logEventsTxt="Write Nexgen events to the server log"
	logMessagesTxt="Write system messages to the server log"
	logChatMessagesTxt="Write chat messages to the server log"
	LogPrivateMessagesTxt="Write private messages to the server log"
	defaultAllowTeamSwitchTxt="Team switch allowed by default"
	defaultAllowTeamBalanceTxt="Team balance allowed by default"
	defaultAllowNameChangeTxt="Name change allowed by default"
	gameWaitTimeTxt="Game wait time (sec)"
	gameStartDelayTxt="Game start delay (sec)"
	autoReconnectTimeTxt="Auto reconnect time (sec)"
	maxIdleTimeTxt="Max idle time (sec)"
	maxIdleTimeCPTxt="Max idle time in control panel (sec)"
	spawnProtectTimeTxt="Spawn protect time (sec)"
	teamKillDmgProtectTxt="Team kill damage protect time (sec)"
	teamKillPushProtectTxt="Team kill push protect time (sec)"
	autoDisableMatchTimeTxt="Auto disable match mode time (min)"
	
	ignoredWeaponsTxt="Weapons ignored by spawn protector."
	weaponClassTxt="Weapon class"
	ignorePrimaryFireTxt="Ignore primary fire"
	ignoreAltFireTxt="Ignore alternate fire"
	hudReplaceClassesTxt="HUD replacement classes."
	originalHUDClassTxt="Original HUD class"
	replacementHUDClassTxt="Replacement HUD class"
	addNewItemTxt="<Add new item>"
}