/***************************************************************************************************
 *
 *  NSC. Nexgen Server Controller by Zeropoint.
 *
 *  $CLASS        NexgenRCPServerSettings2
 *  $VERSION      1.03 (19-1-2008 19:20)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  Nexgen extra server settings control panel page.
 *
 **************************************************************************************************/
class NexgenRCPServerSettings2 extends NexgenPanel;

var NexgenClientCore rpci;                        // Remote Procedure Call interface.

var UWindowSmallButton resetButton;
var UWindowSmallButton saveButton;

var UWindowCheckbox autoUpdateBansInp;
var UWindowCheckbox autoDelExpiredBansInp;
var UWindowCheckbox announceTeamKillsInp;
var UWindowCheckbox enableNexgenMessageHUDInp;
var UWindowCheckbox logEventsInp;
var UWindowCheckbox logMessagesInp;
var UWindowCheckbox logChatMessagesInp;
var UWindowCheckbox LogPrivateMessagesInp;
var UWindowCheckbox defaultAllowTeamSwitchInp;
var UWindowCheckbox defaultAllowTeamBalanceInp;
var UWindowCheckbox defaultAllowNameChangeInp;

var UWindowEditControl gameWaitTimeInp;
var UWindowEditControl gameStartDelayInp;
var UWindowEditControl autoReconnectTimeInp;
var UWindowEditControl maxIdleTimeInp;
var UWindowEditControl maxIdleTimeCPInp;
var UWindowEditControl spawnProtectTimeInp;
var UWindowEditControl teamKillDmgProtectInp;
var UWindowEditControl teamKillPushProtectInp;
var UWindowEditControl autoDisableMatchTimeInp;



/***************************************************************************************************
 *
 *  $DESCRIPTION  Creates the contents of the panel.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function setContent() {	
	local NexgenContentPanel p;
	
	// Create layout & add components.
	createWindowRootRegion();
	splitRegionH(20, defaultComponentDist, , true);
	p = addContentPanel();
	splitRegionV(196, , , true);
	skipRegion();
	divideRegionV(2, defaultComponentDist);
	saveButton = addButton(client.lng.saveTxt);
	resetButton = addButton(client.lng.resetTxt);
	
	p.divideRegionV(2, 2 * defaultComponentDist);
	p.divideRegionH(11);
	p.splitRegionV(64, , , true);
	autoUpdateBansInp = p.addCheckBox(TA_Left, client.lng.autoUpdateBansTxt, true);
	autoDelExpiredBansInp = p.addCheckBox(TA_Left, client.lng.autoDelExpiredBansTxt, true);
	announceTeamKillsInp = p.addCheckBox(TA_Left, client.lng.announceTeamKillsTxt, true);
	enableNexgenMessageHUDInp = p.addCheckBox(TA_Left, client.lng.enableNexgenMessageHUDTxt, true);
	logEventsInp = p.addCheckBox(TA_Left, client.lng.logEventsTxt, true);
	logMessagesInp = p.addCheckBox(TA_Left, client.lng.logMessagesTxt, true);
	logChatMessagesInp = p.addCheckBox(TA_Left, client.lng.logChatMessagesTxt, true);
	LogPrivateMessagesInp = p.addCheckBox(TA_Left, client.lng.LogPrivateMessagesTxt, true);
	defaultAllowTeamSwitchInp = p.addCheckBox(TA_Left, client.lng.defaultAllowTeamSwitchTxt, true);
	defaultAllowTeamBalanceInp = p.addCheckBox(TA_Left, client.lng.defaultAllowTeamBalanceTxt, true);
	defaultAllowNameChangeInp = p.addCheckBox(TA_Left, client.lng.defaultAllowNameChangeTxt, true);
	p.divideRegionH(11);
	p.divideRegionH(11);
	p.addLabel(client.lng.gameWaitTimeTxt, true);
	p.addLabel(client.lng.gameStartDelayTxt, true);
	p.addLabel(client.lng.autoReconnectTimeTxt, true);
	p.addLabel(client.lng.maxIdleTimeTxt, true);
	p.addLabel(client.lng.maxIdleTimeCPTxt, true);
	p.addLabel(client.lng.spawnProtectTimeTxt, true);
	p.addLabel(client.lng.teamKillDmgProtectTxt, true);
	p.addLabel(client.lng.teamKillPushProtectTxt, true);
	p.addLabel(client.lng.autoDisableMatchTimeTxt, true);
	p.skipRegion();
	p.skipRegion();
	gameWaitTimeInp = p.addEditBox();
	gameStartDelayInp = p.addEditBox();
	autoReconnectTimeInp = p.addEditBox();
	maxIdleTimeInp = p.addEditBox();
	maxIdleTimeCPInp = p.addEditBox();
	spawnProtectTimeInp = p.addEditBox();
	teamKillDmgProtectInp = p.addEditBox();
	teamKillPushProtectInp = p.addEditBox();
	autoDisableMatchTimeInp = p.addEditBox();
	p.skipRegion();
	p.skipRegion();
	p.skipRegion();
	
	// Configure components.
	gameWaitTimeInp.setMaxLength(2);
	gameStartDelayInp.setMaxLength(2);
	autoReconnectTimeInp.setMaxLength(2);
	maxIdleTimeInp.setMaxLength(3);
	maxIdleTimeCPInp.setMaxLength(3);
	spawnProtectTimeInp.setMaxLength(2);
	teamKillDmgProtectInp.setMaxLength(2);
	teamKillPushProtectInp.setMaxLength(2);
	autoDisableMatchTimeInp.setMaxLength(2);
	
	gameWaitTimeInp.setNumericOnly(true);
	gameStartDelayInp.setNumericOnly(true);
	autoReconnectTimeInp.setNumericOnly(true);
	maxIdleTimeInp.setNumericOnly(true);
	maxIdleTimeCPInp.setNumericOnly(true);
	spawnProtectTimeInp.setNumericOnly(true);
	teamKillDmgProtectInp.setNumericOnly(true);
	teamKillPushProtectInp.setNumericOnly(true);
	autoDisableMatchTimeInp.setNumericOnly(true);
	
	setValues();
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Sets the values of all input components to the current server settings.
 *
 **************************************************************************************************/
function setValues() {
	autoUpdateBansInp.bChecked = client.sConf.autoUpdateBans;
	autoDelExpiredBansInp.bChecked = client.sConf.removeExpiredBans;
	announceTeamKillsInp.bChecked = client.sConf.broadcastTeamKillAttempts;
	enableNexgenMessageHUDInp.bChecked = client.sConf.useNexgenMessageHUD;
	logEventsInp.bChecked = client.sConf.logEvents;
	logMessagesInp.bChecked = client.sConf.logSystemMessages;
	logChatMessagesInp.bChecked = client.sConf.logChatMessages;
	LogPrivateMessagesInp.bChecked = client.sConf.logPrivateMessages;
	defaultAllowTeamSwitchInp.bChecked = client.sConf.allowTeamSwitch;
	defaultAllowTeamBalanceInp.bChecked = client.sConf.allowTeamBalance;
	defaultAllowNameChangeInp.bChecked = client.sConf.allowNameChange;
	
	gameWaitTimeInp.setValue(string(client.sConf.waitTime));
	gameStartDelayInp.setValue(string(client.sConf.startTime));
	autoReconnectTimeInp.setValue(string(client.sConf.autoReconnectTime));
	maxIdleTimeInp.setValue(string(client.sConf.maxIdleTime));
	maxIdleTimeCPInp.setValue(string(client.sConf.maxIdleTimeCP));
	spawnProtectTimeInp.setValue(string(client.sConf.spawnProtectionTime));
	teamKillDmgProtectInp.setValue(string(client.sConf.teamKillDamageProtectionTime));
	teamKillPushProtectInp.setValue(string(client.sConf.teamKillPushProtectionTime));
	autoDisableMatchTimeInp.setValue(string(client.sConf.autoDisableMatchTime));
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Notifies the dialog of an event (caused by user interaction with the interface).
 *  $PARAM        control    The control object where the event was triggered.
 *  $PARAM        eventType  Identifier for the type of event that has occurred.
 *  $REQUIRE      control != none
 *  $OVERRIDE
 *
 **************************************************************************************************/
function notify(UWindowDialogControl control, byte eventType) {
	super.notify(control, eventType);
	
	// Button pressed?
	if (control != none && eventType == DE_Click && control.isA('UWindowSmallButton') &&
	    !UWindowSmallButton(control).bDisabled) {
	
		switch (control) {
			case resetButton: setValues(); break;
			case saveButton: saveSettings(); break;
		}
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Notifies this panel that the server configuration has been updated.
 *  $PARAM        configType  Type of settings that have been changed.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function configChanged(byte configType) {
	
	// Relevant settings for this panel?
	if (configType == client.sConf.CT_ExtraServerSettings) {
		setValues();
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Attemps to locate the RPC interface for this control panel.
 *  $REQUIRE      client != none
 *  $RETURN       True if the RPC interface has been set, false if not.
 *  $ENSURE       result == true ? rcpi != none : true
 *
 **************************************************************************************************/
function bool setRPCI() {
	
	// Check if RPC interface is already set.
	if (rpci == none) {
		// Attempt to get the RPC interface.
		rpci = NexgenClientCore(client.getController(class'NexgenClientCore'.default.ctrlID));
		return rpci != none;
		
	} else {
		// It is.
		return true;
	}
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Saves the server settings.
 *
 **************************************************************************************************/
function saveSettings() {
	// Make sure the RPC interface is available.
	if (!setRPCI()) return;

	// Save settings.
	rpci.setServerSettingsExt1(autoUpdateBansInp.bChecked,
	                           autoDelExpiredBansInp.bChecked,
	                           announceTeamKillsInp.bChecked,
	                           enableNexgenMessageHUDInp.bChecked,
	                           logEventsInp.bChecked,
	                           logMessagesInp.bChecked,
	                           logChatMessagesInp.bChecked,
	                           LogPrivateMessagesInp.bChecked,
	                           defaultAllowTeamSwitchInp.bChecked,
	                           defaultAllowTeamBalanceInp.bChecked,
	                           defaultAllowNameChangeInp.bChecked);
	                          
	rpci.setServerSettingsExt2(int(gameWaitTimeInp.getValue()),
	                           int(gameStartDelayInp.getValue()),
	                           int(autoReconnectTimeInp.getValue()),
	                           int(maxIdleTimeInp.getValue()),
	                           int(maxIdleTimeCPInp.getValue()),
	                           int(spawnProtectTimeInp.getValue()),
	                           int(teamKillDmgProtectInp.getValue()),
	                           int(teamKillPushProtectInp.getValue()),
	                           int(autoDisableMatchTimeInp.getValue()));
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
	panelIdentifier="serversettings2"
}
