simulated function getPlayerNameIndices(string msg, out PlayerReplicationInfo pri1,
                                        out PlayerReplicationInfo pri2, out int index1,
                                        out int index2) {
	local int firstIndex;
	local int secondIndex;
	local PlayerReplicationInfo currPRI;
	
	// Attempt to locate first player replication info if not set.
	while(pri1 == none && firstIndex < arrayCount(client.player.gameReplicationInfo.PRIArray) &&
	      client.player.gameReplicationInfo.PRIArray[firstIndex] != none) {
		currPRI = client.player.gameReplicationInfo.PRIArray[firstIndex];
		if (len(currPRI.playerName) > 2 && instr(msg, currPRI.playerName) >= 0) {
			pri1 = currPRI;
		} else {
			firstIndex++;
		}
	}
	
	// Attempt to locate second player replication info if not set.
	if (pri1 != none) {
		while(pri2 == none && secondIndex < arrayCount(client.player.gameReplicationInfo.PRIArray) &&
		      client.player.gameReplicationInfo.PRIArray[secondIndex] != none) {
			currPRI = client.player.gameReplicationInfo.PRIArray[secondIndex];
			firstIndex = instr(msg, currPRI.playerName);
			if (currPRI != pri1 && firstIndex >= 0) {
				pri2 = currPRI;
			} else if (currPRI == pri1 && firstIndex >= 0 &&
			    instr(mid(msg, firstIndex + len(currPRI.playerName)), currPRI.playerName) >= 0) {
			    pri2 = currPRI;
			} else {
				secondIndex++;
			}
			
	    }
	}
	
	// locate player names & get player colors.
	firstIndex = -1;
	secondIndex = -1;
	if (pri1 != none) {
		firstIndex = instr(msg, pri1.playerName);
	}
	if (pri2 != none) {	
		if (pri2 == pri1) {
			if (firstIndex >= 0) {
				secondIndex = instr(mid(msg, firstIndex + len(pri1.playerName)) , pri2.playerName);
				if (secondIndex >= 0) {
					secondIndex += firstIndex + len(pri1.playerName);
				}
			}
		} else {
			secondIndex = instr(msg, pri2.playerName);
		}
	}
	
	index1 = firstIndex;
	index2 = secondIndex;
}