<?php

/***************************************************************************************************
 *
 *  Nexgen statistics viewer by Zeropoint.
 *
 *  $FILE         getstats.php
 *  $VERSION      1.00 (24-6-2008 20:02)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  The server side script that provides an interface for the Nexgen statistics viewer
 *                plugin and UTStats.
 *
 **************************************************************************************************/

/***** CONSTANTS *****/
define('MAX_NUMBER_OF_LISTS', 5);
define('MAX_NUMBER_OF_PLAYERS', 30);



/***** CONFIG *****/

// Database settings.
$db_host = 'localhost';
$db_name = 'utstats';
$db_user = '';
$db_password = '';

// List settings.
add_player_list('Tournament DeathMatch', 5, 'Top DM players');
add_player_list('Capture the Flag', 5, 'Top CTF players');
add_player_list('Assault', 5, 'Top AS players');



/***** MAIN *****/

// Connect to database.
$db_link = mysql_connect($db_host, $db_user, $db_password) or die('unable to connect to database, '.mysql_error());
mysql_select_db($db_name) or die('could not select database, '.mysql_error());

// For each player list...
$player_list_index = 0;
$player_count = 0;
while ($player_list_index < sizeof($player_lists) &&
       $player_list_index < MAX_NUMBER_OF_LISTS &&
       $player_count < MAX_NUMBER_OF_PLAYERS) {
	// Get list details.
	$game_name = $player_lists[$player_list_index]['game_name'];
	$num_players = $player_lists[$player_list_index]['num_players'];
	$list_title = $player_lists[$player_list_index]['list_title'];
	
	// Retrieve game id.
	$query = "select id from uts_games where name = '".mysql_real_escape_string($game_name)."' limit 1";
	$result = mysql_query($query);
	if ($r = mysql_fetch_array($result)) {
		$game_id = $r[id];
	} else {
		$game_id = 0;
	}
	
	// Get player list.
	if ($game_id > 0) {
		$query = "select pid, rank, prevrank from uts_rank where gid = $game_id order by rank desc limit $num_players";
		$result = mysql_query($query);
		if (mysql_num_rows($result) > 0) {
			println('beginlist "'.str_replace('"', '\\"', $list_title).'"');
		}
		while (($r = mysql_fetch_array($result)) && $player_count < MAX_NUMBER_OF_PLAYERS) {
			// Get player rank info.
			$player_id = $r['pid'];
			$rank = $r['rank'];
			$previous_rank = $r['prevrank'];
			
			// Get player info.
			$query = "select name, country from uts_pinfo where id = $player_id limit 1";
			$result2 = mysql_query($query);
			$r2 = mysql_fetch_array($result2);
			$player_name = $r2['name'];
			$player_country = $r2['country'];
			
			// Process data.
			if ($rank > $previous_rank) {
				$rank_change = 'up';
			} else if ($rank < $previous_rank) {
				$rank_change = 'down';
			} else {
				$rank_change = 'nc';
			}
			
			// Echo player info.
			println('addplayer "'.str_replace('"', '\\"', $player_name).'" '.round($rank).' '.$player_country.' '.$rank_change);
			
			// Continue with next player.
			$player_count++;
		}
	}
	
	// Continue with next list.
	$player_list_index++;
}

// End of execution, no more output is desired!
die();



/***** FUNCTIONS *****/

/***************************************************************************************************
 *
 *  $DESCRIPTION  Adds a new player list that will be displayed on the server.
 *  $PARAM        $game_name    The name of the game type.
 *  $PARAM        $num_players  Number of players to display in the list.
 *  $PARAM        $list_title   Display title of the list on server.
 *
 **************************************************************************************************/
function add_player_list($game_name, $num_players = 10, $list_title = '') {
	global $player_lists;
	
	if (trim($list_title) == '') {
		$list_title = $game_name;
	}
	
	$player_lists[] = array('game_name' => $game_name, 'num_players' => $num_players, 'list_title' => $list_title);
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Writes a line to the output.
 *  $PARAM        $text  The text that is to be written.
 *
 **************************************************************************************************/
function println($text) {
	echo $text."\r\n";
}
?>