/***************************************************************************************************
 *
 *  NSC. Nexgen Server Controller by Zeropoint.
 *
 *  $CLASS        NexgenXLang
 *  $VERSION      1.00 (21-11-2007 19:20)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *  $DESCRIPTION  Localization support class.
 *
 **************************************************************************************************/
class NexgenXLang extends Info;

var localized string invalidConfigMsg;            // Message written to log when configuration was damaged.

var localized string mapSwitchTabTxt;             // Match switch tab label text.
var localized string mapSwitchActionTxt;          // Map switch button text.
var localized string hideBadMapsTxt;              // Hide incompatible maps checkbox text.
var localized string adminMapSwitchMsg;           // Message displayed when a map switch was executed.

var localized string settingsPanelTitle;          // Title of the NexgenX settings panel.
var localized string enableOverlaySkinTxt;        // Enable the overlay skin effect.
var localized string enableMapSwitchTabTxt;       // Enable the map switch tab.
var localized string enableStartAnnouncerTxt;     // Enable the game starting voice announcer.
var localized string enableAntiSpamTxt;           // Enable spam detection.

var localized string fullServerRedirPanelTitle;   // Title of the full server redirect settings panel.
var localized string enableFullServerRedirTxt;    // Enable full server player redirect.
var localized string messageTxt;                  // Message input field label.
var localized string defaultFullServerRedirMsg;   // Default message for the full server redirect dialog.
var localized string serverEntryTxt;              // Server entry label.
var localized string urlTxt;                      // URL input field label.

var localized string antiSpamMutedState;          // Client muted state because of anti spam.



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/
defaultproperties {
	invalidConfigMsg="NexgenX configuration file was corrupt and has been repaired."
	
	mapSwitchTabTxt="Map switch"
	mapSwitchActionTxt="Switch"
	hideBadMapsTxt="Hide incompatible maps"
	adminMapSwitchMsg="<C07>%1 has changed the game to %2."
	
	settingsPanelTitle="NexgenX - General settings"
	enableOverlaySkinTxt="Enable player overlay skin effect"
	enableMapSwitchTabTxt="Enable map switch tab for match controllers"
	enableStartAnnouncerTxt="Enable game start announcer"
	enableAntiSpamTxt="Enable anti spam"
	
	fullServerRedirPanelTitle="NexgenX - Full server redirect settings"
	enableFullServerRedirTxt="Enable player redirect to alternate servers when server is full"
	messageTxt="Message"
	defaultFullServerRedirMsg="The server you have tried to enter has no more player slots available. You can try again in a few minutes or reconnect immediately as a spectator. If you wish to play immediately you can connect to one of the alternate servers."
	serverEntryTxt="Server %1"
	urlTxt="URL"
	
	antiSpamMutedState="Muted (spam)"
}