/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLLaunchPuff
 *  $VERSION  1.40
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLLaunchPuff extends SLSmoke;

var() float intro;
var() float life;
var float elapsed;
var bool bShorted;

simulated function beginPlay() {
	velocity = vector(rotation) * 15.0;
	elapsed = life;
}

simulated function tick(float d) {
	if (level.bDropDetail && !bShorted) {
		life /= 4.0;
		elapsed /= 4.0;
		intro /= 2.0;
		bShorted = true;
	}
	
	if (elapsed > life - intro) {
		scaleGlow = (life - elapsed) / intro;
		drawScale = default.drawScale * scaleGlow;
	} else {
		scaleGlow = elapsed / (life - intro);
		drawScale = default.drawScale + 1.0 * (1.0 - scaleGlow);
	}
	
	lightBrightness = scaleGlow * default.lightBrightness;

	elapsed -= d;

	if (elapsed < 0) {
		destroy();
	}
}
// $END_CLASSIFIED

defaultproperties {
	Intro=0.15
	life=6.00
	RemoteRole=ROLE_SimulatedProxy
	LifeSpan=0.00
	DrawType=DT_Sprite
	Texture=Texture'SLV2Textures.Smoke.launchpuff'
	ScaleGlow=0.00
}
