/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLBoostSmoke
 *  $VERSION  1.00
 *  $AUTHOR   Daan 'Defrost' Scheerens  original version
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLBoostSmoke extends UT_SpriteSmokePuff;

var Texture smokeSprites[10];

const minLifeSpan = 1.0;
const maxLifeSpan = 3.0;

simulated function beginPlay() {
	texture = smokeSprites[rand(arrayCount(smokeSprites))];
	lifeSpan = minLifeSpan + fRand() * (maxLifeSpan - minLifeSpan);
	// Randomize rotation?
}

// $END_CLASSIFIED

defaultproperties {
	remoteRole=ROLE_None
	lifeSpan=2.0
	drawScale=2.0
	scaleGlow=0.5
	drawType=DT_SpriteAnimOnce
	style=STY_Translucent
    lightType=LT_None
    bCorona=False
	smokeSprites(0)=Texture'Botpack.utsmoke.us1_a00'
	smokeSprites(1)=Texture'Botpack.utsmoke.us2_a00'
	smokeSprites(2)=Texture'Botpack.utsmoke.us3_a00'
	smokeSprites(3)=Texture'Botpack.utsmoke.us4_a00'
	smokeSprites(4)=Texture'Botpack.utsmoke.us5_a00'
	smokeSprites(5)=Texture'Botpack.utsmoke.us6_a00'
	smokeSprites(6)=Texture'Botpack.utsmoke.us7_a00'
	smokeSprites(7)=Texture'Botpack.utsmoke.us8_a00'
	smokeSprites(8)=Texture'Botpack.utsmoke.us9_a00'
	smokeSprites(9)=Texture'Botpack.utsmoke.us10_a00'
}
