/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLClip
 *  $VERSION  1.10
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLClip extends SLInfo;

var int rounds;
var SLAmmo ammo;

replication {
	reliable if (role == ROLE_Authority)
    	rounds;
}

simulated function bool empty() {
	return rounds == 0;
}

simulated function bool full() {
	return rounds == class'SLConfig'.default.roundsPerClip;
}

simulated function int getRounds() {
	return rounds;
}

simulated function int getMaxRounds() {
	return class'SLConfig'.default.roundsPerClip;
}

function bool useRound() {
	if (rounds > 0) {
		rounds--;
		ammo.ammoAmount--;
		return true;
	} else {
		return false;
	}
}
// $END_CLASSIFIED
