/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLFuelglow
 *  $VERSION  1.10
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLFuelglow extends SLSmoke;

var float fadet;

function postBeginPlay() {
}

function tick(float delta) {
	if (fadet < 0.5) {
		fadet = fmin(0.5, fadet + delta);
		drawScale = default.drawScale * fadet * 2;
	} else {
		disable('tick');
	}
}

function fade() {
	if (!isInState('fadeOut')) {
		GotoState('fadeOut');
	}
}

state fadeOut {
	
	function beginState() {
		fadet = 0.0;
	}
  
	function tick(float delta) {
		if (fadet < 0.5) {
			fadet += delta;
			scaleGlow = default.scaleGlow * (1.0 - fadet / 0.5);
		} else {
			destroy();
		}
	}
  
}
// $END_CLASSIFIED

defaultproperties {
	Physics=PHYS_Trailer
	LifeSpan=0.00
	Texture=Texture'SLV2Textures.exhaust.fuelglow'
	DrawScale=0.80
	AmbientGlow=255
}
