/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLProjectileSN
 *  $VERSION  1.50
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLProjectileSN extends SpawnNotify;

var() float limitMult;

// Don't remove this function! For some reason it causes the rockets to be stuck in the air when
// it is removed.
function postBeginPlay() {
	super.postBeginPlay();
}

function Actor spawnNotification(Actor a) {
	local Pawn inst;
	local StrangeShell s;
	local float limit;
	local float da;

	inst = a.instigator;
  
	if (inst != none) {
		foreach AllActors(Class'StrangeShell', s) {
			if (inst != none && (s.getPilot() == inst || s.gunner == inst)) {
				limit = vsize(a.velocity) * limitMult;
				da = normal(a.velocity) dot normal(s.velocity);
				if (da > 0) {
					a.velocity += normal(a.velocity) * vsize(s.velocity) * da;
					if (vsize(a.velocity) > limit) {
						a.velocity = normal(a.velocity) * limit;
					}
				}
				
				break;
			}
		}
	}
	return a;
}

// $END_CLASSIFIED

defaultproperties {
	limitMult=1.25
	ActorClass=Class'Engine.Projectile'
}
