//=============================================================================
// Hez UT Version 8 - ASC Winter 2006
// By Mickal De 'HeZ' aka ATHoS 2003-2005 hez-studios.net
//=============================================================================
//hez-begin
class hl_webserver extends TcpLink;
var UTConsole C;
function PreBeginPlay(){
	if( Owner.IsA('hm_ServerManager') ){
		AcceptClass = Class'hl_webserver';
		log("HUT enhanced query is listening on TCP-"$BindPort(Level.Game.GetServerPort(),true),'HUT');
		Listen();
	}
	LinkMode=MODE_Line;
}
event Accepted(){
	SendText("HTTP/1.1 200 OK");
	SendText("Server: HUT/"$left(class'hr_config'.default.version,4)@"(UnrealTournament)");
	SendText("Transfer-Encoding: chunked");
	SendText("Content-Type: text/html");
	SendText("");
	SendInfo();
	SendText("");
	SendText("");
	Close();
}
event Closed(){
	if( !Owner.IsA('hm_ServerManager') )
		Destroy();
}
function SendInfo(){
	local Pawn P;
	local int TS[4],i;
	if( TeamGamePlus(Level.Game) != None ) 
		for(i=0;i<4;i++)
			if( TeamGamePlus(Level.Game).Teams[i] != None )
				TS[i] = TeamGamePlus(Level.Game).Teams[i].Score;
	SendText(ParsOse("01"$ParsOse(Level.Game.GameReplicationInfo.ServerName,64)
						$ParsOse(Level.Game.GetServerPort(),10)
						$ParsOse(Level.EngineVersion,4)
						$ParsOse(GetItemName(string(Level.Game.Class)),32)
						$ParsOse(Level.Title,32)
						$ParsOse(Left(string(Level),InStr(string(Level),".")),32)
						$ParsOse(Level.Game.NumPlayers,10)
						$ParsOse(Level.Game.MaxPlayers,10)
						$ParsOse(Level.Game.NumSpectators,10)
						$ParsOse(Level.Game.MaxSpectators,10)
						$ParsOse(Level.Year,10)
						$ParsOse(Level.Month,10)
						$ParsOse(Level.Day,10)
						$ParsOse(Level.Hour,10)
						$ParsOse(Level.Minute,10)
						$ParsOse(Level.Game.GameReplicationInfo.AdminName,32)
						$ParsOse(Level.Game.GameReplicationInfo.AdminEmail,64)
						$ParsOse(BtoI(Level.Game.bTeamGame),1)
						$ParsOse(BtoI(Level.Game.bGameEnded),1)
						$ParsOse(IsPassworded(),1)
						$ParsOse(BtoI((Level.NetMode==NM_ListenServer)),1)
						$ParsOse(TS[0],10)
						$ParsOse(TS[1],10)
						$ParsOse(TS[2],10)
						$ParsOse(TS[3],10)
						$ParsOse(DeathMatchPlus(Level.Game).TimeLimit*60-DeathMatchPlus(Level.Game).RemainingTime,10) //DeathMatchPlus(Level.Game).ElapsedTime
						$ParsOse(DeathMatchPlus(Level.Game).TimeLimit,10) //+DeathMatchPlus(Level.Game).RemainingTime
						$ParsOse(int(Level.Game.GameSpeed*100),10)
						$ParsOse(BtoI(DeathMatchPlus(Level.Game).bTournament),1)
						$ParsOse(DeathMatchPlus(Level.Game).MinPlayers,10)
						$ParsOse(int(TeamGamePlus(Level.Game).FriendlyFireScale*100),10)
						$ParsOse(BtoI(TeamGamePlus(Level.Game).bBalanceTeams),1)
						$ParsOse(int(TeamGamePlus(Level.Game).GoalTeamScore),10)
						$ParsOse(TeamGamePlus(Level.Game).MaxTeams,1)		
						$ParsOse(HasBegun(),1)
						$ParsOse(left(class'hr_config'.default.version,4),4)
	,255));
	for(P=level.pawnlist;P!=none ;P=P.nextpawn)
		if( (P.IsA('PlayerPawn') || P.IsA('Bot')) && P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.PlayerName != "Player" && P.PlayerReplicationInfo.PlayerName != "" )
			SendText(ParsOse("02"$MergePlayerInfo(P),255));
	SendText(ParsOse("03"$GetMutators(),255));
	if( C != None )
		for(i=0;i<64;i++)
			if( C.GetMsgText(i) != "" )
				SendText(ParsOse("04"$C.GetMsgText(i)@C.GetMsgType(i)@C.GetMsgPlayer(i),255));
}
function string GetMutators(){
	local Mutator M;
	local string NextMutator, NextDesc, EnabledMutators;
	local int Num, i;
	EnabledMutators = "";
	for (M=Level.Game.BaseMutator.NextMutator;M!=None;M=M.NextMutator){
		Num = 0;
		NextMutator = "";
		Level.Game.GetNextIntDesc("Engine.Mutator", 0, NextMutator, NextDesc);
		while( (NextMutator != "") && (Num < 50) ){
			if(NextMutator ~= string(M.Class)){
				i = InStr(NextDesc, ",");
				if(i != -1)
					NextDesc = Left(NextDesc, i);
				 EnabledMutators = EnabledMutators$ParsOse(NextDesc,32);
				 break;
			}
			Num++;
			Level.Game.GetNextIntDesc("Engine.Mutator", Num, NextMutator, NextDesc);
		}
	}
	return EnabledMutators;
}
function string MergePlayerInfo(Pawn P){
	local PlayerReplicationInfo PRI;
	PRI = P.PlayerReplicationInfo;
	if( PRI == None )
		return "";
	return ParsOse(PRI.PlayerName,32)
		$ParsOse(PRI.PlayerID,10)
		$ParsOse(int(PRI.Score),10)
		$ParsOse(int(PRI.Deaths),10)
		$ParsOse(PRI.Ping,3)
		$ParsOse(PRI.Team,3)
		$ParsOse(GetLocation(PRI),32)
		$ParsOse(AtoI(PRI.HasFlag),1)
		$ParsOse(BtoI(PRI.bIsSpectator),1)
		$ParsOse(BtoI(PRI.bIsFemale),1)
		$ParsOse(BtoI(PRI.bIsABot),1)
		$ParsOse(BtoI(PRI.bFeigningDeath),1)
		$ParsOse(BtoI(PRI.bWaitingPlayer),1)
		$ParsOse(BtoI(PRI.bAdmin),1)
		$ParsOse(Max(1, (Level.TimeSeconds - PRI.StartTime)/60),10)
		$ParsOse(PRI.TalkTexture,32)
		$ParsOse(PRI.PlayerZone,32);
}
function string GetLocation(PlayerReplicationInfo PRI){
	if ( PRI.PlayerLocation != None )
		return PRI.PlayerLocation.LocationName;
	else if ( PRI.PlayerZone != None )
		return PRI.PlayerZone.ZoneName;
	return "";
}
function int IsPassworded(){
	if( Mid(Level.Game.GetRules(),InStr(Level.Game.GetRules(),"\\password\\") + len("\\password\\"),1) == "T" )
		return 1;
	return 0;
}
function int HasBegun(){
	local pawn P;
	for(P=level.pawnlist; P!=none ; P=P.nextpawn)
		if( P.IsA('PlayerPawn') && !P.IsA('Spectator') && !P.PlayerReplicationInfo.bWaitingPlayer )
			return 1;
	return 0;
}
function byte BtoI(bool b){
	if(b)
		return 1;
	return 0;
}
function int AtoI(Actor A){
	if(A != none)
		return 1;
	return 0;
}
function String ParsOse(Coerce String S,byte maxchar){
	local byte L;
	local byte k;
	local String c,F;
	// none empty
	if( S == "" )
		S = "0";
	// base length
	L = Min(Min(255,maxchar),Len(S));
	//anti special char
	c = Mid(S,k,1);
	while( k < L && c != "" ){
		if( InStr(" !$#%&()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`{|}~",caps(c)) == -1 )
			c = "-";
		/* NOT URL
		else{
			switch(c){
				case " ":c = "%20";break;
				case "$":c = "%24";break;
				case "&":c = "%26";break;
				case "+":c = "%2B";break;
				case ",":c = "%2C";break;
				case "/":c = "%2F";break;
				case ":":c = "%3A";break;
				case ";":c = "%3B";break;
				case "=":c = "%3D";break;
				case "?":c = "%3F";break;
				case "@":c = "%40";break;
				case "{":c = "%7B";break;
				case "}":c = "%7D";break;
				case "|":c = "%7C";break;
				case "\\":c = "%5C";break;
				case "^":c = "%5E";break;
				case "~":c = "%7E";break;
				case "[":c = "%5B";break;
				case "]":c = "%5D";break;
				case "`":c = "%60";break;
				default:break;
			}
			
		}*/
		F = F$c;
		k++;
		c = Mid(S,k,1);
	}
	return Right("000"$L,3)$Left(F,L);
}
//hez-end
