//=============================================================================
// Hez UT Version 8 - ASC Winter 2006
// By Mickal De 'HeZ' aka ATHoS 2003-2005 hez-studios.net
//=============================================================================
//hez-begin
class hm_ServerManager extends Mutator config(hut_log);
var config String hl[64];					// static log
const DTIME = 0.1;							// TimerRate ...
var hr_config RI;							// config GLOBAL REPLICATION / LEVEL
var hm_ClientManager CM;   					// clients
var hm_ClientManager LastSW; 				// last team switcher
var hl_webclient WebC;						// webclient
var hl_webserver WebS;						// webserver
var string TeamName[4];     				// team string
var string PostCheck_PlayerName[32];		// checking publickey hacks
var string PostCheck_PublicKey[32];			// checking publickey hacks
var byte LG;								// LastGame Added / POS !
var byte LG_Map;							// LastMap Added / POS !
var byte LG_Mutate;							// LastMutator Added / POS !
var float ScoreBoardDelay;					// end->vote
var float dTimeSecondes;					// pause
struct spam
{
	var byte PID;
	var string Msg;
	var float Timin;
};
var spam Last_Say[10];						// anti-spam
const MaxMsgRecord = 5;
const MaxAllowedMsgs = 4;
const MaxDuplicateMsgs = 3;
var PlayerPawn FP[6];						// first pawn (team) 4 == spec or no team 5 == everyone

var bool SmartCTFBoardFixDone;
var bool isGameConfigUpdate;
//===========================================================
// FUNCTIONS
function PreBeginPlay(){
	if( Level.NetMode != NM_DedicatedServer ){
		log("HUT::Your server must be dedicated!",'HUT');
		Destroy();
	}
	Level.Game.CurrentID = 1; // byte("abc") return 0 !
	Level.Game.RegisterMessageMutator( Self );
	Level.Game.RegisterDamageMutator( Self );
	// config GLOBAL REPLICATION / LEVEL (for everyone)
	RI = Level.Spawn(class'hr_config',Self);
	class'hm_ClientManager'.default.RI = RI;
	// connection to masterserver
	if (RI.UseStatsServer) {
		Class'hl_webclient'.Default.RI = RI;
		WebC = Spawn(class'hl_webclient',Self);
		WebC.RI = RI;
	}
	// enhanced query 
	if (RI.EnableHUTWebServer) {
		WebS = Spawn(Class'hl_webserver', self);
	}
	// game
	Level.Game.bRestartLevel = False;
	DeathMatchPlus(Level.Game).bNetReady = False;
	DeathMatchPlus(Level.Game).bDontRestart = True;
	if( RI.RespawnTime <= 1 )
		DeathMatchPlus(Level.Game).bForceRespawn = RI.bForceRespawn;
	else
		DeathMatchPlus(Level.Game).bForceRespawn = False;
	SetTimer(DTIME,True);
	ScoreBoardDelay = RI.ScoreBoardDelay;
	RI.RemainingTime = RI.VoteDelay;
	RI.GameState = 0;
	RI.WaitingTime = RI.WaitingTimeConfig+4;
}
//===========================================================
// Timer
Event Timer(){
	local bool HasAdmin;
	local PlayerReplicationInfo PRI;
	local hm_ClientManager TCM,iTCM;
	local int i,j;
	// time
	RI.Hour = Level.Hour;
	RI.Minute = Level.Minute;
	// place me
	if ( Level.Game.BaseMutator != Self ) 
		SendToListStart();
	// Check for offline clients + timed server updates
	for(TCM=CM;TCM!=None;TCM=TCM.PostCM){
		 if( TCM.Owner != None ){ 
			if( TCM.LoginState == 1 && TCM.PP != None && TCM.PP.PlayerReplicationInfo != None ){
				TCM.LoginState = 2; // postlogged
				// all players to him
				for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
					if( iTCM.Owner != None && iTCM != TCM && iTCM.PP != None && iTCM.PP.PlayerReplicationInfo != None )
						TCM.Client_PlayerEvent(iTCM.IsSpectator,False,iTCM.PlayerName,-1,iTCM.PP.PlayerReplicationInfo.PlayerID,iTCM.PublicKey,iTCM.PP.PlayerReplicationInfo.Team,iTCM.ip,True);
				// him to all players
				for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
					if( iTCM.Owner != None )
						iTCM.Client_PlayerEvent(TCM.IsSpectator,False,TCM.PP.PlayerReplicationInfo.PlayerName,-1,TCM.PP.PlayerReplicationInfo.PlayerID,TCM.PublicKey,TCM.PP.PlayerReplicationInfo.Team,TCM.ip);
			}
			if( RI.GameState >= 5 && !TCM.DoneVote && ScoreBoardDelay <= 0){
				TCM.DoneVote = True;
				TCM.Client_Window(1);
			}
			if( RI.GameState < 2 && !HasAdmin )
				HasAdmin = RI.HasRight(3,TCM.PublicKey,TCM.Rights);
		}
		else if( TCM.LoginState > 0 && !TCM.HasBeenDeleted ){ // it does not delete the cm
			TCM.HasBeenDeleted = True;
			PlayerLeft(TCM.IsSpectator,TCM.PlayerName,TCM.PublicKey,TCM.LastFrags,TCM.PlayerID,TCM.Team,TCM.ip,TCM.LastStartTime);
			// delete the shield
			if( TCM.Shield != None ){
				TCM.Shield.Destroy();
				TCM.Shield = None; 
			}
			// update the chain
			if( TCM.PreCM != None )
				TCM.PreCM.PostCM = TCM.PostCM;
			else
				CM = TCM.PostCM;
		}
	}
	// update
	if( RI.GameState < 2 && RI.WaitingTime < 1 ){
		for(TCM=CM;TCM!=None;TCM=TCM.PostCM){
			if( TCM.LoginState == 2 ){
				TCM.LoginState = 3;
				//TCM.Client_NewMessage('Notice',"Commands : !open !teams !start !vote !kick !abort !play !spec !red !blue !green !yellow",7);
				//TCM.Client_NewMessage('Notice',"Shortcut : !o !t !l !v !k !a !p !s !r !b !g !y",7);
				if( RI.HasRight(2,TCM.PublicKey,TCM.Rights) && hl[0] != "" ){
					for(i=0;i<64;i++)
						if( hl[i] != "" )
							j++;
					TCM.Client_NewMessage('Notice',"hut_log.ini contains ",9,j@"warning(s).",7);
				}
				
				if( HasAdmin && !RI.HasRight(3,TCM.PublicKey,TCM.Rights) )
					TCM.Client_NewMessage('Notice',"Please wait, an administrator is going to launch the match.",7);
				else
					TCM.Client_NewMessage('Notice',"Hit Fire or say ",9,"!start ",7,"to begin.",9);
				
			}
		}
	}
	RI.HasAdmin = HasAdmin;
	// game begin
	if( RI.WaitingTime > 0 )
		RI.WaitingTime -= DTIME;
	// game start
	if( RI.GameState < 1 )
		DeathMatchPlus(Level.Game).CountDown = 12;
	else
		DeathMatchPlus(Level.Game).CountDown = 0;
	// game end
	if( RI.GameState >= 5 ){
		/*
		if( ScoreBoardDelay == 1 )
			for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
				TCM.Client_Window(1);
		*/
		
		if (!SmartCTFBoardFixDone && ScoreBoardDelay < RI.ScoreBoardDelay - 0.5) {
			SmartCTFBoardFixDone = true;
			TCM = cm;
			while (TCM != None) {
				TCM.Client_ConsoleCommand("mutate SmartCTF ForceStats");
				TCM = TCM.PostCM;
			}
		}
		
		if( ScoreBoardDelay <= 0 ){
			if( RI.RemainingTime >= 0 )
				RI.RemainingTime -= DTIME;
			if( RI.RemainingTime < 1 && RI.GameState != 6 ){
				i = RI.RunNextGame();
				if( i != 200 ){
					for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
						TCM.Client_CloseW();
					Message2All("Next Game will be ["$RI.GameLabel[RI.gVote[i]]$"] ["$RI.GetGmap(RI.gVote[i],RI.mVote[i])$"]");
				}
				else{
					RI.GameState = 5;
					RI.RemainingTime = 250;
					hlog("Warning: Could not find a game in GameVote, an administrator will have to set one.",'admin');
					Message2All("Warning: Could not find a game in GameVote, an administrator will have to set one.");
				}
			}
		}
		else
			ScoreBoardDelay -= DTIME;
	}
	// match tools ************************************************************************************************
	// auto pause
	if( RI.IsMatch && RI.AutoPause ){
		if( RI.GameState == 3 && Level.Game.NumPlayers < RI.DesiredPlayers  ){
			RI.GameState = 4;
			RI.Pauser = "SERVER";
			Message2All("The game is paused, waiting for"@RI.DesiredPlayers@"players ready.");
			for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
				TCM.CMPause(True);
		}
		if( RI.GameState == 4 && RI.Pauser == "SERVER" ){
			RI.Pauser = "";
			// flag au sol ?
			if( Level.Game.NumPlayers >= RI.DesiredPlayers ){
				RI.GameState = 3;
				Message2All("The game has been resumed!");
				for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
					TCM.CMPause(False);
			}
		}
	}
	// PAUSE temps du jeu ?
	if( RI.GameState == 4 ){
		dTimeSecondes += DTIME;
		if( dTimeSecondes == 1 ){
			dTimeSecondes = 0;
			Level.Game.GameReplicationInfo.RemainingTime++;
			DeathMatchPlus(Level.Game).RemainingTime++;
			for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
				TCM.Client_CMPause(Level.Game.GameReplicationInfo.RemainingTime);
		}
	} 
	// spam ************************************************************************************************
	for(i=0;i<MaxMsgRecord;i++)
		if( Last_Say[i].Timin <= 0 )
			Last_Say[i].PID = 0;
		else
			Last_Say[i].Timin -= DTIME;
	// . ************************************************************************************************
}
//===========================================================
// Messages
function bool MutatorBroadcastMessage( Actor Sender, Pawn Receiver, out coerce string Msg, optional bool bBeep, out optional name Type ){
	local hm_ClientManager TCM,iTCM;
	local PlayerReplicationInfo PRI;
	local byte C[5],pos,c_pos;
	local String S[5],M;
	local bool bLeave;
	local Pawn P;
	if( Receiver == SetFirstPawn(Sender,Type) && InStr(Msg,Level.Game.EnteredMessage) == -1 && InStr(Msg,Level.Game.LeftMessage) == -1 ){
		if( Sender.IsA('Spectator') ){
			if( RI.MuteSpectators && RI.GameState == 3 ){
				TCM = GetCM(Sender);
				if( !RI.HasRight(3,TCM.PublicKey,TCM.Rights) ){
					TCM.Client_NewMessage('client',"Spectators are muted while they play this match.");
					if( Level.Game.IsA('TeamGamePlus') )
						TCM.Client_NewMessage('client',"Use TeamSay to talk with spectators.");
					return False;
				}
			}
			M = right(Msg,len(Msg)-len(PlayerPawn(Sender).PlayerReplicationInfo.PlayerName)-1);
			if( IsSpam(PlayerPawn(Sender),M) )
				return False;
			// send
			for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
				TCM.Client_NewMessage('Say',PlayerPawn(Sender).PlayerReplicationInfo.PlayerName$": ",8,M,8);
			// check for cmds
			Commands(M,PlayerPawn(Sender));
		}
		else{
			C[0] = 4;
			S[0] = Msg;
			// try to colorate ?
			c_pos = 255;
			M = S[0];
			for(P=Level.PawnList;P!=None;P=P.NextPawn){
				if( P.PlayerReplicationInfo != None ){
					pos = InStr(M,P.PlayerReplicationInfo.PlayerName);
					if( pos != -1 && pos < c_pos ){
						c_pos = pos;
						PRI = P.PlayerReplicationInfo;
					}
				}
			}
			if( c_pos < 255 ){
				S[0] = Left(M,InStr(M,PRI.PlayerName));
				C[0] = 9;
				S[1] = PRI.PlayerName;
				C[1] = PRI.Team;
				S[2] = Right(M,Len(M)-InStr(M,PRI.PlayerName)-Len(PRI.PlayerName));
				C[2] = 9;
				c_pos = 255;
				M = S[2];
				for(P=Level.PawnList;P!=None;P=P.NextPawn){
					if( P.PlayerReplicationInfo != None ){
						pos = InStr(M,P.PlayerReplicationInfo.PlayerName);
						if( pos != -1 && pos < c_pos ){
							c_pos = pos;
							PRI = P.PlayerReplicationInfo;
						}
					}
				}
				if( c_pos < 255 ){
					S[2] = Left(M,InStr(M,PRI.PlayerName));
					C[2] = 9;
					S[3] = PRI.PlayerName;
					C[3] = PRI.Team;
					S[4] = Right(M,Len(M)-InStr(M,PRI.PlayerName)-Len(PRI.PlayerName));
					C[4] = 9;
				}
			}
			for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
				TCM.Client_NewMessage('event',S[0],C[0],S[1],C[1],S[2],C[2],S[3],C[3],S[4],C[4]);
		}
	}
	if( NextMessageMutator != None )
		NextMessageMutator.MutatorBroadcastMessage( Sender, Receiver, Msg, bBeep, Type );
	return False;
}
function bool MutatorBroadcastLocalizedMessage( Actor Sender, Pawn Receiver, out class<LocalMessage> Message, out optional int Switch, out optional PlayerReplicationInfo RelatedPRI_1, out optional PlayerReplicationInfo RelatedPRI_2, out optional Object OptionalObject ){
	local String S,pre,mid,post;
	local hm_ClientManager TCM;
	//getting the last switcher
	if( Receiver == SetFirstPawn(Sender,'') ){
		if( Sender.IsA('GameInfo') && OptionalObject != None && OptionalObject.IsA('TeamInfo') ){
			TCM = GetCM(RelatedPRI_1.Owner);
			if( TCM != None ){
				if( TCM.TeamEntered ){
					if( TCM.HasSwitched )
						TCM.HasSwitched = False;
					else{
						TCM.HasSwitched = True;
						level.game.ChangeTeam(TCM.PP,TCM.Team);
		 				TCM.PP.Died(None,'',TCM.PP.Location);
						TCM.PP.PlayerReplicationInfo.Team = TCM.Team;
						TCM.Client_NewMessage('client',"Failed to switch. Use HUT functions : !red !blue !green !yellow");
						return False;
					}
				}
				else
					TCM.TeamEntered = True;
			}
		}
 		if( !Message.default.bIsSpecial ){
			S = Message.static.GetString( Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
			if ( ClassIsChildOf(Message, class'Botpack.DeathMessagePlus') ){
				if( RelatedPRI_1 != None && RelatedPRI_2 != None ){
					if( InStr(S,RelatedPRI_1.PlayerName) < InStr(S,RelatedPRI_2.PlayerName) ){
						pre = Left(S,InStr(S,RelatedPRI_1.PlayerName));
						mid = Left(S,InStr(S,RelatedPRI_2.PlayerName));
						mid = Right(mid,Len(mid)-InStr(S,RelatedPRI_1.PlayerName)-Len(RelatedPRI_1.PlayerName));
						post = Right(S,Len(S)-InStr(S,RelatedPRI_2.PlayerName)-Len(RelatedPRI_2.PlayerName));
						for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
							TCM.Client_NewMessage('death',pre,9,RelatedPRI_1.PlayerName,RelatedPRI_1.Team,mid,9,RelatedPRI_2.PlayerName,RelatedPRI_2.Team,post,9);
					}
					else{
						pre = Left(S,InStr(S,RelatedPRI_2.PlayerName));
						mid = Left(S,InStr(S,RelatedPRI_1.PlayerName));
						mid = Right(mid,Len(mid)-InStr(S,RelatedPRI_2.PlayerName)-Len(RelatedPRI_2.PlayerName));
						post = Right(S,Len(S)-InStr(S,RelatedPRI_1.PlayerName)-Len(RelatedPRI_1.PlayerName));
						for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
							TCM.Client_NewMessage('death',pre,9,RelatedPRI_2.PlayerName,RelatedPRI_2.Team,mid,9,RelatedPRI_1.PlayerName,RelatedPRI_1.Team,post,9);
					}
				}
				else if( RelatedPRI_1 != None ){
					pre = Left(S,InStr(S,RelatedPRI_1.PlayerName));
					post = Right(S,Len(S)-InStr(S,RelatedPRI_1.PlayerName)-Len(RelatedPRI_1.PlayerName));
					for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
						TCM.Client_NewMessage('death',pre,9,RelatedPRI_1.PlayerName,RelatedPRI_1.Team,post,9);
				}
		 		else
					for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
						TCM.Client_NewMessage('death',S,9);
			}
			else
				for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
					TCM.Client_NewMessage('event',S,4);
		}
	}
	if( !Message.default.bIsSpecial ){
		if ( NextMessageMutator != None )
			NextMessageMutator.MutatorBroadcastLocalizedMessage( Sender, Receiver, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );
		return False;
	}
	else{
		if ( NextMessageMutator != None )
			return NextMessageMutator.MutatorBroadcastLocalizedMessage( Sender, Receiver, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );
		return True;
	}
}
function bool MutatorTeamMessage( Actor Sender, Pawn Receiver, PlayerReplicationInfo PRI, coerce string S, name Type, optional bool bBeep ){
	local byte t;
	local hm_ClientManager TCM;
	local PlayerPawn PSender;
	bBeep = False; // replaced by BFv sound
	// process only the first time
	if( Receiver == SetFirstPawn(Sender,Type) ){
		// muted ?
		if( Sender.IsA('Spectator') && RI.MuteSpectators && RI.GameState == 3 && !Level.Game.IsA('TeamGamePlus') ){
			TCM = GetCM(Sender);
			if( !RI.HasRight(3,TCM.PublicKey,TCM.Rights)){
				TCM.Client_NewMessage('client',"Spectators are muted while they play this match.");
				return False;
			}
		}
		if( IsSpam(PlayerPawn(Sender),S) )
			return False;
		// get it to the new hud
		if( Level.Game.IsA('TeamGamePlus') )
			t = Pawn(Sender).PlayerReplicationInfo.Team;
		else
			t = 4;
		for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
			if( Type == 'Say' || (Type == 'TeamSay' && Pawn(Sender) != None && TCM.PP != None && TCM.PP.PlayerReplicationInfo != None && TCM.PP.PlayerReplicationInfo.Team == Pawn(Sender).PlayerReplicationInfo.Team) ){
				TCM.Client_NewMessage(Type,Pawn(Sender).PlayerReplicationInfo.PlayerName$": ",t,S,9,,,,,,,Pawn(Sender).PlayerReplicationInfo.TalkTexture);
			}
		// check for cmds
		Commands(S,PlayerPawn(Sender));
	}
	// next Mutator
	if ( NextMessageMutator != None )
		NextMessageMutator.MutatorTeamMessage( Sender, Receiver, PRI, S, Type, bBeep );
	return False;
}
// spam ?	
function bool IsSpam(PlayerPawn PSender,String S){
	local hm_ClientManager TCM;
	local byte i,n,sn;
	
	if (RI.EnableAntiSpam) return false;
	
	if (PSender != None && PSender.PlayerReplicationInfo != None) {
		for (i = 0; i < MaxMsgRecord; i++) {
			if (Last_Say[i].PID == PSender.PlayerReplicationInfo.PlayerID) {
				n++;
				if (Last_Say[i].Msg == S) sn++;
				if(n > MaxAllowedMsgs || sn >= MaxDuplicateMsgs) {
					TCM = GetCM(PSender);
					if(TCM != None) {
						TCM.Client_NewMessage('client', "don't spam!");
					}
					return True;
				}
			}
		}
		for(i = 0; i < MaxMsgRecord - 1; i++) {
			Last_Say[i] = Last_Say[i + 1];
		}
		Last_Say[MaxMsgRecord - 1].PID = PSender.PlayerReplicationInfo.PlayerID;
		Last_Say[MaxMsgRecord - 1].Msg = S;
		Last_Say[MaxMsgRecord - 1].Timin = 8;
	}
	return False;
}
function Commands(String S,PlayerPawn PP){
	switch(S){
		case"!open":	case"!o":					Mutate("hz0090",PP);break;
		case"!teams":	case"!t":	case"!team":	Mutate("hz005",PP);break;
		case"!start":	case"!l":					Mutate("hz003",PP);break;
		case"!red":		case"!r":					Mutate("hz0040",PP);break;
		case"!blue":	case"!b":					Mutate("hz0041",PP);break;
		case"!green":	case"!g":					Mutate("hz0042",PP);break;
		case"!yellow":	case"!y":					Mutate("hz0043",PP);break;
		case"!vote":	case"!v":					Mutate("hz010",PP);break;
		case"!kick":	case"!k":					Mutate("hz0011",PP);break;
		case"!abort":	case"!a":					Mutate("hz0012",PP);break;
		case"!play":	case"!p":					Mutate("hz011",PP);break;
		case"!spec":	case"!s":					Mutate("hz012",PP);break;
		case "!quit":				case "!exit":	Mutate("hz013",PP); break;
		case "!leave":				case "!bye":	Mutate("hz014",PP); break;
	}
}
function Pawn SetFirstPawn(Actor Sender,Name Type){
	local byte Team;
	local Pawn P;
	if( Type == 'TeamSay' && Pawn(Sender) != None && Pawn(Sender).PlayerReplicationInfo != none ){
		Team = min(Pawn(Sender).PlayerReplicationInfo.Team,4);
		for(P=Level.PawnList;P!=None;P=P.NextPawn){
			if( P.IsA('PlayerPawn') && P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == Pawn(Sender).PlayerReplicationInfo.Team ){
				FP[Team] = PlayerPawn(P);
				return FP[Team];
			}
		}
	}
	for(P=Level.PawnList;P!=None;P=P.NextPawn){
		if( P.IsA('PlayerPawn') ){
			FP[5] = PlayerPawn(P);
			return FP[5];
		}
	}
}
//===========================================================
// TKs && Rs
function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType){
	local hm_ClientManager TCM;
	if ( Victim.IsA('PlayerPawn') && Victim.bIsPlayer )
		TCM = GetCM(Victim);
	if( TCM != None ){
		if( TCM.ShockPTime > 0 )
			ActualDamage=0;
		else if( Victim != InstigatedBy ){
			if( TCM.RsPTime > 0 && TCM.PP.PlayerReplicationInfo.HasFlag != None ){
				ActualDamage=0;
				if( IsExtDamage(DamageType) && DamageType != 'Fell' ){
					level.game.RestartPlayer(Victim);
					TCM.Client_NewMessage('client',"You have been saved (Respawning).");
				}
			}
			else if( TCM.PushPTime > 0 && IsExtDamage(DamageType) ){
				ActualDamage=0;
				if( DamageType != 'Fell' ){
					level.game.RestartPlayer(Victim);
					TCM.Client_NewMessage('client',"You have been saved (TeamKilled).");
				}
			}
			if( Level.Game.IsA('TeamGamePlus') && InstigatedBy != None && (InstigatedBy.IsA('PlayerPawn') || InstigatedBy.IsA('Bot')) && Victim.PlayerReplicationInfo.Team == InstigatedBy.PlayerReplicationInfo.Team ){
				TCM.ShockPTime = RI.ShockPTime;
				TCM.PushPTime = RI.PushPTime;
				TCM.TkerName = InstigatedBy.PlayerReplicationInfo.PlayerName;
			}
		}
	}
	if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}
function bool IsExtDamage(name damageType){
	if ( damageType == 'Burned' 
	|| damageType == 'Corroded'
	|| damageType == 'Drowned'
	|| damageType == 'Fell' )
		return True;
	return False;
}
function bool PreventDeath(Pawn Killed, Pawn Killer, name damageType, vector HitLocation){
	local hm_ClientManager TCM;
	if( DamageType != 'Suicided' ){	
		if( Killed.IsA('PlayerPawn') && Killed.bIsPlayer )
			TCM = GetCM(Killed);
		if( TCM != None ){
			if( TCM.ShockPTime > 0 ){
				if( Killed.Health < 2 )
					Killed.Health = 100;
				return True;
			}if( Killer != Killed ){
				if( Killer == None ){
					if( TCM.RsPTime > 0 || TCM.ShockPTime > 0 || TCM.PushPTime > 0 ){
						level.game.RestartPlayer(Killed);
						if( TCM.RsPTime > 0 )
							TCM.Client_NewMessage('client',"You have been saved (Respawning).");
						else
							TCM.Client_NewMessage('client',"You have been saved (TeamKilled).");
						if( Killed.Health < 2 )
							Killed.Health = 100;
						return True;
					}
				}
				else if( TCM.RsPTime > 0 || TCM.ShockPTime > 0 ){
					if( Killed.Health < 2 )
						Killed.Health = 100;
					return True;	
				}
				else if( TCM.PushPTime > 0 && Killer.PlayerReplicationInfo != None && Killer.PlayerReplicationInfo.Team == Killed.PlayerReplicationInfo.Team ){
					if( Killed.Health < 2 )
						Killed.Health = 100;
					return True;	
				}
			}
		}
	}
	if ( NextMutator != None && NextMutator.PreventDeath(Killed, Killer, damageType, HitLocation) )
		return true;
	return False;
}
function ModifyPlayer(Pawn Other){
	local int i,j,k,l;
	local string st;
	local hm_ClientManager TCM;
	TCM = GetCM(Other);
	if( TCM != None )
		TCM.Respawn();
	// loading to playing
	if( RI.GameState < 2 ){
		if( RI.IsMatch )
			RI.GameState = 3;
		else
			RI.GameState = 2;
		for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
			TCM.Client_PlaySound(sound'hut8cc.startfight');
	}
	// CHECKING SKIN - FIX
	if( Other == None || Other.PlayerReplicationInfo == None )
		return;
	if( Other.PlayerReplicationInfo.Team > 3 || !Level.Game.IsA('TeamGamePlus') )
		return;
	for(j=0;j<4;j++){
		if( Other.PlayerReplicationInfo.Team == j ){
			for(i=0;i<6;i++){
				if( Other.multiSkins[i] != None ){
					for(l=0;l<4;l++){
						k = InStr(Other.multiSkins[i],"T_"$l);
						// mayhem fix
						if( k == -1 ){
							k = InStr(Other.multiSkins[i], "t_"$l);
							if( k != -1 && j != l ){
								st=left(Other.multiSkins[i],k)$"t_"$j;
								hlog("SKIN-FIX:"@Other.PlayerReplicationInfo.PlayerName,'all');
								Other.multiSkins[i] = Texture(DynamicLoadObject(st,class'Texture'));
							}
						}
						else if( k != -1 && j != l ){
							st=left(Other.multiSkins[i],k)$"T_"$j;
							hlog("SKIN-FIX:"@Other.PlayerReplicationInfo.PlayerName,'all');
							Other.multiSkins[i] = Texture(DynamicLoadObject(st,class'Texture'));
						}
					}
				}
			}
		}
	}
	// client side ?
	for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
		TCM.Client_SkinFix(Other);
	// next
	if ( NextMutator != None )
		NextMutator.ModifyPlayer(Other);
}
//===========================================================
// Login
function ModifyLogin(out class<PlayerPawn> SpawnClass,out string Portal,out string Options){
	local String PublicKey,Password,NormalClass,OverRideClass,PlayerName;
	PlayerName = Level.Game.ParseOption(Options,"Name");
	OverRideClass = caps(Level.Game.ParseOption(Options,"OverrideClass"));
	NormalClass = Level.Game.ParseOption(Options,"Class");
	PublicKey = caps(Level.Game.ParseOption(Options,"HUTPublicKey"));
	Password = caps(Level.Game.ParseOption(Options,"HUTPassword"));
	if( len(PublicKey) == 32 )
		PostCheck(PlayerName,PublicKey,True);
	// reserved slots
	if( OverRideClass == "HUT8CC.HSP_SPECTATOR" ){
		if( Level.Game.NumPlayers >= RI.PlayersLimit ){
			SpawnClass = class'CHSpectator';
			hlog("The VIP Access has been refused for"@PlayerName@"(server full).",'all');
		}
		else if( !RI.HasRight(5,PublicKey) ){
			SpawnClass = class'CHSpectator';
			hlog("The VIP Access has been refused for"@PlayerName@"(access denied).",'all');
		}
		else{
			SpawnClass = class<PlayerPawn>(DynamicLoadObject(NormalClass,class'Class'));
			hlog(PlayerName@"joined as VIP.",'all');
		}
	}
	// match 
	if( RI.IsMatch && SpawnClass != class'CHSpectator' ){
		if( RI.Password != "" && caps(RI.Password) != Password && (RI.HasRight(3,PublicKey) || RI.AcceptSpectators) ){
			SpawnClass = class'CHSpectator';
			hlog(PlayerName@"had a wrong password, he joined as spectator.",'all');
		}
		if( RI.GameState == 3 && Level.Game.NumPlayers == RI.DesiredPlayers ){
			SpawnClass = class'CHSpectator';
			hlog("The server is full,"@PlayerName@"joined as spectator.",'all');
		}
	}
	// next ?
	if ( NextMutator != None )
		NextMutator.ModifyLogin(SpawnClass,Portal,Options);
}
function bool PostCheck(String PlayerName,String PublicKey,optional bool bIN){
	local int i;
	if( bIN ){
		for(i=0;i<32;i++){
			if( PlayerName == "" ){
				PostCheck_PlayerName[i] = PlayerName;
				PostCheck_PublicKey[i] = PublicKey;
				return True;
			}
		}
		return False;
	}
	for(i=0;i<32;i++){
		if( (PlayerName == PostCheck_PlayerName[i] && PublicKey != PostCheck_PublicKey[i]) 
		|| (PlayerName != PostCheck_PlayerName[i] && PublicKey == PostCheck_PublicKey[i]) ){
			PostCheck_PlayerName[i] = "";
			PostCheck_PublicKey[i] = "";
			return False;
		}
		else if( PlayerName == PostCheck_PlayerName[i] && PublicKey == PostCheck_PublicKey[i] ){
			PostCheck_PlayerName[i] = "";
			PostCheck_PublicKey[i] = "";
			return True;
		}
	}
	return True;
}
//===========================================================
// Client Management
function hm_ClientManager GetCM(Actor A){
	local hm_ClientManager TCM;
	for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
		if( TCM.Owner == A )
			return TCM;
	return None;
}
function NewClient(Actor A){
	local hm_ClientManager TCM,NCM;
	if( GetCM(A) != None )
		return;
	NCM = spawn(class'hm_ClientManager',A);
	NCM.SM = Self;
	if( CM == None )
		CM = NCM;
	else{
		for(TCM=CM;TCM!=None;TCM=TCM.PostCM){
			if( TCM.PostCM == None ){
				TCM.PostCM = NCM;
				TCM.PostCM.PreCM = TCM;
				break;
			}
		}
	}
}

/**
 *
 */
function hm_ClientManager getCMbyId(int playerID) {
	local hm_ClientManager TCM;
		
	for (TCM = CM; TCM != none; TCM = TCM.postCM) {
		if (TCM.owner != none && TCM.PP != none && TCM.PP.playerReplicationInfo.playerID == playerID) {
			return TCM;
		}
	}
	
	return none;
}

//===========================================================
// game Management
function PlayerLeft(bool IsSpectator,String PlayerName,String PublicKey,int LastFrags,byte PlayerID,byte Team,string ip,int StartTime){
	local hm_ClientManager TCM;
	local int i;
	i = RI.DelVote(PublicKey);
	if( !IsSpectator )
		RI.AddFC(PublicKey,LastFrags,StartTime);
	if( CM != None )
		for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
			if( TCM.Owner != None )
				TCM.Client_PlayerEvent(IsSpectator,true,PlayerName,i,PlayerID,PublicKey,Team,ip);
}
function bool HandleEndGame(){
	if(CheckForTie())
		return false;
	if(Level.Game.IsA('Assault')){
	   if( !Assault(Level.Game).bDefenseSet )
	      return false;
	   else
	      Assault(Level.Game).ResetGame();
	}
	// set vote
	RI.GameState = 5;
	if ( NextMutator != None )
		return NextMutator.HandleEndGame();
	return false;
}
function StartMatch(hm_ClientManager TCM){
	local Pawn P;
	// not during match w/ admins
	if( RI.GameState < 1 ){ // && Level.Game.NumPlayers > 0 
		if( RI.IsMatch && Level.Game.NumPlayers != RI.DesiredPlayers ){
			TCM.Client_NewMessage('Notice',"Only"@Level.Game.NumPlayers@"players ingame,"@RI.DesiredPlayers@"are required!");
			return;
		}
		RI.GameState = 1;
		for(P=level.pawnlist; P!=none ; P=P.nextpawn)
			if ( P.IsA('PlayerPawn') )
				PlayerPawn(P).bReadyToPlay = True;
		DeathMatchPlus(Level.Game).bNetReady = True;
		DeathMatchPlus(Level.Game).CountDown = -1;
		DeathMatchPlus(Level.Game).StartCount = 30;
		DeathMatchPlus(Level.Game).ElapsedTime = DeathMatchPlus(Level.Game).NetWait+1;
		DeathMatchPlus(Level.Game).Timer();
		Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has launched the game!");
	}
}
//===========================================================
// balance team
function bool BalanceTeams(hm_ClientManager TCM,optional bool bRecursiv){
	local byte i,j,T[4];
	local bool b;
	local Pawn P;
	local TeamGamePlus TGP;
	TGP = TeamGamePlus(Level.Game);
	if( TGP == None ){
		TCM.Client_NewMessage('client',"This command is only available for TeamGame.");
		return False;
	}
	for(P=Level.PawnList;P!=None;P=P.NextPawn)
		if( (P.IsA('PlayerPawn') && !P.IsA('Spectator')) || P.IsA('Bot') )
			T[P.PlayerReplicationInfo.Team]++;
	// TGP.Teams[].Size, is that sure ? 
	// check
	for(i=0;i<TGP.MaxTeams;i++)
		for(j=0;j<TGP.MaxTeams;j++)
			if( T[j] < T[i]-1 )
				return ProcessBalanceTeams(TCM,i,j);
			else if( T[i] < T[j]-1 )
				return ProcessBalanceTeams(TCM,j,i);
	if( !bRecursiv )
		TCM.Client_NewMessage('client',"Teams seem to be balanced.");
	return False;
}
function bool ProcessBalanceTeams(hm_ClientManager TCM,byte from,byte to){
	local hm_ClientManager iTCM,sTCM;
	local Pawn P,Switcher;
	//get the last switcher
	if( LastSW != None && LastSW.PP != None && LastSW.PP.PlayerReplicationInfo != None && LastSW.PP.PlayerReplicationInfo.Team == from && LastSW.PP.PlayerReplicationInfo.HasFlag == None )
		Switcher = LastSW.PP;
	else	
		for(P=Level.PawnList;P!=None;P=P.NextPawn)
			if( P.IsA('PlayerPawn') && !P.IsA('Spectator') && P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == from && P.PlayerReplicationInfo.HasFlag == None ){
				Switcher = P;
				break;
			}
	if( Switcher != None ){
		sTCM = GetCM(Switcher);
		if( sTCM != None ){
			sTCM.SwitchTeam(to,CM);
		}
		else{
			level.game.ChangeTeam(Switcher,to);
			Switcher.Died(None,'',Switcher.Location);
			level.game.RestartPlayer(Switcher);
			Switcher.PlayerReplicationInfo.Team = to;
		}
		Message2All("TeamBalancer:"@Switcher.PlayerReplicationInfo.PlayerName@"is now in"@TeamName[to]);
		BalanceTeams(TCM,True);
		return True;
	}
	hlog("The server failed to balance Teams!",'system');
	return False;
}
//===========================================================
// broadcast
function Message2All(String Message){
	local hm_ClientManager TCM;
	for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
		TCM.Client_NewMessage('all',Message);
}
//===========================================================
//===========================================================
// commands
//===========================================================
function Mutate(string MutateString, PlayerPawn Sender){
	local hm_ClientManager TCM,iTCM,sTCM,targetCM;
	local Pawn P;
	local int i,j;
	local String cmd,para,Maps,publickey,rights,name,ip,reason;
	local byte R,gVote,mVote;
	local String gameName, msg;
	local int teamColor, playerID;
	if( Sender == None ) return;
	if( Mid(MutateString,0,2) != "hz" || RI.GameState > 5 ){
		if ( NextMutator != None )
			NextMutator.Mutate(MutateString,Sender);
		return;
	}
	R = byte(Mid(MutateString,2,1));
	cmd = Mid(MutateString,3,2);
	para = Mid(MutateString,5,len(MutateString)-5);
	TCM = GetCM(Sender);
	// new admin
	if( MutateString == "hz" ){
		if( TCM.PP.PlayerReplicationInfo.bAdmin ){
			i = RI.AddUser("hz",TCM.PublicKey,TCM.SharedKey,TCM.PP.PlayerReplicationInfo.PlayerName,RI.AdminRights);
			if( i < RI.mu ){
				TCM.Account = i;
				TCM.Rights = RI.AdminRights;
				TCM.Client_NewMessage('client',"You are now HUT Admin.");
				TCM.Client_WindowSet(False);
				TCM.Client_ReturnedRights(TCM.PublicKey,TCM.SharedKey,i,TCM.Rights);
				TCM.Client_winm("The server gave you full-power. You are now able to set the server with HUT."
								,"You have to reconnect to complete the installation of the UserList."
								,"For any help or request, contact mike@hez-studios.net"
								,"Thank you for using HeZ-UT.");
			}
			else
				TCM.Client_NewMessage('client',"The Users List is full, please delete one user before.");
		}
		else 
			TCM.Client_NewMessage('client',"Please log as ServerAdmin first.");
		return;
	}
	if( !RI.HasRight(R,TCM.PublicKey,TCM.Rights) ){
		TCM.Client_NewMessage('client',"You are not allowed to execute this command.");
		hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
		return;
	}
	switch(R){
		case 0: // Everyone ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // kickvote
					i = byte(Mid(para,0,1)); 			// mod
					j = byte(Mid(para,1,3)); 			// PlayerID
					if( i == 1 ){		// !kick
						if( RI.KickedKey != "" ){ // current
							if( j > 0 ){
								TCM.Client_NewMessage('client',"Abort the current kickvote with !abort before you can revote.");
								return;
							}
							if( !RI.KickVoteList(TCM.PublicKey) ){
								TCM.Client_NewMessage('client',"You have already voted for the current kickvote.");
								return;
							}
							RI.KickedAmmount++;
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"kickvoted"@RI.KickedName);
							if( RI.KickedAmmount > Level.Game.NumPlayers/2 ){
								for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
									if( iTCM.PublicKey == RI.KickedKey )
										break;
								// kick him
								j = RI.KickedDelay;
								if( iTCM != None ){
									iTCM.Client_winm("You have been kicked by the server"
													,"Reason : Majority (KickVote)"
													,"You were kicked for"@j@"games.");
									iTCM.Client_ConsoleCommand("disconnect");
								}
								if( j > 0 ){
									i = RI.UpdateBan(RI.KickedName,RI.KickedIP,RI.KickedKey,j);
									if( i >= 0 )
										reason = "for"@j@"game(s)";
								}
								Message2All(RI.KickedName@"has been kicked"$reason$".");
								hlog(RI.KickedName@"has been kicked by KickVote",'all');
								// update ban
								if( j != 0 )
									for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
										if( iTCM.Owner != None )
											iTCM.Client_UdpateBan(RI.BannedName[i],RI.BannedIP[i],RI.BannedTime[i]);
								// delete the current kickvote
								RI.KickedName = "";
								RI.KickedKey = "";
								RI.KickedAmmount = 0;
								RI.KickVoteList("");
							}
						}
						else{ // new one
							if( j > 0 ){
								for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
									if( iTCM.PP.PlayerReplicationInfo.PlayerID == j )
										break;
								if( RI.HasRight(4,iTCM.PublicKey,iTCM.Rights) ){
									TCM.Client_NewMessage('client',"You cannot kick a moderator.");
									return;
								}
								if( iTCM == None ){
									TCM.Client_NewMessage('client',"Player not found.");
									return;
								}
								RI.KickedName = iTCM.PP.PlayerReplicationInfo.PlayerName;
								RI.KickedKey = iTCM.PublicKey;
								RI.KickedIP = iTCM.IP;
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"wants to KickVote"@RI.KickedName);
							}
							else{
								TCM.Client_NewMessage('client',"Run KickVote before voting!");
								TCM.Client_Window(2);
							}
						}
					}
					else if( i == 2 ){	// !abort
						if( RI.KickedKey != "" ){
							if( TCM.PublicKey == RI.KickedKey ){
								TCM.Client_NewMessage('client',"You cannot abort your own KickVote.");
								return;
							}
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has aborted the KickVote against"@RI.KickedName);
							RI.KickedName = "";
							RI.KickedKey = "";
							RI.KickedAmmount = 0;
							RI.KickVoteList("");
						}
						else
							TCM.Client_NewMessage('client',"Kickvote is already inactiv.");
					}
				return;
				case "02": // idle
					TCM.Client_winm("You have been kicked by the server."
									,"Reason : sleeping / camping"
									,"You can reconnect as soon as you are back.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has been kicked for sleeping / camping.",'all');					
					TCM.Client_ConsoleCommand("disconnect");
				return;
				case "03": // start the match
					if( RI.WaitingTime <= 0 && (!RI.HasAdmin || RI.HasRight(3,TCM.PublicKey,TCM.Rights)) )
						StartMatch(TCM);
				return;
				case "04": // switch team
					i = int(para);
					if( Sender.PlayerReplicationInfo.Team == i || i >= TeamGamePlus(Level.game).MaxTeams || Sender.IsA('CHSpectator') || !Level.game.bTeamGame ){
						TCM.Client_NewMessage('client',"Failed to switch.");
						return;
					}
					if( TCM.SWTime > 0 ){
						TCM.Client_NewMessage('client',"You have to wait"@TCM.SWTime@"secondes before you can change of team.");
						return;
					}
					if( TCM.nSwitch > RI.SWMax && RI.SWMax > 0 ){
						TCM.Client_NewMessage('client',"You cannot switch more than"@RI.SWMax@"times.");
						return;
					}
					LastSW = TCM;
					TCM.nSwitch++;
					TCM.SWTime = RI.SWTime;
					TCM.SwitchTeam(i,CM);
					Message2All(Sender.PlayerReplicationInfo.PlayerName@"is now in"@TeamName[i]);
				return;
				case "05": //balance team
					if( RI.WaitingTime > 0 )
						TCM.Client_NewMessage('client',"Please wait"@int(RI.WaitingTime)@"secondes.");
					else
						BalanceTeams(TCM);
				return;
				case "06": // view by
					i = byte(para);
					if( i == 0 || TCM.PP.PlayerReplicationInfo.PlayerID == i ){
						TCM.PP.ViewTarget = None;
						TCM.PP.bBehindView = False;
					}
					else
						for(P=level.pawnlist; P!=none ; P=P.nextpawn)
							if( P.PlayerReplicationInfo.PlayerID == i ){
								if( (P.IsA('PlayerPawn') && !P.IsA('Spectator')) || P.IsA('Bot') ){
									if( TCM.IsSpectator || !Level.Game.IsA('TeamGamePlus') || P.PlayerReplicationInfo.Team == TCM.PP.PlayerReplicationInfo.Team ){
										TCM.PP.ViewTarget = P;
										TCM.PP.bBehindView = True;
									}
									else
										TCM.Client_NewMessage('client',"Failed to change view.");
								}
								break;
							}
				return;
				case "07": // vote /hez007"$i$UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).MapName
					if( RI.WaitingTime > 0 ){
						TCM.Client_NewMessage('client',"Please wait"@int(RI.WaitingTime)@"secondes.");
						return;
					}
					
					if (RI.GameVoteList(TCM.PublicKey) && RI.GameState > 1 && RI.GameState < 5) {
						RI.GvVote++;
						if( RI.GvVote > Level.Game.NumPlayers/2 ){
							RI.GameVoteList("");
							RI.GvVote = 0;
							RI.GameState = 5;
						}
					}
					
					gVote = byte(Mid(para,0,1));
					mVote = byte(Mid(para,1,3));
					// old vote
					j = RI.GetVoteID(TCM.PublicKey);
					// new vote
					i = RI.NewVote(TCM.PublicKey,gVote,mVote);
					switch( i ){
						case -5 : TCM.Client_NewMessage('client',"This is the same Vote."); return;
						case -4 : TCM.Client_NewMessage('client',"You are only allowed to emit"@RI.MaxVote@"vote(s)."); return;
						case -3 : TCM.Client_NewMessage('client',"MapVote is not enabled for this game."); return;
						case -2 : TCM.Client_NewMessage('client',"Erroneous Vote."); return;
						case -1 : TCM.Client_NewMessage('client',"This map is temporarly disabled."); return;
						default:
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"voted for ["$RI.GameLabel[gVote]$"] ["$RI.GetGmap(gVote,mVote)$"]");
							for(TCM=CM;TCM!=None;TCM=TCM.PostCM){
								if( j > 0 ) // delete old 
									TCM.Client_UpdateVote(True,j,0,0);
								TCM.Client_UpdateVote(False,i,gVote,mVote);
							}
						return;
					}
				return;
				case "08": // annouce ban
					Message2All(para@"has been rejected by the server.");
					hlog(para@"has been rejected by the server.",'all');
				return;
				case "09": // open window
					TCM.Client_Window(byte(para));
				return;
				case "10": // gamevote request
					if( RI.GameState > 1 && RI.GameState < 5 ){
						if( !RI.GameVoteList(TCM.PublicKey) ){
							TCM.Client_NewMessage('client',"You have already voted.");
							return;
						}
						RI.GvVote++;
						Message2All(TCM.PlayerName@"wants to run GameVote.");
						TCM.Client_Window(1);
						if( RI.GvVote > Level.Game.NumPlayers/2 ){
							RI.GameVoteList("");
							RI.GvVote = 0;
							RI.GameState = 5;
						}
					}
					else
						TCM.Client_NewMessage('client',"This command is only available while playing.");
				return;
				case "11": // play
					TCM.Client_Play(1);
				return;
				case "12": // spec
					TCM.Client_Play(0);
				return;
				case "13": // quit ut
					TCM.Client_ConsoleCommand("exit");
				return;
				case "14": // leave server
					TCM.Client_ConsoleCommand("disconnect");
				return;
				
				
				// Private message system.
				case "15": // block player
					if (!RI.EnablePMSystem) {
						TCM.Client_NewMessage('client', "The private messaging system has been disabled.");
						return;
					}
					
					targetCM = getCMbyID(int(para));
					if (targetCM == none) {
						name = "unknown player";
					} else {
						name = targetCM.playerName;
					}
					
					if (isBlocked(TCM, para)) {
						TCM.Client_NewMessage('client', "Unable to block" @ name $ ", player is already blocked.");
					} else if (blockPlayer(TCM, targetCM.publicKey)) {
						TCM.Client_NewMessage('client', name @ "has been blocked.");
					} else {
						TCM.Client_NewMessage('client', "Unable to block" @ name $", the block list is full.");
					}
				return;
				
				case "16": // unblock player
					if (!RI.EnablePMSystem) {
						TCM.Client_NewMessage('client', "The private messaging system has been disabled.");
						return;
					}
					
					targetCM = getCMbyID(int(para));
					if (targetCM == none) {
						name = "unknown player";
					} else {
						name = targetCM.playerName;
					}
					
					if (unblockPlayer(TCM, targetCM.publicKey)) {
						TCM.Client_NewMessage('client', name @ "has been unblocked.");
					} else {
						TCM.Client_NewMessage('client', "Unable to unblock" @ name $", player is not blocked.");
					}
				return;
				
				case "17": // send pm
					if (!RI.EnablePMSystem) {
						TCM.Client_NewMessage('client', "The private messaging system has been disabled.");
						return;
					}
					
					if (inStr(para, ",") < 0) return;
					
					playerID = int(left(para, inStr(para, ",")));
					msg = right(para, len(para) - inStr(para, ",") - 1);
					targetCM = getCMbyId(playerID);
					
					if (targetCM == none) {
						TCM.Client_NewMessage('Notice', "Failed to send your private message.");
					} else if (!isBlocked(targetCM, TCM.publicKey)) {
						TCM.Client_NewMessage('Say', "PM send to ", 4, targetCM.PP.playerReplicationInfo.playerName $ ": ", targetCM.getTeamColor(), msg, 9);
						targetCM.receivePM(msg, publicKey, TCM.PP.playerReplicationInfo.playerName, TCM.getTeamColor());
					} else {
						TCM.Client_NewMessage('Notice', targetCM.PP.playerReplicationInfo.playerName @ "has blocked your private message.");
					}
					
				return;
				
				default: // unknown
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}			
		return;
		case 1: // GameAdmin ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // del game
					i = byte(para);
					RI.GameLabel[i] = "";
					RI.GameClass[i] = "";
					RI.Mutators_Name[i] = "";
					RI.Mutators[i] = "";
					RI.MapVote[i] = 0;
					for(j=0;j<100;j++)
						RI.SetGmap(i,j,"");
					TCM.Client_NewMessage('client',"The game"@RI.GameLabel[i]@"has been deleted.");
					RI.SaveConfig();
					for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
						if( TCM.Owner != None )
							TCM.Client_DelGame(i);
				return;
				case "02": // add game /hz102i"$GameTypeS.GetValue2()$","$GameLabelE.GetValue()
					/*
					i = byte(Mid(para,0,1));
					para = Mid(para,1,len(para)-1);
					for(j=0;j<8;j++){
						if( RI.GameLabel[j] == "" || RI.GameClass[j] == "" ){
							LG = j;
							LG_Map = 0;
							RI.MapVote[LG] = i;
							RI.GameLabel[LG] = Right(para,len(para)-InStr(para,",")-1);
							RI.GameClass[LG] = Left(para,InStr(para,","));
							TCM.Client_NewMessage('client',"The game"@RI.GameLabel[LG]@"has been added.");
							return;
						}
					}
					// no slots available
					TCM.Client_NewMessage('client',"The game"@Right(para,len(para)-InStr(para,",")-1)@"has NOT been added. Only 8 differents games can be set, delete one first.");
					LG = -1;
					*/
					para = Mid(MutateString, 5, len(MutateString) - 5);
					i = byte(Mid(para, 0, 1));
					para = Mid(para, 1, len(para) - 1);
					gameName = Right(para, len(para) - InStr(para, ",") - 1);
					isGameConfigUpdate = false;
					LG = -1;
					
					// Search for game to update
					for(j = 0; j < 8; j++) {
						if (RI.GameLabel[j] == gameName) {
							isGameConfigUpdate = true;
							LG = j;
							break;
						}
					}
					
					// Search for a free slot if not updating
					if (!isGameConfigUpdate) {
						for(j = 0; j < 8; j++) {
							if (RI.GameLabel[j] == "" || RI.GameClass[j] == "") {
								LG = j;
								break;
							}
						}
					}
					
					// Check if a slot has been found
					if (LG == -1) {
						TCM.Client_NewMessage('client',"The game"@Right(para,len(para)-InStr(para,",")-1)@"has NOT been added. Only 8 differents games can be set, delete one first.");
						return;
					}
					
					// Setup for update/add
					LG_Map = 0;
					LG_Mutate = 0;
					RI.MapVote[LG] = i;
					RI.GameLabel[LG] = Right(para, len(para) - InStr(para, ",") - 1);
					RI.GameClass[LG] = Left(para, InStr(para, ","));
					if (isGameConfigUpdate) {
						// Clear old data
						RI.Mutators_Name[LG] = "";
						RI.Mutators[LG] = "";
						for (j = 0; j < 100; j++) {
							RI.SetGmap(LG, j, "");
						}
						
						TCM.Client_NewMessage('client', "The game" @ gameName @ "has been updated.");
					} else {
						TCM.Client_NewMessage('client', "The game" @ gameName @ "has been added.");
					}
				return;
				case "03": // mutators /hz103"$UMenuMapList(Items).MapName$","$UMenuMapList(Items).DisplayName);
					if( LG != -1 && InStr(para,",") != -1 && LG_Mutate < 16 ){
						if( RI.Mutators[LG] != "" ){
							RI.Mutators_Name[LG] = RI.Mutators_Name[LG]$","$Right(para,len(para)-InStr(para,",")-1);
							RI.Mutators[LG] = RI.Mutators[LG]$","$Left(para,InStr(para,","));
						}
						else{
							RI.Mutators_Name[LG] = Right(para,len(para)-InStr(para,",")-1);
							RI.Mutators[LG] = Left(para,InStr(para,","));
						}
						LG_Mutate++;
					}
				return;
				case "04": // maps /hz104"$UMenuMapList(Items).DisplayName
					if( LG != -1 && len(para) > 3 && LG_Map < 100 ){
						RI.SetGmap(LG,LG_Map,para);
						LG_Map++;
					}
				return;
				case "05": // command lines
					if( LG != -1 ){
						i = byte(Mid(para,0,1));
						if( i == 1 )
							RI.GameCmdBeg[LG] = Mid(para,1,len(para)-1); 
						else if( i == 2 )
							RI.GameCmdEnd[LG] = Mid(para,1,len(para)-1);
					}
				return;
				case "06": // game add /save/end
					/*
					if( LG != -1 ){
						for(i=0;i<RI.MaxMap;i++)
							RI.LastMap[i] = "";
						RI.SaveConfig();
						for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
							if( TCM.Owner != None )
								TCM.Client_AddGame(LG);
					}
					*/
					if (LG != -1) {
						for(i = 0; i < RI.MaxMap; i++) {
							RI.LastMap[i] = "";
						}
						RI.SaveConfig();
						for(TCM = CM; TCM != None; TCM = TCM.PostCM) {
							if(TCM.Owner != None) {
								if (isGameConfigUpdate) {
									TCM.Client_UpdateGame(LG);
								} else {
									TCM.Client_AddGame(LG);
								}
							}
						}
					}
				return;
				case "07": // set TIMES
					RI.ShockPTime = byte(Mid(para,0,2));
					RI.PushPtime = byte(Mid(para,2,2));
					RI.RsPTime = byte(Mid(para,4,2));
					RI.MutedTime = byte(Mid(para,6,2));
					RI.SWTime = byte(Mid(para,8,3));
					RI.MaxIdle = byte(Mid(para,11,3));
					RI.PlayersLimit = byte(Mid(para,14,2));
					RI.MaxVote = byte(Mid(para,16,2));
					RI.ScoreBoardDelay = byte(Mid(para,18,2));
					RI.VoteDelay = byte(Mid(para,20,2));
					RI.WaitingTimeConfig = byte(Mid(para,22,2));
					RI.MaxMap = byte(Mid(para,24,2));
					RI.RespawnTime = byte(Mid(para,26,2));
					RI.AutoReconnectTime = byte(Mid(para,28,2));
					RI.KickedDelay = byte(Mid(para,30,2));
					RI.bForceRespawn = I2B(byte(Mid(para,32,1)));
					RI.SWMax = byte(Mid(para,33,2));
					// misc
					if( RI.RespawnTime <= 1 )
						DeathMatchPlus(Level.Game).bForceRespawn = RI.bForceRespawn;
					else
						DeathMatchPlus(Level.Game).bForceRespawn = False;
					ScoreBoardDelay = RI.ScoreBoardDelay;
					RI.RemainingTime = RI.VoteDelay;
				return;
				case "08": // set ILLLEGALS && news
					if( byte(Mid(para,0,1)) == 1 )
						RI.Illegal[byte(Mid(para,1,1))] = Mid(para,2,len(para)-2);
					else
						RI.News[byte(Mid(para,1,1))] = Mid(para,2,len(para)-2);
				return;				
				case "09": // set SAVE 
					RI.SaveConfig();
					TCM.Client_NewMessage('client',"New Setting Saved.");
					for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
						if( TCM.Owner != None )
							TCM.Client_UpdateConfig();
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		case 2: // UserAdmin ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // add by publickey /hz201"$left(PublicKeyL.Text$"00000000000000000000000000000000",32)$left(r$"00000000",8)$PlayerNameE.GetValue()
					publickey = Mid(para,0,32);
					rights = Mid(para,32,10);
					name = Mid(para,42,len(para)-40);
					// no original by this way !
					if( byte(Mid(rights,0,1)) > 0 ){
						TCM.Client_NewMessage('client',"You cannot create a General Administrator.");
						return;
					}
					i = RI.mu;
					// online update
					for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
						if( iTCM.PublicKey == publickey ){
							// checking admin rights
							if( iTCM == TCM ){
								TCM.Client_NewMessage('client',"You cannot edit your own account.");
								return;
							}
							if( !RI.CanEditUser(TCM.Rights,iTCM.Rights) ){
								TCM.Client_NewMessage('client',"This user has more rights than you, you cannot edit him.");
								return;
							}
							for(i=0;i<10;i++){
								if( byte(Mid(TCM.Rights,i,1)) == 0 && byte(Mid(rights,i,1)) != byte(Mid(iTCM.Rights,i,1)) ){
									TCM.Client_NewMessage('client',"You cannot modify a right you do not have.");
									return;
								}
							}
							ip = iTCM.ip;
							i = RI.AddUser(TCM.Rights,iTCM.PublicKey,iTCM.SharedKey,name,rights);
						}
					// offline update
					if( i == RI.mu ){
						i = RI.AddUser(TCM.Rights,publickey,"",name,rights);
						if( i == -1 ){
							TCM.Client_NewMessage('client',"This user has more rights than you, you cannot edit him.");
							return;
						}
					}
					if( i < RI.mu ){
						TCM.Client_NewMessage('client',"The"@RI.PlayerName[i]@"'s account has been successfully updated.");
						// user online ?
						for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM){
							if( iTCM.PublicKey == publickey && iTCM.Owner != None ){
								iTCM.Account = i;
								iTCM.Rights = rights;
								iTCM.Client_NewMessage('client',TCM.PP.PlayerReplicationInfo.PlayerName@"has created/updated your account.");
								iTCM.Client_WindowSet(False);
								iTCM.Client_ReturnedRights(iTCM.PublicKey,iTCM.SharedKey,i,iTCM.Rights);
								iTCM.Client_winm(TCM.PP.PlayerReplicationInfo.PlayerName@"has created/updated your account"
												,"Here are your new rights."
												,"For any help, contact your server-admin:"@Level.Game.GameReplicationInfo.AdminName
												,"Thank you for using HeZ UT.");
								for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
									iTCM.Client_PlayerEvent(TCM.IsSpectator,False,TCM.PlayerName,-1,TCM.PP.PlayerReplicationInfo.PlayerID,TCM.PublicKey,TCM.PP.PlayerReplicationInfo.Team,TCM.ip);

							}
							iTCM.Client_UpdateUser(publickey,False,i,name,rights,ip);
						}
					}
					else
						TCM.Client_NewMessage('client',"The User List is full or the User has not been found.");
				return;
				case "02": // del by publickey /hz202"$PublicKeyL.Text
					publickey = para;
					for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM){
						if( iTCM.PublicKey == publickey ){
							if( iTCM == TCM ){
								TCM.Client_NewMessage('client',"You cannot edit your own account.");
								return;
							}
							if( !RI.CanEditUser(TCM.Rights,iTCM.Rights) ){
								TCM.Client_NewMessage('client',"This user has more rights than you, you cannot edit him.");
								return;
							}
						}
					}
					i = RI.delUser(publickey);
					if( i < RI.mu ){
						TCM.Client_NewMessage('client',"The User has been deleted.");
						// user online + update usermin
						for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM){
							if( iTCM.PublicKey == publickey ){
								iTCM.Account = RI.mu;
								iTCM.Rights = RI.DefaultRights;
								iTCM.Client_NewMessage('client',""@TCM.PP.PlayerReplicationInfo.PlayerName@"has deleted your account.");
								iTCM.Client_WindowSet(False);
								iTCM.Client_ReturnedRights(iTCM.PublicKey,iTCM.SharedKey,i,iTCM.Rights);
								iTCM.Client_winm(TCM.PP.PlayerReplicationInfo.PlayerName@"has deleted your account"
													,"Browse the client window to know your new rights."
													,"If you need help, contact your server administrator."
													,"Thank you for using HeZ UT.");
								iTCM.Client_ConsoleCommand("Disconnect");
							}
							iTCM.Client_UpdateUser(publickey,True);
						}
					}
					else
						TCM.Client_NewMessage('client',"The User has not been found.");
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 3: // MatchAdmin ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": //action on players
					i = byte(Mid(para,2,3)); // PlayerID
					for(sTCM=CM;sTCM!=None;sTCM=sTCM.PostCM){
						if( sTCM.PP.PlayerReplicationInfo.PlayerID == i ){
							switch( byte(Mid(para,0,2)) ){ // "XX" cmd
								case 1:	// switch
									if( sTCM.IsSpectator ){
										TCM.Client_NewMessage('client',sTCM.PP.PlayerReplicationInfo.PlayerName@"is a spectator.");
										return;
									}
									j = sTCM.PP.PlayerReplicationInfo.Team+1;
									if( j >= TeamGamePlus(Level.Game).MaxTeams )
										j = 0;
									sTCM.SwitchTeam(j,CM);
									Message2All(TCM.PP.PlayerReplicationInfo.PlayerName$":"@sTCM.PP.PlayerReplicationInfo.PlayerName@"is now in"@TeamName[j]);		
								break;
								case 2:	// sent password
									sTCM.NewPassword(TCM.PP.PlayerReplicationInfo.PlayerName);
									if( TCM != sTCM )
										TCM.Client_NewMessage('client',sTCM.PP.PlayerReplicationInfo.PlayerName@"has received the password.");
									hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has sent the password to"@sTCM.PP.PlayerReplicationInfo.PlayerName,'all');
								break;
								case 3:	// reconnect as spectator
									hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has reconnected"@sTCM.PP.PlayerReplicationInfo.PlayerName,'all');
									sTCM.Client_CloseW();
									sTCM.Client_Play(0);
								break;
								case 4:	// reconnect as player
									hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has reconnected"@sTCM.PP.PlayerReplicationInfo.PlayerName,'all');
									sTCM.Client_CloseW();
									sTCM.Client_Play(1);
								break;
								case 5:	// connect to another server
									ip = Right(para,len(para)-5);
									// check IP and save it									
									if( RI.IsAValidIP(ip) ){
										hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has sent"@sTCM.PP.PlayerReplicationInfo.PlayerName@"to"@ip,'all');
										Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has sent"@sTCM.PP.PlayerReplicationInfo.PlayerName@"to"@ip);	
										sTCM.Client_SendToServer(ip);
										sTCM.Client_CloseW();
									}
									else
										TCM.Client_NewMessage('client',"Invalid address.");
								break;
								default:
									TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
									hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
								break;
							}
							break;
						}
					}
				return;
				case "02": // run /hz302"$B2I(AcceptSpecC.bChecked)$B2I(MuteSpecC.bChecked)$B2I(AutoPauseC.bChecked)$right("00"$MinPlayersE.GetValue(),2)$PasswordE.GetValue()
					RI.AcceptSpectators = I2B(byte(Mid(para,0,1)));
					RI.MuteSpectators = I2B(byte(Mid(para,1,1)));
					RI.AutoPause = I2B(byte(Mid(para,2,1)));
					RI.DesiredPlayers = byte(Mid(para,3,2));
					RI.Password = Mid(para,5,len(para)-5);
					RI.SaveConfig();
					if( Mid(para,5,len(para)-5) != "" )
						for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
							iTCM.CheckPassword(Mid(para,5,len(para)-5));
					if( RI.GameState < 1 ){
						if( !RI.IsMatch )
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"wants to run a match.");
						else
							TCM.Client_NewMessage('client',"New setting saved.");
						RI.IsMatch = True;
					}
					else
						TCM.Client_NewMessage('client',"The game has already begun.");
				return;
				case "03": // action on game
					switch( byte(Mid(para,0,1)) ){ // "X" action
						case 1: // restart.
							RI.GameState = 6;
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has restarted the game!");	
							for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
								TCM.Client_CloseW();
							Level.ServerTravel(Left(string(Level), InStr(string(Level), "."))$".unr",True);
						break;
						case 2: // pause
							if( RI.GameState < 2 || RI.GameState > 4 ){
								TCM.Client_NewMessage('client',"This command is only available while playing.");
								return;
							}
							if( RI.GameState < 4 ){
								RI.GameState = 4;
								RI.Pauser = TCM.PP.PlayerReplicationInfo.PlayerName;
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has paused the game.");
								for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
									iTCM.CMPause(True);
							
							}
							else if( RI.GameState == 4 ){
								if( RI.IsMatch )
									RI.GameState = 3;
								else
									RI.GameState = 2;
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has resumed the game.");
								RI.Pauser = "";
								for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
									TCM.CMPause(False);
							}
						break;
						case 3: // stop & stop
							RI.GameState = 5;
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has stopped the game.");
						break;
						default:
							TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
							hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
						break;
					}
				return;
				case "04": // force vote /hez304"$i$UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).MapName
					if( RI.WaitingTime > 0 && RI.GameState < 6 ){
						TCM.Client_NewMessage('client',"Please wait"@int(RI.WaitingTime)@"secondes.");
						return;
					}
					gVote = byte(Mid(para,0,1));
					mVote = byte(Mid(para,1,3));
					// new vote
					i = RI.ForceVote(TCM.PublicKey,gVote,mVote);
					switch( i ){
						case -2 : TCM.Client_NewMessage('client',"Erroneous Vote."); return;
						default:
							Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has changed the game to ["$RI.GameLabel[gVote]$"] ["$RI.GNextMap$"]");
							for(TCM=CM;TCM!=None;TCM=TCM.PostCM)
								if( TCM != None )
									TCM.Client_CloseW();
							ScoreBoardDelay = 0;
							RI.GameState = 6;
						return;
					}
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 4: // Moderator ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // kick/ban
					i = byte(Mid(para,0,3)); 			// PlayerID
					j = int(Mid(para,3,2)); 			// nGame
					if( j == -1 )
						j = 200; //ban
					reason = Mid(para,5,len(para)-5);	// reason
					for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM){
						if( iTCM.Owner != None && iTCM.PP != None && iTCM.PP.PlayerReplicationInfo.PlayerID == i ){
							if( RI.HasRight(4,iTCM.PublicKey,iTCM.Rights) ){
								TCM.Client_NewMessage('client',"You cannot kick another moderator.");
								return;
							}
							if( j != 0 ){
								i = RI.UpdateBan(iTCM.PP.PlayerReplicationInfo.PlayerName,iTCM.ip,iTCM.PublicKey,j);
								if( i < 0 ){
									TCM.Client_NewMessage('client',"The ban list is full!");
									return;
								}
							}
							if( j == 200 ){
								iTCM.Client_winm("You have been kicked by"@TCM.PP.PlayerReplicationInfo.PlayerName
												,"Reason :"@reason
												,"You were banned, please go play somewhere else.");
								TCM.Client_NewMessage('client',RI.BannedName[i]@"has been banned.");
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has banned"@iTCM.PP.PlayerReplicationInfo.PlayerName@"(reason:"@reason$").");
								hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has banned"@iTCM.PP.PlayerReplicationInfo.PlayerName@"(reason:"@reason$").",'all');
							}
							else if( j > 0 ){
								iTCM.Client_winm("You have been kicked by"@TCM.PP.PlayerReplicationInfo.PlayerName
												,"Reason :"@reason
												,"You were kicked for"@j@"games.");
								TCM.Client_NewMessage('client',RI.BannedName[i]@"has been kicked for"@j@"game(s).");
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has kicked"@iTCM.PP.PlayerReplicationInfo.PlayerName@"for"@j@"game(s) (reason:"@reason$").");
								hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has kicked"@iTCM.PP.PlayerReplicationInfo.PlayerName@"for"@j@"game(s) (reason:"@reason$").",'all');
							}
							else if( j == 0 ){
								iTCM.Client_winm("You have been kicked by"@TCM.PP.PlayerReplicationInfo.PlayerName
												,"Reason :"@reason
												,"You were booted so you can reconnect immediatly.");
								TCM.Client_NewMessage('client',RI.BannedName[i]@"has been booted.");
								Message2All(TCM.PP.PlayerReplicationInfo.PlayerName@"has booted"@iTCM.PP.PlayerReplicationInfo.PlayerName@"(reason:"@reason$").");
								hlog(TCM.PP.PlayerReplicationInfo.PlayerName@"has booted"@iTCM.PP.PlayerReplicationInfo.PlayerName@"(reason:"@reason$").",'all');					
							}
							iTCM.Client_ConsoleCommand("disconnect");
							// update ban
							if( j != 0 )
								for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
									if( iTCM.Owner != None )
										iTCM.Client_UdpateBan(RI.BannedName[i],RI.BannedIP[i],RI.BannedTime[i]);
							return;
						}
					}
				return;
				case "02": // update ban
					j = int(Mid(para,0,2)); 			// nGame
					name = Mid(para,2,len(para)-2); 	// name
					if( j == -1 )
						j = 200; //ban
					for(i=0;i<99;i++)
						if( RI.BannedName[i] == name ){
							for(iTCM=CM;iTCM!=None;iTCM=iTCM.PostCM)
								if( iTCM.Owner != None )
									iTCM.Client_UdpateBan(RI.BannedName[i],RI.BannedIP[i],j);
							RI.UpdateBan(RI.BannedName[i],RI.BannedIP[i],RI.BannedKey[i],j);
						}
					if( j > 0 )
						TCM.Client_NewMessage('client',name@"has been updated in the ban list.");
					else
						TCM.Client_NewMessage('client',name@"has been deleted from the ban list.");
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 5: // VIP ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // unique cmd
					if( Level.Game.NumPlayers >= RI.PlayersLimit )
						TCM.Client_NewMessage('client',"The server is full. All VIP slots are already taken."); 
					else
						TCM.Client_vip();
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 6: // trusted user ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 7: // SA ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				case "01": // login+cmd
					if( Left(para,1) == " " ){
						TCM.Client_NewMessage('client',"Erroneous command.");
						return;
					}
					if( IsCheat(para) ){
						TCM.Client_NewMessage('client',"Login as ServerAdmin for cheat commands.");
						return;
					}
					TCM.PP.bAdmin = True;
					TCM.PP.PlayerReplicationInfo.bAdmin = TCM.PP.bAdmin;
					TCM.Client_ConsoleCommand(para);
					hLog(TCM.PP.PlayerReplicationInfo.PlayerName@"has execued a ServerAdmin command!",'all');
					TCM.Client_ConsoleCommand("mutate hz702");
				return;
				case "02": // logout
					TCM.PP.bAdmin = False;
					TCM.PP.PlayerReplicationInfo.bAdmin = TCM.PP.bAdmin;
					if (TCM.PP.ReducedDamageType == 'All' )
						TCM.PP.ReducedDamageType = '';
					TCM.PP.StartWalk();
				return;
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
		case 8: // network admin ///////////////////////////////////////////////////////////////////////////////////////////////////
			switch(cmd){
				default: // unknow
					TCM.Client_NewMessage('client',"The command"@MutateString@"doesn't exist.");
					hlog(Sender.PlayerReplicationInfo.PlayerName@"has tried to execute:"@MutateString,'admin');
				return;
			}
		return;
	}
}
function bool IsCheat(String s){
	switch(caps(s)){
		case "ADMIN GHOST":return True;
		case "ADMIN FLY":return True;
		case "ADMIN GOD":return True;
		case "ADMIN AMPHIBIOUS":return True;
		case "ADMIN ALLAMMO":return True;
		case "ADMIN INVISIBLE":return True;
		case "ADMIN LOADED":return True;
		default:return False;
	}
}
//===========================================================
// hut log
// all & admin + system
function hlog(String S,name Type){
	local hm_ClientManager iTCM;
	local int i;
	if( Type == 'system' ){
		if( hl[63] != "" ){
			for(i=1;i<64;i++)
				hl[i-1] = hl[i];
			hl[63] = S;
		}
		else{
			for(i=0;i<64;i++)
				if( hl[i] == "" ){
					hl[i] = S;
					break;
				}
		}
		SaveConfig();
	}
	if( RI == None )
		return;
	if( RI.dynhl[63] != "" ){
		for(i=1;i<64;i++){
			RI.dynhl[i-1] = RI.dynhl[i];
			RI.dynhlType[i-1] = RI.dynhlType[i];
		}
		RI.dynhl[63] = S;
		RI.dynhlType[63] = Type$"";
	}
	else{
		for(i=0;i<64;i++)
			if( RI.dynhl[i] == "" ){
				RI.dynhl[i] = S;
				RI.dynhlType[i] = Type$"";
				break;
			}
	}
	RI.LogA++;
	log("HUT::"$caps(Type)$":"$S,'HUT');
}
//===========================================================
// Misc
// THX someone ..
function SendToListStart(){
	local Mutator M, PrevMutator;
	// retire from list
	for(M=Level.Game.BaseMutator;M!=None;M=M.NextMutator){
		if( M == Self && PrevMutator != None )
			PrevMutator.NextMutator = M.NextMutator;
		PrevMutator = M;
	}
	Self.NextMutator = Level.Game.BaseMutator;
	Level.Game.BaseMutator = Self;
}
// BDBMapvote THX
function bool CheckForTie(){
  local TeamInfo Best;
  local int i;
  local pawn P, BestP;
  local PlayerPawn Player;
  if(Level.Game.IsA('Assault'))  //cant have ties in Assault, I think ?
     return false;
  if(Level.Game.IsA('Domination'))  //cant have ties in Domination, I think ?
     return false;
  if(Level.Game.IsA('TeamGamePlus')){  // check for a team game tie
     for( i=0; i<TeamGamePlus(Level.Game).MaxTeams; i++ )// find best team
       if( (Best == None) || (Best.Score < TeamGamePlus(Level.Game).Teams[i].Score) )
          Best = TeamGamePlus(Level.Game).Teams[i];
     for( i=0; i<TeamGamePlus(Level.Game).MaxTeams; i++ )
          if( (Best.TeamIndex != i) && (Best.Score == TeamGamePlus(Level.Game).Teams[i].Score) )
             return true;  // teams tied
  }
  else{   // check for death match tie
     for( P=Level.PawnList; P!=None; P=P.nextPawn )// find individual winner
        if( P.bIsPlayer && ((BestP == None) || (P.PlayerReplicationInfo.Score > BestP.PlayerReplicationInfo.Score)) )
           BestP = P;
     for ( P=Level.PawnList; P!=None; P=P.nextPawn ) // check for tie
          if ( P.bIsPlayer && (BestP != P) && (P.PlayerReplicationInfo.Score == BestP.PlayerReplicationInfo.Score) )
               return true; // tied
  }
  return false;  // No tie
}
function bool I2B(byte i){
	if( i == 1 )
		return True;
	return False;
}

//===========================================================
// private messaging system

function bool isBlocked(hm_ClientManager cm, string publicKey) {
	local int index;
	local bool hasBeenBlocked;
	
	// Check if the players public key has been blocked.
	while (!hasBeenBlocked && index < arrayCount(class'hm_ClientManager'.default.blockedPlayers)) {

		if (cm.blockedPlayers[index] ~= publicKey) {
			// Found him!
			hasBeenBlocked = true;
		} else {
			// No this aint the player we are looking for, continue...
			index++;
		}
	}
	
	return hasBeenBlocked;
}

function bool blockPlayer(hm_ClientManager cm, string publicKey) {
	local int index;
	local bool hasBeenBlocked;
	local UWindowList item;
	
	// Search for an empty slot.
	while (!hasBeenBlocked && index < arrayCount(class'hm_ClientManager'.default.blockedPlayers)) {
		
		if (cm.blockedPlayers[index] == "") {
			// Empty slot found, block the player key.
			cm.blockedPlayers[index] = publicKey;
			hasBeenBlocked = true;
		} else {
			// No slot has been found, continue with the next one.
			index++;
		}
	}
		
	return hasBeenBlocked;
}

function bool unblockPlayer(hm_ClientManager cm, string publicKey) {
	local int index;
	local bool hasBeenUnblocked;
	local UWindowList item;
	
	// Check if the players public key has been blocked.
	while (!hasBeenUnblocked && index < arrayCount(class'hm_ClientManager'.default.blockedPlayers)) {
		
		if (cm.blockedPlayers[index] ~= publicKey) {
			// Found him, unblock him!
			hasBeenUnblocked = true;
			cm.blockedPlayers[index] = "";
		} else {
			// No this aint the player we are looking for, continue...
			index++;
		}
	}

	return hasBeenUnblocked;
}
//hez-end
defaultproperties
{
	TeamName(0)="Red"
	TeamName(1)="Blue"
	TeamName(2)="Green"
	TeamName(3)="Yellow"
}
