//=============================================================================
// Hez UT Version 8 - ASC Winter 2006
// By Mickal De 'HeZ' aka ATHoS 2003-2005 hez-studios.net
//=============================================================================
//hez-begin
class hw_GameVote extends UWindowPageWindow;
var UMenuLabelControl WMessage;			// message
var UWindowPageControl GameVotePages;	// multi pages
var hw_sub GameW[8];					// pages for games
var UWindowPageControlPage GameTAB[8];	// tabs for games
var UWindowCheckbox ChangeC,defC;		// admin change
struct GameVotePage{
	var bool MapVote;
    var UWindowSmallButton VoteB;
	var hw_votelistbox MapListBox;
};
var GameVotePage GameVoteP[8];
var hw_votelistbox VoteBox;				// voteBox
var byte nV,MaxVote;					// nombre de votes
var Texture MapT;
var UMenuLabelControl MLabel;
var int PanelZ,BoxZ,PanelH;

const VotedBoxZ = 150;
const MutatorListRows = 4;
const MutatorListColumns = 2;
const MutatorListDY = 16;
const xOffset = 5;

function Created() {
	local UMenuMapListFrameCW VoteFrame;
	
	PanelZ = 280;
	PanelH = 200;
	BoxZ = 250;
	GameVotePages = UWindowPageControl(CreateWindow(Class'UWindowPageControl', 0.0, 0.0, WinWidth - PanelZ, WinHeight));
	GameVotePages.SetMultiLine(True);
	VoteFrame = UMenuMapListFrameCW(CreateWindow(Class'UMenuMapListFrameCW', WinWidth - PanelZ + 5, WinHeight - VotedBoxZ - 25, PanelZ - 15, VotedBoxZ));
	VoteBox = hw_votelistbox(CreateWindow(Class'hw_votelistbox', 0.0, 0.0, 100.0, 100.0, self));
	VoteBox.UP = self;
	VoteFrame.Frame.SetFrame(VoteBox);
	VoteBox.Register(self);
	VoteBox.Items.Clear();
	MLabel = UMenuLabelControl(CreateControl(Class'UMenuLabelControl', WinWidth - PanelZ, 5.0, PanelZ, 20.0));
	MLabel.Align = TA_Center;
}

function SetAdminGameVote(){
	ChangeC = UWindowCheckbox(CreateControl(class'UWindowCheckbox',WinWidth-PanelZ+5,WinHeight-22,PanelZ-10,1));
	ChangeC.SetText("Use AdminVote (switch to the map directly).");
	ChangeC.Align = TA_Left;
	DefC = UWindowCheckbox(CreateControl(class'UWindowCheckbox',WinWidth+20,WinHeight+20,10,1));
	DefC.bDisabled = True;
}
function Paint(Canvas C, float X, float Y){
	Super.Paint(C, X, Y);
	DrawUpBevel(C,WinWidth-PanelZ+6,20,PanelZ-10,PanelH+6,GetLookAndFeelTexture());
	if( MapT != None )
		DrawStretchedTexture(C,WinWidth-PanelZ+9,23,PanelZ-16,PanelH,MapT);
}
function SetGameVote(hr_config RI){
	local int i;
	MaxVote = RI.MaxVote;
	for(i=0;i<8;i++)
		if( len(RI.GameClass[i]) > 1 )
			AddGame(RI,i);
	for(i=0;i<33;i++)
		if( RI.kVote[i] != "" )
			UpdateVote(RI,False,RI.iVote[i],RI.gVote[i],RI.mVote[i]);
}

function AddGame(hr_config RI, byte i) {
	local int j;
	local int k;
	local int X;
	local int Y;
	local int labelWidth;
	local hw_votelist L;
	local string MutatorName;
	local string Map;
	local UMenuLabelControl GLabel;
	local UMenuMapListFrameCW MapListFrame;

	GameTAB[i] = GameVotePages.AddPage(RI.GameLabel[i], Class'hw_sub');
	GameW[i] = hw_sub(GameTAB[i].Page);
	GameW[i].UP = self;
	Y = 5;
	GLabel = UMenuLabelControl(GameW[i].CreateControl(Class'UMenuLabelControl', xOffset, Y, GameW[i].WinWidth, 20.0));
	GLabel.Align = TA_Center;
	GLabel.SetFont(1);
	GLabel.SetText(Class<GameInfo>(DynamicLoadObject(RI.GameClass[i], Class'Class')).Default.GameName);
	Y += 20;
	GLabel = UMenuLabelControl(GameW[i].CreateControl(Class'UMenuLabelControl', xOffset, Y, GameW[i].WinWidth, 20.0));
	GLabel.Align = TA_Center;
	GLabel.SetText(":: Map ::");
	GLabel.SetFont(0);
	if (RI.MapVote[i] > 0) {
		GameVoteP[i].MapVote = True;
	}
	
	if (GameVoteP[i].MapVote) {
		MapListFrame = UMenuMapListFrameCW(GameW[i].CreateWindow(Class'UMenuMapListFrameCW', xOffset, Y - 4, GameW[i].WinWidth - 15, BoxZ));
		GameVoteP[i].MapListBox = hw_votelistbox(GameW[i].CreateWindow(Class'hw_votelistbox', 0.0, 0.0, 100.0, 100.0, GameW[i]));
		GameVoteP[i].MapListBox.UP = self;
		MapListFrame.Frame.SetFrame(GameVoteP[i].MapListBox);
		GameVoteP[i].MapListBox.Register(GameW[i]);
		GameVoteP[i].MapListBox.Items.Clear();
		
		for (j = 0; j < 100; j++) {
			Map = GetGmap(RI, i, j);
			if (Map != "") {
				L = hw_votelist(GameVoteP[i].MapListBox.Items.Append(Class'hw_votelist'));
				L.DisplayName = Map;
				L.MapName = string(j) $ "";
				for (k = 0; k <= RI.MaxMap; k++) {
          			if (RI.LastMap[k] != "") {
						if (RI.LastMap[k] == (string(i) $ Right("00" $ string(j), 2))) {
							L.IsActiv = True;
							L.bDisabledEx = True;
						}
					} else {
						break;
					}
				}
			} else {
				break;
			}
		}
		Y += BoxZ;
		
	} else {
		Y += 20;
		GLabel = UMenuLabelControl(GameW[i].CreateControl(Class'UMenuLabelControl', xOffset, Y, GameW[i].WinWidth, 20.0));
		GLabel.Align = TA_Center;
		GLabel.SetText(GetGmap(RI, i, RI.NextMap[i]));
		GLabel.SetFont(1);
		Y += 20;
	}
	
	GameVoteP[i].VoteB = UWindowSmallButton(GameW[i].CreateControl(Class'UWindowSmallButton', xOffset, Y, GameW[i].WinWidth - 15, 16.0));
	GameVoteP[i].VoteB.SetText("Vote");
	Y += 20;
	GLabel = UMenuLabelControl(GameW[i].CreateControl(Class'UMenuLabelControl', xOffset, Y, GameW[i].WinWidth - 2 * xOffset, 20.0));
	GLabel.Align = TA_Center;
	GLabel.SetText(":: Mutators ::");
	GLabel.SetFont(0);
	Y += 20;
	
	X = xOffset;
	labelWidth = (GameW[i].WinWidth - 2 * xOffset) / MutatorListColumns;
	
	j = 0;
	MutatorName = ComaParse(RI.Mutators_Name[i]);
	while (MutatorName != "" && j < MutatorListRows * MutatorListColumns) {
		GLabel = UMenuLabelControl(GameW[i].CreateControl(Class'UMenuLabelControl', X, Y, labelWidth, MutatorListDY));
		GLabel.Align = TA_Center;
		GLabel.SetText(Right(MutatorName,Len(MutatorName) - InStr(MutatorName,".") - 1));
		GLabel.SetFont(1);
		MutatorName = ComaParse(RI.Mutators_Name[i]);
		j++;
		if (j % MutatorListColumns == 0) {
			 X = xOffset;
			 Y += MutatorListDY;
		} else {
			x += labelWidth;
		}
	}
}

function UpdateVote(hr_config RI,bool bDel,byte id, byte gVote,byte mVote){
	local int i;
	local UWindowList Items;
	local hw_votelist VoteList;
	if( RI == none )
		return;
	if( bDel ){
		for(Items=VoteBox.Items;Items!=None;Items=Items.Next){
			VoteList = hw_votelist(Items);
			if( VoteList != None && VoteList.iVote == id ){
				if( VoteList.pVote <= 1 )
					VoteList.Remove();
				else{
					VoteList.pVote--;
					SortVoteList(VoteList);
					VoteList.DisplayName = "["$VoteList.pVote$"] ["$RI.GameLabel[VoteList.gVote]$"] ["$GetGmap(RI,VoteList.gVote,VoteList.mVote)$"]";
				}
			}
		}
	}
	else{
		for(Items=VoteBox.Items;Items!=None;Items=Items.Next){
			VoteList = hw_votelist(Items);
			if( VoteList != None && VoteList.iVote == id ){
				VoteList.pVote++;
				SortVoteList(VoteList);
				VoteList.DisplayName = "["$VoteList.pVote$"] ["$RI.GameLabel[VoteList.gVote]$"] ["$GetGmap(RI,VoteList.gVote,VoteList.mVote)$"]";
				return;
			}
		}
		VoteList = hw_votelist(VoteBox.Items.Append(class'hw_votelist'));
		VoteList.gVote = gVote;
		VoteList.mVote = mVote;
		VoteList.pVote = 1;
		VoteList.iVote = id;
		VoteList.MapN = GetGmap(RI,VoteList.gVote,VoteList.mVote);
		VoteList.DisplayName = "["$VoteList.pVote$"] ["$RI.GameLabel[VoteList.gVote]$"] ["$GetGmap(RI,VoteList.gVote,VoteList.mVote)$"]";
	}
}
function bool SortVoteList(hw_votelist VoteList){
	local UWindowList Items;
	VoteList.Remove();
	for(Items=VoteBox.Items.Next;Items!=None;Items=Items.Next){
		if( hw_votelist(Items).pVote < VoteList.pVote ){
			Items.InsertItemBefore(VoteList);
			return True;
		}
	}
	VoteBox.Items.AppendItem(VoteList);
	return False;
}
function Notify(UWindowDialogControl C, byte E){
	local int i;
	local string cmd;
	Super.Notify(C, E);
	if( ChangeC != None && ChangeC.bChecked )
		cmd ="304";
	else
		cmd ="007";
	switch(E){
		case DE_DoubleClick:
			for(i=0;i<8;i++)
				if( C == GameVoteP[i].MapListBox && (!hw_votelist(GameVoteP[i].MapListBox.SelectedItem).IsActiv || (ChangeC != None && ChangeC.bChecked)) ){
					getplayerowner().ConsoleCommand("mutate hz"$cmd$i$UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).MapName);
					nV++;
					WMessage.SetText("You have emitted a vote,"@max(0,MaxVote-nV)@"vote(s) left.");
				}
			if( C == VoteBox ){
				getplayerowner().ConsoleCommand("mutate hz"$cmd$hw_votelist(VoteBox.SelectedItem).gVote$hw_votelist(VoteBox.SelectedItem).mVote);
				nV++;
				WMessage.SetText("You have emitted a vote,"@max(0,MaxVote-nV)@"vote(s) left.");
			}
		break;
		case DE_Click:	
			// set map texture
			if( C == VoteBox && VoteBox.SelectedItem != None ){
				MLabel.SetText(hw_votelist(VoteBox.SelectedItem).MapN);
				MapT = Texture(DynamicLoadObject(hw_votelist(VoteBox.SelectedItem).MapN$".Screenshot", class'Texture'));
			}
			else
				for(i=0;i<8;i++)
					if( C == GameVoteP[i].MapListBox && GameVoteP[i].MapListBox.SelectedItem != None ){
						MLabel.SetText(UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).DisplayName);
						MapT = Texture(DynamicLoadObject(UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).DisplayName$".Screenshot", class'Texture'));
					}
			// emit vote
			for(i=0;i<8;i++)
				if( C == GameVoteP[i].VoteB ){
					if( GameVoteP[i].MapVote ){
						if( GameVoteP[i].MapListBox.SelectedItem != None && UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).MapName != "" && (!hw_votelist(GameVoteP[i].MapListBox.SelectedItem).IsActiv || (ChangeC != None && ChangeC.bChecked))  ){
							getplayerowner().ConsoleCommand("mutate hz"$cmd$i$UMenuMapList(GameVoteP[i].MapListBox.SelectedItem).MapName);
							nV++;
							WMessage.SetText("You have emitted a vote,"@max(0,MaxVote-nV)@"vote(s) left.");
						}
						else
							WMessage.SetText("Please select a map for this game.");
					}
					else{
						getplayerowner().ConsoleCommand("mutate hz"$cmd$i);
						nV++;
						WMessage.SetText("You have emitted a vote,"@max(0,MaxVote-nV)@"vote(s) left.");
					}
				}
		break;
	}
}
function String ComaParse(out String S){
	local String SR,SL;
	if( InStr(S,",") == -1 ){
		SL = S;
		S = "";
		return SL;
	}
	SR = Right(S,len(S)-InStr(S,",")-1);
	SL = Left(S,InStr(S,","));
	S = SR;
	return SL;
}
function String GetGmap(hr_config RI,byte g,byte m){
	switch(g){
		case 0:return RI.G0Maps[m];
		case 1:return RI.G1Maps[m];
		case 2:return RI.G2Maps[m];
		case 3:return RI.G3Maps[m];
		case 4:return RI.G4Maps[m];
		case 5:return RI.G5Maps[m];
		case 6:return RI.G6Maps[m];
		case 7:return RI.G7Maps[m];
	}
}
//hez-end
