//=============================================================================
// Hez UT Version 8 - ASC Winter 2006
// By Mickal De 'HeZ' aka ATHoS 2003-2005 hez-studios.net
//=============================================================================
//hez-begin
class hw_PrivateMessage extends UWindowPageWindow;

var UMenuLabelControl wMessage;
var hw_votelistbox playerBox;
var hw_votelistbox blockedPlayerBox;
var UMenuLabelControl sayLabel;
var UWindowEditControl msgInp;
var UWindowSmallButton sendButton;
var UWindowSmallButton clearButton;
var UWindowDynamicTextArea textArea;
var color colors[6];
var String blockedPlayers[32];
var String savedMessages[4];
var int numSavedMsg;
var int curSavedMsg;

const nPadd = 10;
const playerListHeight = 128;
const sendButtonWidth = 64;
const clearButtonWidth = 64;



/**
 *
 */
function created() {
	local int wx, wy, ww, wh;
	local int cy, cx, cw, ch;
	local UMenuLabelControl caption;
	local UMenuMapListFrameCW playerFrame;
	
	wx = nPadd;
	wy = nPadd;
	ww = winWidth - 2 * wx - 6;
	wh = winHeight - 2 * wy - 8;

	// "Unblocked:" label.
	cy = wy;
	cx = wx;
	cw = (ww - nPadd) / 2;
	ch = 16;
	caption = UMenuLabelControl(createControl(class'UMenuLabelControl', cx, cy, cw, ch));
	caption.setText("Unblocked:");
	caption.setFont(F_Bold);

	// "Blocked:" label.
	cx = wx + (ww + nPadd) / 2;
	caption = UMenuLabelControl(createControl(class'UMenuLabelControl', cx, cy, cw, ch));
	caption.setText("Blocked:");
	caption.setFont(F_Bold);
	
	// Unblocked player list.
	cx = wx;
	cy += ch;
	ch = playerListHeight;
	playerFrame = UMenuMapListFrameCW(createWindow(class'UMenuMapListFrameCW', cx, cy, cw, ch));
	playerBox = hw_votelistbox(createWindow(class'hw_votelistbox', 0, 0, 100, 100, self));
	playerBox.up = self;
	playerFrame.frame.setFrame(playerBox);
	playerBox.register(self);
	playerBox.items.clear();

	// Unblocked player list.
	cx = wx + (ww + nPadd) / 2;
	playerFrame = UMenuMapListFrameCW(createWindow(class'UMenuMapListFrameCW', cx, cy, cw, ch));
	blockedPlayerBox = hw_votelistbox(createWindow(class'hw_votelistbox', 0, 0, 100, 100, self));
	blockedPlayerBox.up = self;
	playerFrame.frame.setFrame(blockedPlayerBox);
	blockedPlayerBox.register(self);
	blockedPlayerBox.items.clear();
	
	// "Say to ...:" label.
	cx = wx;
	cy += ch + nPadd;
	cw = wh;
	ch = 16;
	sayLabel = UMenuLabelControl(createControl(class'UMenuLabelControl', cx, cy, cw, ch));
	sayLabel.setText("Say:");
	sayLabel.setFont(F_Bold);
	
	// Message input box.
	cy += ch;
	cw = ww - sendButtonWidth - nPadd;
	msgInp = UWindowEditControl(createControl(class'UWindowEditControl', cx, cy, cw, cy));
	msgInp.editBoxWidth = cw;
	msgInp.setMaxLength(250);
	
	// Send button.
	cw = sendButtonWidth;
	cx = wx + ww - sendButtonWidth;
	sendButton = UWindowSmallButton(createControl(class'UWindowSmallButton', cx, cy, cw, cy));
	sendButton.SetText("Send");
	
	// "Private messages:" label.
	cx = wx;
	cy += ch + nPadd;
	cw = ww - clearButtonWidth - nPadd;
	ch = 16;
	caption = UMenuLabelControl(createControl(class'UMenuLabelControl', cx, cy, cw, ch));
	caption.setText("Private messages:");
	caption.setFont(F_Bold);
	
	// Clear button.
	cx = wx + ww - clearButtonWidth;
	cw = clearButtonWidth;
	clearButton = UWindowSmallButton(createControl(class'UWindowSmallButton', cx, cy, cw, cy));
	clearButton.SetText("Clear");
		
	// Received private messages list.
	cx = wx;
	cy += ch;
	cw = ww;
	ch = wy + wh - cy;
	playerFrame = UMenuMapListFrameCW(createWindow(class'UMenuMapListFrameCW', cx, cy, cw, ch));
	textArea = UWindowDynamicTextArea(CreateControl(class'UWindowDynamicTextArea', 0, 0, 100, 100));
	textArea.setTextColor(lookAndFeel.editBoxTextColor);
    textArea.bTopCentric = false;
	playerFrame.frame.setFrame(textArea);

}



/**
 *
 */
function playerEvent(bool bSpectator, bool bLeave, string playerName, byte playerID, byte team, string publicKey) {
	local hw_votelist playerList;
	local UWindowList items;
	local hw_votelistbox playerBox;
	
	// Return on invalid player.
	if (playerName == "" || playerID < 1) {
		return;
	}
	
	// Determine in which list the player is displayed.
	if (isBlocked(publicKey)) {
		playerBox = self.blockedPlayerBox;
	} else {
		playerBox = self.playerBox;
	}
	
	// Remove player from the list.
	for (items = playerBox.items; items != none; items=items.next) {
		if (hw_votelist(items) != none && hw_votelist(items).playerID == playerID) {
			if (playerBox.selectedItem == items) playerBox.selectedItem = none;
			if (blockedPlayerBox.selectedItem == items) blockedPlayerBox.selectedItem = none;
			items.remove();
		}
	}
	
	// If the player didn't leave, update his properties.
	if (!bLeave) {
		playerList = hw_votelist(playerBox.items.append(class'hw_votelist'));
		playerList.playerName = playerName;
		playerList.publicKey = publicKey;
		playerList.playerID = playerID;
		playerList.isPlayerList = true;
		if (bSpectator) {
			playerList.c = colors[5];
			playerList.displayName = "[SPECTATOR:" $ playerID $ "]" @ playerName;
		} else {
			playerList.c = colors[4];
			if (team >= 0 && team <= 3) {
				playerList.c = colors[team];
			}
			playerList.displayName = "[PLAYER:" $ playerID $ "]" @ playerName;
		}
	}
	
	playerFocusUpdate();
}



/**
 * Checks if the player with the specified public key has been blocked.
 * @param  publicKey the public key of the player to check
 * @return true if the player has been blocked, false if not
 */
function bool isBlocked(string publicKey) {
	local int index;
	local bool hasBeenBlocked;
	
	// Check if the players public key has been blocked.
	while (!hasBeenBlocked && index < arrayCount(blockedPlayers)) {

		if (blockedPlayers[index] ~= publicKey) {
			// Found him!
			hasBeenBlocked = true;
		} else {
			// No this aint the player we are looking for, continue...
			index++;
		}
	}
	
	return hasBeenBlocked;
}



/**
 * Attempts to block a player based on his public key. If the player has been
 * blocked the player lists will be updated.
 * @param  publicKey the public key of the player to block
 * @return true if the player has been blocked,
 *         false if the blocked list is full
 */
function bool blockPlayer(string publicKey) {
	local int index;
	local bool hasBeenBlocked;
	local UWindowList item;
	
	// Search for an empty slot.
	while (!hasBeenBlocked && index < arrayCount(blockedPlayers)) {
		
		if (blockedPlayers[index] == "") {
			// Empty slot found, block the player key.
			blockedPlayers[index] = publicKey;
			hasBeenBlocked = true;
		} else {
			// No slot has been found, continue with the next one.
			index++;
		}
	}
	
	// Update player lists if the player has been blocked.
	if (hasBeenBlocked) {
		for (item = playerBox.items; item != none; item = item.next) {
			if (hw_votelist(item) != none && hw_votelist(item).publicKey ~= publicKey) {
				item.remove();
				blockedPlayerBox.items.appendItem(item);
				playerBox.selectedItem = none;
				if (blockedPlayerBox.selectedItem != none) {
					blockedPlayerBox.selectedItem.bSelected = false;
				}
				blockedPlayerBox.selectedItem = hw_votelist(item);
				blockedPlayerBox.selectedItem.bSelected = true;
				break;
			}
		}
	}
	
	return hasBeenBlocked;
}



/**
 *
 */
function bool unblockPlayer(string publicKey) {
	local int index;
	local bool hasBeenUnblocked;
	local UWindowList item;
	
	// Check if the players public key has been blocked.
	while (!hasBeenUnblocked && index < arrayCount(blockedPlayers)) {

		if (blockedPlayers[index] ~= publicKey) {
			// Found him, unblock him!
			hasBeenUnblocked = true;
			blockedPlayers[index] = "";
		} else {
			// No this aint the player we are looking for, continue...
			index++;
		}
	}

	// Update player lists if the player has been unblocked.
	if (hasBeenUnblocked) {
		for (item = blockedPlayerBox.items; item != none; item = item.next) {
			if (hw_votelist(item) != none && hw_votelist(item).publicKey ~= publicKey) {
				item.remove();
				playerBox.items.appendItem(item);
				blockedPlayerBox.selectedItem = none;
				if (playerBox.selectedItem != none) {
					playerBox.selectedItem.bSelected = false;
				}
				playerBox.selectedItem = hw_votelist(item);
				playerBox.selectedItem.bSelected = true;
				break;
			}
		}
	}
	
	return hasBeenUnblocked;
}



/**
 *
 */
function notify(UWindowDialogControl c, byte e) {
	local int playerID;
	local string publicKey;
	local string playerName;
	local string message;
	
	super.notify(c, e);
	
	// Send message.
	if (c == sendButton && e == DE_Click ||
	    c == msgInp     && e == DE_EnterPressed) {
		if (getSelectedPlayer() == none) {
			wMessage.SetText("Please select a player to send your message to.");
		} else if (msgInp.getValue() == "") {
			wMessage.SetText("Please enter a message to send.");
		} else {
			playerName = getSelectedPlayer().playerName;
			playerID = getSelectedPlayer().playerID;
			textArea.addText("to" @ playerName $ ":" @ msgInp.getValue());
			getplayerowner().ConsoleCommand("mutate hz017" $ playerID $ "," $ msgInp.getValue());
			msgInp.setValue("");
		}
	}
	
	// Clear private message log.
	if (c == clearButton && e == DE_Click) {
		textArea.clear();
		playerFocusUpdate();
	}
	
	// Focus check for unblocked player list.
	if (c == playerBox && e == DE_Click) {
		if (blockedPlayerBox.selectedItem != none) {
			blockedPlayerBox.selectedItem.bSelected = false;
			blockedPlayerBox.selectedItem = none;
		}
		playerFocusUpdate();
	}
	
	// Focus check for blocked player list.
	if (c == blockedPlayerBox && e == DE_Click) {
		if (playerBox.selectedItem != none) {
			playerBox.selectedItem.bSelected = false;
			playerBox.selectedItem = none;
		}
		playerFocusUpdate();
	}
	
	// Block player.
	if (c == playerBox && e == DE_DoubleClick) {
		if (playerBox.selectedItem != none) {
			playerID = hw_votelist(playerBox.selectedItem).playerID;
			publicKey = hw_votelist(playerBox.selectedItem).publicKey;
			playerName = hw_votelist(playerBox.selectedItem).playerName;
			
			if (isBlocked(publicKey)) {
				message = "Unable to block" @ playerName $ ", player is already blocked.";
			} else if (blockPlayer(publicKey)) {
				message = "You have blocked" @ playerName $ ".";
				getplayerowner().ConsoleCommand("mutate hz015" $ playerID);
			} else {
				message = "Unable to block" @ playerName $ ", the block list is full.";
			}
			
			textArea.addText(message);
			wMessage.SetText(message);
		}
		
	} 

	// Unblock player.
	if (c == blockedPlayerBox && e == DE_DoubleClick) {
		if (blockedPlayerBox.selectedItem != none) {
			playerID = hw_votelist(blockedPlayerBox.selectedItem).playerID;
			publicKey = hw_votelist(blockedPlayerBox.selectedItem).publicKey;
			playerName = hw_votelist(blockedPlayerBox.selectedItem).playerName;
			
			if (unblockPlayer(publicKey)) {
				message = "You have unblocked" @ playerName $ ".";
				getplayerowner().ConsoleCommand("mutate hz016" $ playerID);
			} else {
				message = "Unable to unblock" @ playerName $ ", player is not blocked.";
			}
			
			textArea.addText(message);
			wMessage.SetText(message);
		}
	} 
}



/**
 *
 */
function playerFocusUpdate() {
	local string selectedPlayer;
	
	if (playerBox.selectedItem != none) {
		selectedPlayer = hw_votelist(playerBox.selectedItem).playerName;
	} else if (blockedPlayerBox.selectedItem != none) {
		selectedPlayer = hw_votelist(blockedPlayerBox.selectedItem).playerName;
	}
	
	if (selectedPlayer == "") {
		sayLabel.setText("Say:");
	} else {
		sayLabel.setText("Say to " $ selectedPlayer $ ":");
	}
}



/**
 *
 */
function hw_votelist getSelectedPlayer() {
	if (playerBox.selectedItem != none) {
		return hw_votelist(playerBox.selectedItem);
	} else {
		return hw_votelist(blockedPlayerBox.selectedItem);
	}
}



/**
 *
 */
function receivePM(string message, string publicKey, string playerName) {
	textArea.addText("from" @ playerName $ ":" @ message);
}



//hez-end
defaultproperties {
	colors(0)=(R=150,G=30,B=30)		// red
	colors(1)=(R=30,G=30,B=150)		// blue
	colors(2)=(R=30,G=150,B=30)		// green
	colors(3)=(R=150,G=150,B=30)	// yellow
	colors(4)=(R=0,G=0,B=0)			// black
	colors(5)=(R=100,G=100,B=100)	// grey
}
