//================================================================================
// hw_Stats.
//================================================================================

class hw_Stats extends UWindowPageWindow;

const Rows = 30;
const Columns = 3;
const ScoreWidthRatio = 0.65;
const BorderDistance = 10;
const RowHeight = 12.0;

function ShowStats(hr_config RI) {
	
	local UMenuLabelControl Label;
	local float ColumnWidth;
	local float PlayerColumnWidth;
	local float ScoreColumnWidth;
	local float X, Y;
	local int i;
	local string PlayerName;
	
	X = BorderDistance;
	Y = BorderDistance;
	ColumnWidth = (WinWidth - 2 * BorderDistance) / Columns;
	PlayerColumnWidth = ScoreWidthRatio * ColumnWidth;
	ScoreColumnWidth = (1- ScoreWidthRatio) * ColumnWidth;
	
	for (i = 0; i < Columns; i++) {
		Label = UMenuLabelControl(CreateControl(Class'UMenuLabelControl', X, Y, PlayerColumnWidth, RowHeight));
		Label.Align = TA_Left;
		Label.SetText("Player:");
		Label.SetFont(1);
		X += PlayerColumnWidth;
		
		Label = UMenuLabelControl(CreateControl(Class'UMenuLabelControl', X, Y, ScoreColumnWidth, RowHeight));
		Label.Align = TA_Left;
		Label.SetText("Score:");
		Label.SetFont(1);		
		X += ScoreColumnWidth;
	}
	
	X = BorderDistance;
	Y = BorderDistance + 2 * RowHeight;
	i = 0;
	while (i < Rows * Columns) {
		PlayerName = RI.StatsPlayerName[i];
		//if (PlayerName == "") break;
		
		Label = UMenuLabelControl(CreateControl(Class'UMenuLabelControl', X, Y, PlayerColumnWidth, RowHeight));
		Label.Align = TA_Left;
		Label.SetText((i+1) $ ".  " $ PlayerName);
		Label.SetFont(0);
		
		Label = UMenuLabelControl(CreateControl(Class'UMenuLabelControl', X + PlayerColumnWidth, Y, ScoreColumnWidth, RowHeight));
		Label.Align = TA_Left;
		Label.SetText(RI.StatsPlayerScore[i]);
		Label.SetFont(0);
				
		i++;
		if (i % Rows == 0) {
			X += ColumnWidth;
			Y = BorderDistance + 2 * RowHeight;
		} else {
			Y += RowHeight;
		}
	}
}