//=============================================================================
// Hez UT Version 8 - ASC Winter 2006
// By Mickal De 'HeZ' aka ATHoS 2003-2005 hez-studios.net
//=============================================================================
//hez-begin
class hw_bind expands UMenuDialogClientWindow;
var UMenuRaisedButton SelectedButton;
var int Selection;
var bool bPolling;
var UMenuRaisedButton BinderButton[10];
var UMenuLabelControl BinderLabel[10];
var String BinderName[10],BinderCMD[10];
const BinderN = 10;
var color RedColor; 
function Created(){
	local int i,X,Y,W,H;
	W = WinWidth-20; H = 20;
	X = 10; Y = 5;
	bIgnoreLDoubleClick = True;
	bIgnoreMDoubleClick = True;
	bIgnoreRDoubleClick = True;
	Super.Created();
	SetAcceptsFocus();
	for (i=0; i<BinderN; i++){
		BinderLabel[i] = UMenuLabelControl(CreateControl(class'UMenuLabelControl',X,Y+5,W-80,H));
		BinderLabel[i].SetText(BinderName[i]@":");
		BinderLabel[i].Align = TA_Left;
		BinderLabel[i].SetFont(F_Bold);
		BinderButton[i] = UMenuRaisedButton(CreateControl(class'UMenuRaisedButton',X+W-70,Y,70,H));
		BinderButton[i].bAcceptsFocus = False;
		BinderButton[i].bIgnoreLDoubleClick = True;
		BinderButton[i].bIgnoreMDoubleClick = True;
		BinderButton[i].bIgnoreRDoubleClick = True;
		BinderButton[i].Text = "";
		BinderButton[i].Index = i;
		BinderButton[i].Align = TA_Center;
		Y += 25;
	}
	LoadExistingKeys();
}
function LoadExistingKeys(){
	local int i,j,pos;
	local string KeyName,Alias;
	for (i=0; i<255; I++){
		KeyName = GetPlayerOwner().ConsoleCommand( "KEYNAME "$i );
		if ( KeyName != "" ){
			Alias = GetPlayerOwner().ConsoleCommand( "KEYBINDING "$KeyName );
			if ( Alias != "" ){
				pos = InStr(Alias, "hz");
				if (pos != -1){
					for(j=0;j<BinderN;j++){
						if( BinderCMD[j] == Alias ){
							BinderButton[j].Text = KeyName;
							break;
						}
					}
				}
			}
		}
	}
}
function KeyDown( int Key, float X, float Y ){
	if (bPolling){
		ProcessMenuKey(Key,mid(string(GetEnum(enum'EInputKey',Key)),3));
		bPolling = False;
		SelectedButton.bDisabled = False;
	}
}
function ProcessMenuKey(int KeyNo,string KeyName ){
	local int i;
	if ( (KeyName == "") || (KeyName == "Escape")
		|| ((KeyNo >= 0x70 ) && (KeyNo <= 0x79)) // function keys
		|| ((KeyNo >= 0x30 ) && (KeyNo <= 0x39))) // number keys
		return;
	
	//Remove existing binds for this key
	for (i=0; i<BinderN; i++){
		if (BinderButton[i].Text == KeyName){
			GetPlayerOwner().ConsoleCommand("SET Input" @ BinderButton[i].Text);
			BinderButton[i].Text = "";
		}
	}
	
	// Remove old key bind for this action
	GetPlayerOwner().ConsoleCommand("SET Input" @ BinderButton[Selection].Text);
	
	// Update key bind
	BinderButton[Selection].Text = KeyName;
	GetPlayerOwner().ConsoleCommand("SET Input" @ KeyName @ BinderCMD[Selection]);
	GetPlayerOwner().SaveConfig();
}
function Notify(UWindowDialogControl C, byte E)
{
	local int i;
	local bool accepted;
	
	accepted = False;
	if (E == DE_Click) {
		i = 0;
		while (!accepted && i < BinderN) {
			if (C == BinderButton[i]) {
				accepted = True;
				
				if (bPolling) { // Already waiting for a key
					if (SelectedButton == C) { // Cancel key binding
						bPolling = False;
						SelectedButton.bDisabled = False;
					} else { // Change action
						SelectedButton.bDisabled = False;
						SelectedButton = UMenuRaisedButton(C);
						Selection = i;
						SelectedButton.bDisabled = True;
					}
				} else { // Wait for a key to be pressed
					SelectedButton = UMenuRaisedButton(C);
					Selection = i;
					bPolling = True;
					SelectedButton.bDisabled = True;
				}
				
			}
			i++;
		}
	}
	
	if (!accepted) {
		Super.Notify(C, E);
	}
}
//hez-end
defaultproperties
{
	BinderName(0)="Switch to red"
	BinderName(1)="Switch to blue"
	BinderName(2)="Switch to green"
	BinderName(3)="Switch to yellow"
	BinderName(4)="Reconnect as Player"
	BinderName(5)="Reconnect as Spectator"
	BinderName(6)="Request GameVote"
	BinderName(7)="Balance Teams"
	BinderName(8)="Start The match"
	BinderName(9)="Open Client Windows"
	BinderCMD(0)="mutate hz0040"
	BinderCMD(1)="mutate hz0041"
	BinderCMD(2)="mutate hz0042"
	BinderCMD(3)="mutate hz0043"
	BinderCMD(4)="mutate hz011"
	BinderCMD(5)="mutate hz012"
	BinderCMD(6)="mutate hz010"
	BinderCMD(7)="mutate hz005"
	BinderCMD(8)="mutate hz003"
	BinderCMD(9)="mutate hz0090"
	RedColor=(R=150)
}
