//================================================================================
// ho_md5.
//================================================================================

class ho_md5 extends Object;

const Hex= "0123456789ABCDEF";
struct MD5_CTX {
  var int State[64];
  var int Count[64];
  var byte buffer[64];
};


static function string MD5String (string Str) {
  local MD5_CTX Context;
  local byte digest[64];
  local string Hex;
  local int i;

  MD5Init(Context);
  MD5Update(Context, Str, Len(Str));
  MD5Final(digest, Context);
  for (i = 0; i < 16; i++ ) {
    Hex = Hex $ DecToHex(digest[i], 1);
  }
  return Hex;
}

static final function MD5Init (out MD5_CTX Context) {
  Context.Count[0] = 0;
  Context.Count[1] = 0;
  Context.State[0] = 1732584193;
  Context.State[1] = -271733879;
  Context.State[2] = -1732584194;
  Context.State[3] = 271733878;
}

static final function MD5Transform (out int Buf[64], byte block[64]) {
  local int A;
  local int B;
  local int C;
  local int D;
  local int X[64];

  A = Buf[0];
  B = Buf[1];
  C = Buf[2];
  D = Buf[3];
  Decode(X,block,64);
  FF(A,B,C,D,X[0],7,-680876936);
  FF(D,A,B,C,X[1],12,-389564586);
  FF(C,D,A,B,X[2],17,606105819);
  FF(B,C,D,A,X[3],22,-1044525330);
  FF(A,B,C,D,X[4],7,-176418897);
  FF(D,A,B,C,X[5],12,1200080426);
  FF(C,D,A,B,X[6],17,-1473231341);
  FF(B,C,D,A,X[7],22,-45705983);
  FF(A,B,C,D,X[8],7,1770035416);
  FF(D,A,B,C,X[9],12,-1958414417);
  FF(C,D,A,B,X[10],17,-42063);
  FF(B,C,D,A,X[11],22,-1990404162);
  FF(A,B,C,D,X[12],7,1804603682);
  FF(D,A,B,C,X[13],12,-40341101);
  FF(C,D,A,B,X[14],17,-1502002290);
  FF(B,C,D,A,X[15],22,1236535329);
  GG(A,B,C,D,X[1],5,-165796510);
  GG(D,A,B,C,X[6],9,-1069501632);
  GG(C,D,A,B,X[11],14,643717713);
  GG(B,C,D,A,X[0],20,-373897302);
  GG(A,B,C,D,X[5],5,-701558691);
  GG(D,A,B,C,X[10],9,38016083);
  GG(C,D,A,B,X[15],14,-660478335);
  GG(B,C,D,A,X[4],20,-405537848);
  GG(A,B,C,D,X[9],5,568446438);
  GG(D,A,B,C,X[14],9,-1019803690);
  GG(C,D,A,B,X[3],14,-187363961);
  GG(B,C,D,A,X[8],20,1163531501);
  GG(A,B,C,D,X[13],5,-1444681467);
  GG(D,A,B,C,X[2],9,-51403784);
  GG(C,D,A,B,X[7],14,1735328473);
  GG(B,C,D,A,X[12],20,-1926607734);
  HH(A,B,C,D,X[5],4,-378558);
  HH(D,A,B,C,X[8],11,-2022574463);
  HH(C,D,A,B,X[11],16,1839030562);
  HH(B,C,D,A,X[14],23,-35309556);
  HH(A,B,C,D,X[1],4,-1530992060);
  HH(D,A,B,C,X[4],11,1272893353);
  HH(C,D,A,B,X[7],16,-155497632);
  HH(B,C,D,A,X[10],23,-1094730640);
  HH(A,B,C,D,X[13],4,681279174);
  HH(D,A,B,C,X[0],11,-358537222);
  HH(C,D,A,B,X[3],16,-722521979);
  HH(B,C,D,A,X[6],23,76029189);
  HH(A,B,C,D,X[9],4,-640364487);
  HH(D,A,B,C,X[12],11,-421815835);
  HH(C,D,A,B,X[15],16,530742520);
  HH(B,C,D,A,X[2],23,-995338651);
  II(A,B,C,D,X[0],6,-198630844);
  II(D,A,B,C,X[7],10,1126891415);
  II(C,D,A,B,X[14],15,-1416354905);
  II(B,C,D,A,X[5],21,-57434055);
  II(A,B,C,D,X[12],6,1700485571);
  II(D,A,B,C,X[3],10,-1894986606);
  II(C,D,A,B,X[10],15,-1051523);
  II(B,C,D,A,X[1],21,-2054922799);
  II(A,B,C,D,X[8],6,1873313359);
  II(D,A,B,C,X[15],10,-30611744);
  II(C,D,A,B,X[6],15,-1560198380);
  II(B,C,D,A,X[13],21,1309151649);
  II(A,B,C,D,X[4],6,-145523070);
  II(D,A,B,C,X[11],10,-1120210379);
  II(C,D,A,B,X[2],15,718787259);
  II(B,C,D,A,X[9],21,-343485551);
  Buf[0] += A;
  Buf[1] += B;
  Buf[2] += C;
  Buf[3] += D;
}

static final function MD5Update (out MD5_CTX Context, string Data, int inputLen)
{
  local int i;
  local int Index;
  local int partlen;
  local byte tmpbuf[64];

  Index = Context.Count[0] >>> 3 & 63;
  if ((Context.Count[0] += inputLen << 3) < inputLen << 3) {
    Context.Count[1]++;
  }
  Context.Count[1] += inputLen >>> 29;
  partlen = 64 - Index;
  if (inputLen >= partlen) {
    MD5Move(Data,0,Context.buffer,Index,partlen);
    MD5Transform(Context.State,Context.buffer);
    i = partlen;
    while (i + 63 < inputLen) {
      MD5Move(Data,i,tmpbuf,0,64);
      MD5Transform(Context.State,tmpbuf);
      i += 64;
    }
    Index = 0;
  } else {
    i = 0;
  }
  MD5Move(Data,i,Context.buffer,Index,inputLen - i);
}

static final function MD5Final (out byte digest[64], out MD5_CTX Context) {
  local byte bits[64];
  local int i;
  local int Index;
  local int padLen;
  local string strbits;
  local string Padding;

  Padding = Chr(128);
  for (i = 1; i < 64; i++) {
    Padding = Padding $ Chr(0);
  }
  Encode(bits,Context.Count,8);
  Index = Context.Count[0] >>> 3 & 63;
  if ( Index < 56 ) {
    padLen = 56 - Index;
  } else {
    padLen = 120 - Index;
  }
  MD5Update(Context,Padding,padLen);
  strbits = "";
  for (i = 0; i < 8; i++) {
    strbits = strbits $ Chr(bits[i]);
  }
  MD5Update(Context,strbits,8);
  Encode(digest,Context.State,16);
  for (i = 0; i < 64; i++) {
    Context.buffer[i] = 0;
  }
}

static final function Encode (out byte Output[64], int Input[64], int Len) {
  local int i;
  local int j;

  i = 0;
  j = 0;
  while (j < Len) {
    Output[j] = Input[i] & 255;
    Output[j + 1] = Input[i] >> 8 & 255;
    Output[j + 2] = Input[i] >> 16 & 255;
    Output[j + 3] = Input[i] >> 24 & 255;
    i++;
    j += 4;
  }
}

static final function Decode (out int Output[64], byte Input[64], int Len) {
  local int i;
  local int j;

  i = 0;
  j = 0;
  while (j < Len) {
    Output[i] = Input[j] | Input[j + 1] << 8 | Input[j + 2] << 16 | Input[j + 3] << 24;
    i++;
    j += 4;
  }
}

static final function MD5Move (string src, int srcindex, out byte buffer[64], int bufindex, int Len)
{
  local int i;
  local int j;

  j = bufindex;
  for (i = srcindex; i < srcindex + Len; i++) {
    buffer[j] = Asc(Mid(src,i,1));
    j++;
    if ( j == 64 ) {
    	return;
    }
  }
}

static final function int ROTATE_LEFT (int X, int N) {
  return X << N | X >>> 32 - N;
}

static final function int F (int X, int Y, int Z) {
  return X & Y |  ~X & Z;
}

static final function int G (int X, int Y, int Z) {
  return X & Z | Y &  ~Z;
}

static final function int H (int X, int Y, int Z) {
  return X ^ Y ^ Z;
}

static final function int i (int X, int Y, int Z) {
  return Y ^ X |  ~Z;
}

static final function FF (out int A, int B, int C, int D, int X, int S, int AC) {
  A += F(B,C,D) + X + AC;
  A = ROTATE_LEFT(A,S);
  A += B;
}

static final function GG (out int A, int B, int C, int D, int X, int S, int AC) {
  A += G(B,C,D) + X + AC;
  A = ROTATE_LEFT(A,S) + B;
}

static final function HH (out int A, int B, int C, int D, int X, int S, int AC) {
  A += H(B,C,D) + X + AC;
  A = ROTATE_LEFT(A,S) + B;
}

static final function II (out int A, int B, int C, int D, int X, int S, int AC) {
  A += i(B,C,D) + X + AC;
  A = ROTATE_LEFT(A,S) + B;
}

static final function string DecToHex (int Dec, int Size) {
  local string S;
  local int i;

  for (i = 0; i < Size * 2; i++) {
    S = Mid("0123456789ABCDEF",Dec & 15,1) $ S;
    Dec = Dec >>> 4;
  }
  return S;
}