/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLJumpDetector
 *  $VERSION  1.40
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLJumpDetector extends TournamentPickup;

var StrangeShell sl;

function postBeginPlay() {
	super.postBeginPlay();
}

state activated {

begin:
	Pawn(owner).bCountJumps = true;

}

function ownerJumped() {
	if (sl != none) {
		sl.eject(owner, 1);
	}
	
	if (inventory != none) {
		inventory.ownerJumped();
	}
}

function tick(float delta) {
	Pawn(owner).bCountJumps = true;
}

function destroyed() {
	local Inventory jb;

	jb = Pawn(owner).findInventoryType(class'UT_Jumpboots');
	
	if (jb == none) {
		Pawn(owner).bCountJumps = false;
	}

	super.destroyed();
}

// $END_CLASSIFIED
