/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS        SLTwinkle
 *  $VERSION      1.02 (2-12-2007 11:57)
 *  $AUTHOR       Daan 'Defrost' Scheerens  initial version
 *  $CONTACT      d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED

class SLTwinkle extends AnimSpriteEffect;

#exec texture import name=SilverTwinkle_a00 file="Resources\SilverTwinkle_a00.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a01 file="Resources\SilverTwinkle_a01.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a02 file="Resources\SilverTwinkle_a02.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a03 file="Resources\SilverTwinkle_a03.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a04 file="Resources\SilverTwinkle_a04.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a05 file="Resources\SilverTwinkle_a05.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a06 file="Resources\SilverTwinkle_a06.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a07 file="Resources\SilverTwinkle_a07.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a08 file="Resources\SilverTwinkle_a08.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a09 file="Resources\SilverTwinkle_a09.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a10 file="Resources\SilverTwinkle_a10.pcx" mips=off flags=2
#exec texture import name=SilverTwinkle_a11 file="Resources\SilverTwinkle_a11.pcx" mips=off flags=2

const minDrawScale = 0.05;    // Minimum draw scale.
const maxDrawScale = 0.40;    // Maximum draw scale.
const minLifeSpan  = 0.8;     // Minimum life span.
const maxLifeSpan  = 1.5;     // Maximum life span.



/***************************************************************************************************
 *
 *  $DESCRIPTION  Called when the Actor is spawned. Gives the light a random draw scale.
 *  $OVERRIDE
 *
 **************************************************************************************************/
function postBeginPlay() {
	super.postBeginPlay();
	drawScale = fRand() * (maxDrawScale - minDrawScale) + minDrawScale;
	lifeSpan = fRand() * (maxLifeSpan - minLifeSpan) + minLifeSpan;
}



/***************************************************************************************************
 *
 *  $DESCRIPTION  Default properties block.
 *
 **************************************************************************************************/

// $END_CLASSIFIED

defaultproperties {
    RemoteRole=ROLE_None
    LifeSpan=1.00
    DrawType=DT_SpriteAnimOnce
    Style=STY_Translucent
    Texture=Texture'SilverTwinkle_a00'
    DrawScale=0.50
    LightType=LT_None
    LightRadius=0
    LightHue=0
    LightBrightness=0
    bCorona=True
}

