/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLFuelPod
 *  $VERSION  1.81
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLFuelpod extends Effects;

var SLFuelcore Core;
var bool bOpen;

function postBeginPlay() {
	core = SLFuelcore(owner);
	
	if (core != none) {
    	setTimer(core.hoverTimer, true);
	}
	super.postBeginPlay();
}

function bool in() {
	local Pawn p;

	if (core != none) {
		foreach RadiusActors(class'Pawn', p, core.hoverRadius) {
			if (validActor(p)) {
				return true;
			}
		}
	}
	
	return false;
}

function timer() {
	if (in()) {
		if (core != none &&  !core.bHover && !core.bHidden && !bOpen) {
			open();
		}
	} else {
		if (core.bHover && !Core.bHidden && bOpen) {
			close();
		}
	}
}

function touchCheck() {
	local Pawn p;

	if (!bOpen && in()) {
		open();
	}
}

function open() {
	bOpen = true;
	playAnim('opening');
	core.startHover();
}

function close() {
	bOpen = false;
	playAnim('closing');
	core.stopHover();
}

function bool validActor(Actor a) {
	//ScriptWarning: (Function SLV202.SLFuelpod.validActor:009F) Accessed None
	//return a.bIsPawn && Pawn(a).bIsPlayer && Pawn(a).health > 0 && !Pawn(a).playerReplicationInfo.bIsSpectator;
	
	//ScriptWarning: (Function SLV202.SLFuelpod.validActor:00AC) Accessed None
	//return a != none && a.bIsPawn && Pawn(a).bIsPlayer && Pawn(a).health > 0 && !Pawn(a).playerReplicationInfo.bIsSpectator;
	
	return a.bIsPawn && Pawn(a).bIsPlayer && Pawn(a).health > 0 && Pawn(a).playerReplicationInfo != none && !Pawn(a).playerReplicationInfo.bIsSpectator;
}

// $END_CLASSIFIED

defaultproperties {
    RemoteRole=ROLE_None
    DrawType=DT_Mesh
    Mesh=SkeletalMesh'SLV2Models.fpod'
}
