/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLInfo
 *  $VERSION  1.10
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLInfo extends Info;

function string getFuncName(string s) {
	local int i;
	
	i = inStr(s, "(");
	return left(s, i);
}

function string sv(Vector v, optional bool bSize) {
	local string size;
	
	if (bSize) {
		size = " vsize=" $ chopf(vsize(v));
	}
	return "(x=" $ chopf(v.x) $ " y=" $ chopf(v.y) $ " z=" $ chopf(v.z) $ size $ ")";
}

function string sr(Rotator r) {
	return "(p=" $ string(r.pitch) $ " y=" $ string(r.yaw) $ " r=" $ string(r.roll) $ ")";
}

function string sf(float f) {
	local string s;
	
	s = string(f);
	while (right(s, 1) == "0") {
		s = left(s, len(S) - 1);
	}
	if (right(s, 1) == ".") {
		s = s $ "0";
	}
	return S;
}

function string chopf(float f, optional int n, optional float nochop) {
	local string s;
	local int i;

	if (abs(f) < nochop) {
		return string(f);
	}
	s = string(f);
	i = inStr(s, ".");
	if (i >= 0) {
		s = left(s, i + 1 + n);
	}
	return s;
}

function string sname(Actor a) {
	if (a != none) {
		if (a.isA('Pawn') && Pawn(A).playerReplicationInfo != none) {
			return Pawn(A).playerReplicationInfo.playerName;
		} else {
			return noMap(a);
		}
	} else {
		return "none";
	}
}

function string noMap(Actor a) {
	local int index;

	index = inStr(string(a), ".");
	if (index == -1) {
		return string(a);
	} else {
		return right(string(a), len(string(a)) - index - 1);
	}
}
// $END_CLASSIFIED
