/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLSmoke
 *  $VERSION  1.12
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLSmoke extends UT_SpriteSmokePuff;

var() bool bRotV;

simulated function beginPlay() {
	local vector dir;

	if (bRotV) {
		dir = vector(rotation);
	} else {
		dir = vect(0.0, 0.0, 1.0);
	}
	
	velocity = dir * risingRate;
	
	if (numSets > 2) {
		texture = ssprites[rand(numSets)];
	}
}
// $END_CLASSIFIED

defaultproperties {
	RisingRate=0.00
	NumSets=0
	RemoteRole=ROLE_None
	Texture=Texture'SLV2Textures.Smoke.bsmoke_a00'
}
