/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLStylus
 *  $VERSION  1.60
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLStylus extends SLInfo;

var Canvas C;
var int xoff;
var int yoff;
var float cx;
var float cy;
var float clipX;
var float clipY;

function bool setCanvas(Canvas newc) {
	local bool resized;
	
	c = newc;
	cx = c.clipX / 2;
	cy = c.clipY / 2;
	resized = clipX != c.clipX;
	clipX = c.clipX;
	clipY = c.clipY;
	
	return resized;
}

function setOffsets(int x, int y) {
	xoff = x;
	yoff = y;
}

function drawFrame(int x, int y, int w, int h, optional int style, optional bool fill, optional bool truexy) {
	local int re;

	if (style == 1) {
		re = w - 2;
	} else {
		re = w - 1;
	}
  
	setPos(x + 1, y, truexy);

	if (style == 4) {
		pix(1, 1);
		setPos(x + w - 1, y, truexy);
		pix(1, 1);
		setPos(x + 1, y + h - 1, truexy);
		pix(1, 1);
		setPos(x + w - 1, y + h - 1, truexy);
		pix(1, 1);
	} else {
		if (style == 2) {
			re--;
		}
		pix(re, 1);
		if (style == 2) {
			re++;
		}
		setPos(x + 1, y + h - 1, truexy);
		if (style == 3) {
			re--;
		}
		pix(re, 1);
	}
  
	SetPos(x, y + 1, truexy);
	
	if (style == 1) {
		re = w;
	} else {
		re = w - 1;
	}
	
	if (fill) {
		pix(re, h - 2);
	} else {
		pix(1, h - 2);
		if (style != 5) {
			setPos(x + re - 1, y + 1, truexy);
			pix(1, h - 2);
		}
	}
}

function pix(int w, int h) {
	c.drawRect(Texture'SLV2Textures.slhud.levelpixel', w, h);
}

function setPos(int x, int y, optional bool truexy) {
	if (truexy) {
		c.setPos(x, y);
	} else {
		c.setPos(x + xoff, y + yoff);
	}
}

function drawText (coerce string text) {
	if (c.curX < c.clipX) {
		c.drawTextClipped(text);
	}
}

function float lineh() {
	local float xl, yl;

	c.TextSize("TEST", xl, yl);
	return yl;
}

function float strw(string s) {
	local float xl, yl;

	c.TextSize(s, xl, yl);
	return xl;
}

function color blendc (color c1, color c2, float x) {
	local color newc;

	if (x > 1.0) {
		x = 1.0;
	}
	newc = c1 * (1.0 - x) + c2 * x;
	return newc;
}
// $END_CLASSIFIED
