/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    SLWallhit
 *  $VERSION  1.10
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class SLWallhit extends UT_WallHit;

var() Class<SLPockmark> pockClass;
var() Class<Effects> puffClass;
var() Class<Effects> chipClass;
var() Class<Effects> sparkClass;

simulated function spawnEffects() {
	local Actor fx;
	local Texture tex;
	local int i;
	local int n;

	spawnSound();
	
	if (level.bDropDetail) {
    	return;
	}
  
	if (level.bHighDetailMode) {
		fx = spawn(pockClass);
	}

	n = rand(maxChips / 2) + maxChips / 2;
	for (i = 0; i < n; i++) {
		if (frand() < chipOdds) {
			fx = spawn(chipClass);
			if (fx != none) {
				fx.remoteRole = ROLE_None;
				fx.drawScale *= 0.75;
				n--;
			}
		}
	}
  
	if (level.bHighDetailMode) {
		if (vector(rotation) dot vect(0.0, 0.0, 1.0) < 0) {
			fx = spawn(puffClass, , , , rotation);
		} else {
			fx = spawn(puffClass, , , , rotator(vect(0.0, 0.0, 1.0)));
		}
		fx.remoteRole = ROLE_None;
	}
}
// $END_CLASSIFIED

defaultproperties {
	pockClass=Class'SLPockmark'
	puffClass=Class'SLHitPuff'
	chipClass=Class'UnrealShare.Chip'
	sparkClass=Class'SLSparker'
	MaxChips=8
	MaxSparks=0
	ChipOdds=1.00
	DrawType=DT_None
}
