/***************************************************************************************************
 *
 *  SLV2. Original version by 0Fus. Maintained since version 2.02 by Zeropoint.
 *
 *  $CLASS    StrangeExpl
 *  $VERSION  1.70
 *  $AUTHOR   Al 'yrns' McElrath        original version
 *            Daan 'Defrost' Scheerens  maintenance
 *  $CONTACT  d.scheerens@gmail.com
 *
 **************************************************************************************************/

// $CLASSIFIED
class StrangeExpl extends AnimSpriteEffect;

var() Texture booms[2];
//var() config bool bNoBlack;

simulated function postBeginPlay() {
	local SLDamagePuff puff;

	super.postBeginPlay();
	
	if (!level.bHighDetailMode) {
		DrawScale = 1.9;
	}
	
	playSound(effectSound1, SLOT_None, 1.0);
	
	drawScale = default.drawScale + frand() * 1.0;
	texture = booms[rand(2)];
	
	/*
	if (!bNoBlack && !level.bDropDetail) {
		puff = spawn(class'SLDamagePuff');
		puff.drawScale = drawScale * 3.0;
	}
	*/
}
// $END_CLASSIFIED

defaultproperties {
    booms(0)=Texture'SLV2Textures.Explo.explo1_a00'
    booms(1)=Texture'SLV2Textures.Explo.explo2_a00'
    EffectSound1=Sound'Botpack.General.Expl04'
    RemoteRole=ROLE_SimulatedProxy
    LifeSpan=0.80
    DrawType=DT_SpriteAnimOnce
    Style=STY_Translucent
    Texture=Texture'SLV2Textures.Explo.explo1_a00'
    DrawScale=2.00
    AmbientGlow=255
    LightEffect=LE_NonIncidence
    LightRadius=12
    bCorona=False
}
